2007-12-30  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* configure.ac, src/vm/jit/Makefile.am, src/vm/jit/ir/Makefile.am,
	src/vm/jit/ir/bytecode.c, src/vm/jit/ir/bytecode.h,
	src/vm/jit/jit.c, src/vm/jit/jit.h, src/vm/jit/parse.c:
	* configure.ac (AC_CONFIG_FILES): Added src/vm/jit/ir/Makefile.

	* src/vm/jit/Makefile.am (DIST_SUBDIRS): Added ir. (SUBDIRS):
	Likewise. (libjit_la_LIBADD): Added ir/libir.la.

	* src/vm/jit/ir/Makefile.am: New file.
	* src/vm/jit/ir/bytecode.c: Likewise.
	* src/vm/jit/ir/bytecode.h: Likewise.

	* src/vm/jit/jit.c (vm/jit/ir/bytecode.h): Added.
	* src/vm/jit/jit.h (vm/jit/ir/bytecode.h): Likewise. Use new BC_*
	constants in the ICMD-enum.

	* src/vm/jit/parse.c (vm/jit/ir/bytecode.h): Added. (parse): Use new
	BC_* constants.
	[d8fe2c3ba284]

2007-12-29  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/mm/memory.c, src/vmcore/system.h:
	* src/vmcore/system.h (system_mprotect): New function.
	[HAVE_SYS_MMAN_H] (sys/mman.h): Added.

	* src/mm/memory.c (vmcore/system.h): Added. (memory_mprotect): Use
	system_mprotect.
	[3c67f686355c]

2007-12-28  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/powerpc/disass.c:
	* src/vm/jit/powerpc/disass.c: Fixed copyright header. (stdint.h):
	Added. (vm/types.h): Removed.
	[4b313b978a51]

2007-12-20  Peter Molnar  <pm@complang.tuwien.ac.at>

	* configure.ac, m4/az_python.m4, src/cacao/Makefile.am,
	src/vm/jit/Makefile.am, src/vm/jit/jit.c, src/vm/jit/python.c,
	src/vm/jit/python.h, src/vm/vm.c:
	* configure.ac: Added tests for python.
	* m4/az_python.m4: New file.
	* src/cacao/Makefile.am src/vm/jit/Makefile.am: [ENABLE_PYTHON]
	Building python module and linking with python libs.
	* src/vm/jit/jit.c [ENABLE_PYTHON] Calling some python function.
	* src/vm/jit/python.c, src/vm/jit/python.h: New files.
	* src/vm/vm.c [ENABLE_PYTHON] Initializing python module.
	[a54c7d83c58a]

2007-12-19  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (JVM_GetManagement): Implemented (only
	returning NULL).
	[4206fab51a24]

	* src/native/native.c, src/native/native.h, src/native/vm/sun/jvm.c:
	* src/native/native.c [ENABLE_LTDL] (native_library_close): New
	function.
	* src/native/native.h: Likewise.

	* src/native/vm/sun/jvm.c (JVM_UnloadLibrary): Implemented.
	[59330b2047b9]

2007-12-16  Stefan Ring  <stefan@complang.tuwien.ac.at>

	* m4/debug.m4, m4/dump.m4:
	* m4/debug.m4: Changed wording to make some defaults less confusing
	(forgot those in previous commit).
	* m4/dump.m4: Likewise.
	[c06d42a7d559]

2007-12-10  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/vm/cldc1.1/java_lang_Throwable.c:
	* src/native/vm/cldc1.1/java_lang_Throwable.c (vm/types.h): Removed.
	(stdint.h): Added. (native/llni.h): Added. (printStackTrace): Use
	new stacktrace functions. (fillInStackTrace): Likewise.
	[ca9ac6d29332]

2007-12-07  Stefan Ring  <stefan@complang.tuwien.ac.at>

	* configure.ac, m4/jit.m4, m4/libjvm.m4, m4/ltdl.m4, m4/zlib.m4:
	* configure.ac: Changed wording to make some defaults less
	confusing.
	* m4/jit.m4: Likewise.
	* m4/libjvm.m4: Likewise.
	* m4/ltdl.m4: Likewise.
	* m4/zlib.m4: Likewise.
	[9ee28b82c23e]

2007-12-05  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/vm/sun/jvm.c, src/vmcore/class.c, src/vmcore/class.h:
	* src/native/vm/sun/jvm.c (JVM_GetEnclosingMethodInfo): Implemented.
	* src/vmcore/class.c (class_get_enclosingmethod): New function.
	* src/vmcore/class.h: Likewise.
	[85ece229beb6]

2007-11-24  Stefan Ring  <stefan@complang.tuwien.ac.at>

	* src/vm/jit/i386/codegen.c, src/vm/jit/i386/emit.c:
	* src/vm/jit/i386/codegen.c (codegen_emit,
	codegen_emit_stub_native): Repaired 16 byte stack alignment.

	* src/vm/jit/i386/emit.c (emit_verbosecall_enter): Likewise.
	[fb2f760c6d47]

2007-11-21  Peter Molnar  <pm@complang.tuwien.ac.at>

	* doc/handbook/cacao.tex, doc/handbook/java.bib,
	doc/handbook/s390.tex:
	* doc/handbook/s390.tex: New file, docs for the s390 port.
	* doc/handbook/cacao.tex, doc/handbook/java.bib: Added support for
	s390.tex.
	[1e17747d8ae4]

2007-11-13  Stefan Ring  <stefan@complang.tuwien.ac.at>

	* src/vm/jit/i386/darwin/md-os.c:
	* src/vm/jit/i386/darwin/md-os.c: Synched with linux version.
	Compiles but doesn't work yet.
	[7a9776c7f769]

2007-11-08  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/codegen-common.c, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/stacktrace.c:
	* src/vm/jit/codegen-common.c (codegen_generate_stub_builtin):
	Unflag leafmethod. (codegen_generate_stub_native): Likewise.

	* src/vm/jit/powerpc64/codegen.c (codegen_emit_stub_native): Added
	leafmethod sanity check.

	* src/vm/jit/stacktrace.c (stacktrace_stackframeinfo_add): Use
	code_is_leafmethod.
	[91f7709c62de]

	* src/vm/jit/m68k/arch.h, src/vm/jit/powerpc64/arch.h,
	src/vm/jit/s390/arch.h:
	* src/vm/jit/m68k/arch.h: Removed commented HAS_4BYTE_STACKSLOT.
	* src/vm/jit/powerpc64/arch.h: Likewise.
	* src/vm/jit/s390/arch.h: Likewise.
	[adc81880df67]

	* src/native/jni.c:
	* src/native/jni.c (TRACEJNICALLS): Don't use a variadic macro but
	pass the text to log in parentheses. This also fixes a bug when
	only one argument is passed.
	[1b6cd680d55a]

	* src/vm/jit/cfg.c, src/vm/jit/cfg.h:
	* src/vm/jit/cfg.c: Fixed copyright header. (vm/types.h): Removed.
	(vm/global.h): Added.
	* src/vm/jit/cfg.h: Likewise.
	[568ba9fdd84b]

2007-11-07  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/jni.c, src/native/vm/gnu/java_lang_VMThrowable.c,
	src/native/vm/gnu/java_security_VMAccessController.c,
	src/native/vm/sun/jvm.c, src/threads/threads-common.c,
	src/vm/jit/stacktrace.c, src/vm/jit/stacktrace.h:
	* src/native/jni.c (_Jv_JNI_FindClass): Renamed
	stacktrace_getCurrentClass to stacktrace_get_current_class.

	* src/native/vm/gnu/java_lang_VMThrowable.c (vm/jit/code.h): Added.
	(vm/jit/linenumbertable.h): Likewise. (fillInStackTrace): Renamed
	stacktrace_fillInStackTrace to stacktrace_get. (getStackTrace):
	Rewritten for new stacktrace code.

	* src/native/vm/gnu/java_security_VMAccessController.c (vm/types.h):
	Removed. (stdint.h): Added. (vm/builtin.h): Removed. (vm/global.h):
	Added. (vmcore/class.h): Removed. (vmcore/options.h): Likewise.
	(vmcore/utf8.h): Added. (getStack): Renamed stacktrace_getStack to
	stacktrace_get_stack.

	* src/native/vm/sun/jvm.c (JVM_FillInStackTrace): Renamed
	stacktrace_fillInStackTrace to stacktrace_get.
	(JVM_GetStackTraceDepth): Rewritten for new stacktrace code and
	added critical section. (JVM_GetStackTraceElement): Rewritten for
	new stacktrace code. (JVM_LatestUserDefinedLoader): Implemented.

	* src/threads/threads-common.c (threads_thread_print_stacktrace):
	Rewritten for new stacktrace code and added critical section.

	* src/vm/jit/stacktrace.c (stacktrace_entry_add): Removed.
	(stacktrace_method_add): Likewise. (stacktrace_stackframeinfo_fill)
	[!NDEBUG]: Added debug output. (stacktrace_stackframeinfo_next):
	Likewise. (stacktrace_stackframeinfo_end_check): Likewise.
	(stacktrace_create): Removed. (stacktrace_fillInStackTrace):
	Removed. (stacktrace_depth): New function. (stacktrace_get):
	Likewise. (stacktrace_first_nonnull_classloader): Likewise.
	(stacktrace_getClassContext): Rewritten.
	(stacktrace_getCurrentClass): Renamed to
	stacktrace_get_current_class and rewritten. (stacktrace_getStack):
	Renamed to stacktrace_get_stack and rewritten.
	(stacktrace_print_trace_from_buffer): Renamed to stacktrace_print
	and rewritten. (stacktrace_print_exception): Rewritten.

	* src/vm/jit/stacktrace.h (stacktracebuffer): Removed.
	(stacktrace_entry): Likewise. (stacktrace_t): New structure.
	(stacktrace_entry_t): Likewise.
	[6ca3d885a0c3]

2007-11-07  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/i386/linux/md-os.c:
	* src/vm/jit/i386/linux/md-os.c (md_replace_executionstate_read):
	Implemented. (md_replace_executionstate_write): Likewise.
	[be521f46a80f]

2007-11-06  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (JVM_FillInStackTrace): Use LLNI macro.
	(JVM_GetStackTraceDepth): Likewise and added a comment about missing
	critical sections. (JVM_GetStackTraceElement): Likewise.
	[3d10f5692560]

2007-11-05  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/Makefile.am, src/vm/jit/alpha/asmpart.S,
	src/vm/jit/alpha/linux/md-os.c, src/vm/jit/alpha/md.c,
	src/vm/jit/alpha/md.h, src/vm/jit/alpha/patcher.c,
	src/vm/jit/arm/asmpart.S, src/vm/jit/arm/codegen.c,
	src/vm/jit/arm/md.c, src/vm/jit/arm/md.h, src/vm/jit/arm/patcher.c,
	src/vm/jit/asmpart.h, src/vm/jit/codegen-common.c, src/vm/jit
	/codegen-common.h, src/vm/jit/i386/linux/md-os.c,
	src/vm/jit/i386/md.c, src/vm/jit/i386/md.h, src/vm/jit/jit.c,
	src/vm/jit/m68k/asmpart.S, src/vm/jit/m68k/codegen.c,
	src/vm/jit/m68k/md.c, src/vm/jit/m68k/md.h,
	src/vm/jit/m68k/patcher.c, src/vm/jit/md.h,
	src/vm/jit/mips/asmpart.S, src/vm/jit/mips/codegen.c,
	src/vm/jit/mips/linux/md-os.c, src/vm/jit/mips/md.c,
	src/vm/jit/mips/md.h, src/vm/jit/mips/patcher.c, src/vm/jit/patcher-
	common.c, src/vm/jit/powerpc/asmpart.S,
	src/vm/jit/powerpc/codegen.c, src/vm/jit/powerpc/darwin/md-asm.h,
	src/vm/jit/powerpc/linux/md-os.c, src/vm/jit/powerpc/md.c,
	src/vm/jit/powerpc/md.h, src/vm/jit/powerpc/patcher.c,
	src/vm/jit/powerpc64/asmpart.S, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/powerpc64/linux/md-os.c, src/vm/jit/powerpc64/md.c,
	src/vm/jit/powerpc64/md.h, src/vm/jit/powerpc64/patcher.c,
	src/vm/jit/replace.c, src/vm/jit/s390/md.c, src/vm/jit/s390/md.h,
	src/vm/jit/sparc64/md.c, src/vm/jit/sparc64/md.h,
	src/vm/jit/sparc64/patcher.c, src/vm/jit/stacktrace.c,
	src/vm/jit/stacktrace.h, src/vm/jit/x86_64/linux/md-os.c,
	src/vm/jit/x86_64/md.c, src/vm/jit/x86_64/md.h:
	* src/vm/jit/md.h: Removed.
	* src/vm/jit/Makefile.am (noinst_HEADERS): Removed md.h.

	* src/vm/jit/asmpart.h (md_asm_codegen_get_pv_from_pc): Added
	temporarily.

	* src/vm/jit/codegen-common.c (md.h): Added. (vm/jit/md.h): Removed.
	(md_asm_codegen_get_pv_from_pc): Added temporarily.

	* src/vm/jit/codegen-common.h (md_codegen_get_pv_from_pc): Removed.

	* src/vm/jit/jit.c (stdint.h): Added. (md.h): Likewise.

	* src/vm/jit/patcher-common.c (md.h): Added. (vm/jit/md.h): Removed.
	* src/vm/jit/replace.c: Likewise.

	* src/vm/jit/stacktrace.c (md.h): Added.
	* src/vm/jit/stacktrace.h (md_stacktrace_get_returnaddress): Removed.

	* src/vm/jit/alpha/asmpart.S, src/vm/jit/alpha/linux/md-os.c,
	src/vm/jit/alpha/md.c, src/vm/jit/alpha/md.h,
	src/vm/jit/alpha/patcher.c, src/vm/jit/arm/asmpart.S,
	src/vm/jit/arm/codegen.c, src/vm/jit/arm/md.c, src/vm/jit/arm/md.h,
	src/vm/jit/arm/patcher.c, src/vm/jit/i386/linux/md-os.c,
	src/vm/jit/i386/md.c, src/vm/jit/i386/md.h,
	src/vm/jit/m68k/asmpart.S, src/vm/jit/m68k/codegen.c,
	src/vm/jit/m68k/md.c, src/vm/jit/m68k/md.h,
	src/vm/jit/m68k/patcher.c, src/vm/jit/mips/asmpart.S,
	src/vm/jit/mips/codegen.c, src/vm/jit/mips/linux/md-os.c,
	src/vm/jit/mips/md.c, src/vm/jit/mips/md.h,
	src/vm/jit/mips/patcher.c, src/vm/jit/powerpc/asmpart.S,
	src/vm/jit/powerpc/codegen.c, src/vm/jit/powerpc/darwin/md-asm.h,
	src/vm/jit/powerpc/linux/md-os.c, src/vm/jit/powerpc/md.c,
	src/vm/jit/powerpc/md.h, src/vm/jit/powerpc/patcher.c,
	src/vm/jit/powerpc64/asmpart.S, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/powerpc64/linux/md-os.c, src/vm/jit/powerpc64/md.c,
	src/vm/jit/powerpc64/md.h, src/vm/jit/powerpc64/patcher.c,
	src/vm/jit/s390/md.c, src/vm/jit/s390/md.h, src/vm/jit/sparc64/md.c,
	src/vm/jit/sparc64/md.h, src/vm/jit/sparc64/patcher.c,
	src/vm/jit/x86_64/linux/md-os.c, src/vm/jit/x86_64/md.c,
	src/vm/jit/x86_64/md.h (md_stacktrace_get_returnaddress): Made
	inline function. (md_codegen_get_pv_from_pc): Likewise.
	(md_cacheflush): Likewise. (md_icacheflush): Likewise.
	(md_dcacheflush): Likewise.
	[d81d9dc006c9]

	* src/vm/jit/s390/patcher.c:
	* src/vm/jit/s390/patcher.c: Fixed header.
	[60fd68b8284c]

2007-10-27  Peter Molnar  <pm@complang.tuwien.ac.at>

	* src/vm/jit/linenumbertable.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/s390/md.c:
	* src/vm/jit/linenumbertable.c (linenumbertable_create,
	linenumbertable_linenumber_for_pc_intern) [__S390__]: Use 31 bits of
	addresses as lookup keys.
	* src/vm/jit/s390/codegen.c (codegen_emit_stub_native): In case of
	exception, use branch (not following) instruction as XPC.
	* src/vm/jit/s390/md.c (md_signal_handler_sigill): Fixes to scenario
	where JIT compiler fails.
	[1a453b2390aa]

2007-10-27  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/code.c, src/vm/jit/code.h:
	* src/vm/jit/code.c (vm/jit/methodheader.h): Removed.
	(code_get_codeinfo_for_pv): Likewise.

	* src/vm/jit/code.h (assert.h): Added. (vm/jit/methodheader.h):
	Likewise. (code_get_codeinfo_for_pv): New function.
	[c3b950a4ea8b]

	* src/vm/jit/codegen-common.c:
	* src/vm/jit/codegen-common.c (vm/jit/code.h): Added.
	(codegen_finish_native_call): Use code_get_codeinfo_for_pv.
	[18a312bfca4b]

2007-10-26  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/vm.c:
	* src/vm/vm.c (vm_create): Removed codegen_init call, jit_init does
	that.
	[c5a79c1e4123]

	* src/vm/jit/arm/codegen.c:
	* src/vm/jit/arm/codegen.c (codegen_emit_stub_native): Removed
	emit_patcher_traps call.
	[704dd3fd06bd]

	* src/vm/jit/s390/codegen.c:
	* src/vm/jit/s390/codegen.c (codegen_emit_stub_native): Removed
	patcher stuff.
	[4b58514e5dab]

	* src/vm/jit/i386/codegen.c:
	* src/vm/jit/i386/codegen.c (codegen_emit_stub_native): Removed
	patcher stuff.
	[0d991b1b2a50]

	* src/vm/jit/alpha/codegen.c:
	* src/vm/jit/alpha/codegen.c (codegen_emit_stub_native): Removed
	patcher stuff.
	[5ed32ddf5dcb]

2007-10-25  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/mips/linux/md-os.c:
	* src/vm/jit/mips/linux/md-os.c (vm/jit/md.h): Removed (accidentally
	commited). (md_signal_handler_sigsegv): Removed some code.
	[279a6a754037]

	* src/vm/jit/mips/arch.h, src/vm/jit/mips/asmpart.S,
	src/vm/jit/mips/codegen.c, src/vm/jit/mips/codegen.h,
	src/vm/jit/mips/emit.c, src/vm/jit/mips/linux/md-os.c:
	* src/vm/jit/mips/arch.h (JIT_COMPILER_VIA_SIGNAL): Temporarily
	added.

	* src/vm/jit/mips/asmpart.S (asm_call_jit_compiler): Removed.
	* src/vm/jit/mips/codegen.c (codegen_emit_stub_compiler): Likewise.

	* src/vm/jit/mips/codegen.h (COMPILERSTUB_CODESIZE): Adapted size.

	* src/vm/jit/mips/emit.c (emit_trap_compiler): New function.

	* src/vm/jit/mips/linux/md-os.c (vm/exceptions.h): Added.
	(md_signal_handler_sigsegv): Added compiler-by-signals code.
	[3e911e512e84]

	* src/vm/jit/alpha/md.c:
	* src/vm/jit/alpha/md.c (md_init): Smaller changes.
	(md_codegen_get_pv_from_pc): Rewritten.
	[8484b2af9cb0]

	* src/vm/jit/jit.c, src/vm/jit/jit.h, src/vm/jit/md.h, src/vm/vm.c:
	* src/vm/jit/jit.c (vm/jit/md.h): Removed. (jit_init): Call md_init.

	* src/vm/jit/jit.h [ENABLE_JIT] (md_init): Added. [ENABLE_INTRP]
	(intrp_md_init): Likewise.

	* src/vm/jit/md.h [ENABLE_JIT] (md_init): Removed. [ENABLE_INTRP]
	(intrp_md_init): Likewise.

	* src/vm/vm.c (vm/jit/md.h): Removed. (vm_create): Don't call
	md_init.
	[86d5f80749fa]

	* src/vm/primitive.c, src/vm/signal.c:
	* src/vm/primitive.c (primitive_box): Fixed -O2 wanrings.
	* src/vm/signal.c (signal_handle): Likewise.
	[e7c1d45ac1cb]

	* src/native/include/Makefile.am:
	* src/native/include/Makefile.am (COMMON_HEADER_FILES): Removed
	java_util_HashMap and java_util_Map. (JAVASE_HEADER_FILES): Added
	java_util_HashMap and java_util_Map.
	[775bed4b55e1]

2007-10-24  Peter Molnar  <pm@complang.tuwien.ac.at>

	* src/vm/jit/s390/arch.h, src/vm/jit/s390/asmpart.S,
	src/vm/jit/s390/codegen.c, src/vm/jit/s390/emit.c,
	src/vm/jit/s390/md.c:
	* src/vm/jit/s390/arch.h (JIT_COMPILER_VIA_SIGNAL): defined.
	* src/vm/jit/s390/asmpart.S (asm_call_jit_compiler): removed.
	* src/vm/jit/s390/codegen.c (codegen_emit_stub_compiler): removed.
	* src/vm/jit/s390/emit.c (emit_trap_compiler): new function.
	* src/vm/jit/s390/md.c (md_signal_handler_sigill): adapted for
	compiler call via signal.
	[c49cadfbd476]

2007-10-24  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/exceptions.c, src/vm/jit/stacktrace.c,
	src/vm/jit/stacktrace.h:
	* src/vm/jit/stacktrace.c (stacktrace_print_trace): Renamed to
	stacktrace_print_exception.
	* src/vm/jit/stacktrace.h: Likewise.

	* src/vm/exceptions.c (exceptions_handle_exception): Likewise.
	[8bc0a90cd4f0]

	* src/native/vm/gnu/java_lang_VMThrowable.c:
	* src/native/vm/gnu/java_lang_VMThrowable.c (getStackTrace): Removed
	unused resolving of the init method.
	[d9b947897586]

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (JVM_FillInStackTrace): Use TRACEJVMCALLS.
	(JVM_GetStackTraceElement): Likewise. (JVM_IHashCode): Likewise.
	[369b6cfa58a6]

	* src/vm/jit/stacktrace.c:
	* src/vm/jit/stacktrace.c (stacktrace_stackframeinfo_fill): New
	function. (stacktrace_stack_walk): Renamed to
	stacktrace_stackframeinfo_next.
	(stacktrace_stackframeinfo_end_check): New function.
	(stacktrace_create): Use new stackframeinfo functions.
	[111e59248e76]

	* src/native/include/Makefile.am:
	* src/native/include/Makefile.am [ENABLE_ANNOTATIONS]
	(JAVASE_HEADER_FILES): Removed java_util_Map.h.
	[d5242eb43dbf]

2007-10-23  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vmcore/linker.c:
	* src/vmcore/linker.c (linker_preinit): Define
	LINKER_ALIGNMENT_LONG_DOUBLE. (link_class_intern): Added a compile
	time check for LINKER_ALIGNMENT_LONG_DOUBLE.
	[c8300b439942]

	* src/native/vm/gnu/java_lang_VMThread.c,
	src/native/vm/java_lang_Thread.c, src/native/vm/java_lang_Thread.h:
	* src/native/vm/java_lang_Thread.c (interrupt): Removed.
	* src/native/vm/java_lang_Thread.h: Likewise.

	* src/native/vm/gnu/java_lang_VMThread.c (interrupt): Use
	threads_thread_interrupt.
	[9921ebdac86b]

	* src/vm/jit/argument.c:
	* src/vm/jit/argument.c (argument_vmarray_from_jvalue): Fixed
	warning when compiling with Sun's jni.h.
	[9e21a19e371f]

2007-10-22  Gregor Kaufmann  <tdn@inode.at>

	* configure.ac, m4/assertion.m4,
	src/lib/gnu/java/lang/VMClassLoader.java,
	src/native/include/Makefile.am, src/native/jni.h,
	src/native/vm/gnu/java_lang_VMClassLoader.c,
	src/native/vm/sun/jvm.c, src/vm/Makefile.am, src/vm/assertion.c,
	src/vm/assertion.h, src/vm/vm.c, src/vmcore/class.c,
	src/vmcore/class.h, src/vmcore/linker.c, src/vmcore/loader.c:
	* configure.ac (AC_CHECK_ENABLE_ASSERTION): Added

	* src/lib/gnu/java/lang/VMClassLoader.java
	(packageAssertionStatus0): New function (classAssertionStatus0):
	Likewise (defaultUserAssertionStatus): Likewise
	(defaultAssertionStatus): Implemented (packageAssertionStatus):
	Likewise (classAssertionStatus): Likewise

	* src/native/include/Makefile.am (COMMON_HEADER_FILES): Added
	java_util_HashMap.h, java_util_Map.h

	* /src/native/jni.h
	(_Jv_JavaVM->Java_java_lang_VMClassLoader_defaultAssertionStatus):
	Removed

	* src/native/vm/gnu/java_lang_VMClassLoader.c
	(native/include/java_util_HashMap.h): Added
	(native/include/java_util_Map.h): Likewise
	(native/include/java_lang_Boolean.h): Likewise (toolbox/list.h):
	Likewise (vm/assertion.h): Likewise (methods): Added information for
	defaultUserAssertionStatus, packageAssertionStatus0,
	classAssertionStatus0
	(Java_java_lang_VMClassLoader_defaultAssertionStatus): Implemented
	(Java_java_lang_VMClassLoader_defaultUserAssertionStatus): New
	function (Java_java_lang_VMClassLoader_packageAssertionStatus0):
	Likewise (Java_java_lang_VMClassLoader_classAssertionStatus0):
	Likewise

	* src/native/vm/sun/jvm.c (toolbox/list.h): Added (vm/assertion.h):
	Likewise (JVM_DesiredAssertionStatus): Implemented
	(JVM_AssertionStatusDirectives): Now returns a usable
	java.lang.AssertionStatusDirectives object

	* src/vm/Makefile.am (libvm_la_SOURCES): Added assertion.c,
	assertion.h

	* src/vm/vm.c (vm/assertion.h): Added (OPT_EA, OPT_DA, OPT_ESA,
	OPT_DSA): Now handled by assertion module

	* src/vmcore/class.c (class_java_util_HashMap): Added

	* src/vmcore/class.h (class_java_util_HashMap): Added

	* src/vmcore/linker.c (linker_init): Added linking of
	class_java_util_HashMap

	* src/vmcore/loader.c (loader_init): Added loading of
	class_java_util_HashMap

	* m4/assertion.m4: New file

	* src/vm/assertion.c: New file

	* src/vm/assertion.h: New file
	[dfc311608cdb]

2007-10-22  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/exceptions.c:
	* src/vm/exceptions.c (unistd.h): Removed.
	[c55e286b6453]

	* src/vm/exceptions.c:
	* src/vm/exceptions.c (vmcore/system.h): Added. (exceptions_init):
	Use system_getpagesize and system_mmap_anonymous.
	[87916090c0dd]

	* src/vm/exceptions.c:
	* src/vm/exceptions.c (exceptions_handle_exception): Changed
	signature to use void*.
	[0787c3ba398d]

	* src/vm/jit/show.c:
	* src/vm/jit/show.c (stdint.h): Added. (SHOW_INT_CONST): Fixed
	compiler warnings.
	[cf051a1d440f]

	* src/vm/jit/show.c:
	* src/vm/jit/show.c (show_basicblock): Pass correct arguments to
	linenumbertable_linenumber_for_pc.
	[5a06e321fc5b]

2007-10-22  Roland Lezuo  <tbfg@complang.tuwien.ac.at>

	* src/vm/jit/m68k/emit.c, src/vm/jit/m68k/linux/md-os.c,
	src/vm/jit/m68k/patcher.c:
	* changed src/vm/jit/m68k/emit.c (builtin_verbosecall_exit): Use
	trace_java_call_exit.

	* changed src/vm/jit/m68k/linux/md-os.c (emit_trap): Fixed a bug.

	* changed src/vm/jit/m68k/patcher.c (md_signal_handler_sigill): Bug.
	(PATCH_BACK_ORIGINAL_MCODE): Bug.
	[6b8e93fdc96b]

	* src/vm/jit/m68k/asmpart.S, src/vm/jit/m68k/codegen.c,
	src/vm/system.c, src/vm/system.h:
	* changed src/vm/jit/m68k/asmpart.S: Removed unused method header
	entries.

	* changed src/vm/jit/m68k/codegen.c (codegen_emit): New
	linenumbertables code.
	[c76ff711720f]

	* src/vm/jit/m68k/arch.h, src/vm/jit/m68k/asmpart.S,
	src/vm/jit/m68k/codegen.c, src/vm/jit/m68k/emit.c,
	src/vm/jit/m68k/linux/md-abi.c, src/vm/jit/m68k/linux/md-os.c,
	src/vm/jit/m68k/linux/md-os.h, src/vm/jit/m68k/md.c,
	src/vm/signal.c, src/vm/signallocal.h, src/vmcore/linker.c:
	* changed src/vm/jit/m68k/arch.h (JIT_COMPILER_VIA_SIGNAL): Added.

	* changed src/vm/jit/m68k/asmpart.S (asm_call_jit_compiler):
	Removed.

	* changed src/vm/jit/m68k/codegen.c (codegen_emit): All
	codegen_addpatchref replaced by patcher_add_patch_ref.

	(codegen_emit_stub_native): Use 8 byte stack slots.

	* changed src/vm/jit/m68k/emit.c (emit_verbosecall_enter): New
	tracer. (emit_trap_compiler): Added. (emit_trap): Likewise.

	* changed src/vm/jit/m68k/linux/md-abi.c (md_param_alloc): Use 8
	byte stackslots.

	* changed src/vm/jit/m68k/linux/md-os.c (md_init_linux): Removed.
	(md_signal_handler_sigsegv): Support for patchers and compiler via
	signal added.

	* changed src/vm/jit/m68k/linux/md-os.h (md_init_linux): Removed.

	* changed src/vm/jit/m68k/md.c (md_init): Call to md_init_linux
	removed.

	* changed src/vm/signal.c (signal_init): Register sigill for M68K.

	* changed src/vm/signallocal.h (md_signal_handler_sigill): Enabled
	for M68K.

	* changed src/vmcore/linker.c (link_class_intern): Enable long 4
	byte alignment.
	[a1dc04786217]

2007-10-22  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/threads/none/threads.h:
	* src/threads/none/threads.h (stackframeinfo): Removed.
	(_no_threads_stackframeinfo): Likewise.
	[267fff05a72b]

	* src/vm/jit/show.c:
	* src/vm/jit/show.c (show_basicblock): Forgot to use
	linenumbertable_linenumber_for_pc.
	[b24a7f31a843]

	* src/vm/jit/jit.c:
	* src/vm/jit/jit.c (jit_jitdata_new) [!ENABLE_THREADS]: Fixed
	compilation.
	[a8d348dbea79]

	* src/vm/jit/trace.c:
	* src/vm/jit/trace.c (trace_java_call_enter): Removed unused
	variable.
	[4e2ba2f7e85d]

	* src/vm/jit/linenumbertable.c, src/vmcore/statistics.c,
	src/vmcore/statistics.h:
	* src/vmcore/statistics.c (count_linenumbertable): New variable.
	(size_linenumbertable): Likewise. (statistics_print_memory_usage):
	Adapted.
	* src/vmcore/statistics.h: Likewise.

	* src/vm/jit/linenumbertable.c [ENABLE_STATISTICS]
	(vmcore/options.h): Added [ENABLE_STATISTICS] (vmcore/statistics.h):
	Likewise. (linenumbertable_create) [ENABLE_STATISTICS]: Added
	statistics calculation.
	[6727b0adf84a]

	* src/vm/jit/Makefile.am, src/vm/jit/alpha/asmpart.S,
	src/vm/jit/alpha/codegen.c, src/vm/jit/arm/asmpart.S,
	src/vm/jit/arm/codegen.c, src/vm/jit/code.h, src/vm/jit/codegen-
	common.c, src/vm/jit/codegen-common.h, src/vm/jit/dseg.c,
	src/vm/jit/dseg.h, src/vm/jit/i386/asmpart.S,
	src/vm/jit/i386/codegen.c, src/vm/jit/linenumbertable.c,
	src/vm/jit/linenumbertable.h, src/vm/jit/m68k/asmpart.S,
	src/vm/jit/m68k/codegen.c, src/vm/jit/methodheader.h,
	src/vm/jit/mips/asmpart.S, src/vm/jit/mips/codegen.c,
	src/vm/jit/powerpc/asmpart.S, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/asmpart.S, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/s390/asmpart.S, src/vm/jit/s390/codegen.c,
	src/vm/jit/sparc64/asmpart.S, src/vm/jit/sparc64/codegen.c,
	src/vm/jit/stacktrace.c, src/vm/jit/x86_64/asmpart.S,
	src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/linenumbertable.c: New file.
	* src/vm/jit/linenumbertable.h: Likewise.
	* src/vm/jit/Makefile.am (libjit_la_SOURCES): Added
	linenumbertable.[ch].

	* src/vm/jit/code.h (vm/jit/linenumbertable.h): Added. (codeinfo):
	Added linenumbertable.

	* src/vm/jit/codegen-common.c (vm/jit/linenumbertable.h): Added.
	(codegen_setup): Create linenumbers list. (codegen_reset): Likewise.
	(codegen_finish): Removed old linenumber-resolving code and call
	linenumbertable_create instead.

	* src/vm/jit/codegen-common.h (codegendata): Removed
	linenumberreferences, linenumbertablesizepos,
	linenumbertablestartpos, linenumbertab, added linenumbers.

	* src/vm/jit/dseg.c (dseg_addlinenumbertablesize): Removed.
	(dseg_addlinenumber): Likewise. (dseg_addlinenumber_inline_start):
	Likewise. (dseg_addlinenumber_inline_end): Likewise.
	(dseg_createlinenumbertable): Likewise.
	(dseg_get_linenumber_from_pc_intern): Likewise.
	(dseg_get_linenumber_from_pc): Likewise.

	* src/vm/jit/dseg.h: Likewise (linenumbertable_entry): Removed.

	* src/vm/jit/methodheader.h (LineNumberTableSize)
	(LineNumberTableStart): Removed.

	* src/vm/jit/stacktrace.c (vm/jit/linenumbertable.h): Added.
	(stacktrace_method_add): Renamed dseg_get_linenumber_from_pc to
	linenumbertable_linenumber_for_pc.

	* src/vm/jit/alpha/asmpart.S, src/vm/jit/arm/asmpart.S,
	src/vm/jit/i386/asmpart.S, src/vm/jit/m68k/asmpart.S,
	src/vm/jit/mips/asmpart.S, src/vm/jit/powerpc/asmpart.S,
	src/vm/jit/powerpc64/asmpart.S, src/vm/jit/s390/asmpart.S,
	src/vm/jit/sparc64/asmpart.S, src/vm/jit/x86_64/asmpart.S
	(asm_vm_call_method): Removed obsolete method-header entries.

	* src/vm/jit/alpha/codegen.c, src/vm/jit/arm/codegen.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/m68k/codegen.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/x86_64/codegen.c
	(vm/jit/linenumbertable.h): Added. (codegen_emit): Removed
	dseg_addlinenumbertablesize call, use new linenumbertable functions,
	removed dseg_createlinenumbertable. (codegen_emit_stub_native):
	Removed obsolete method-header entries.
	[d992be0f02d6]

	* src/vm/jit/arm/codegen.c:
	* src/vm/jit/arm/codegen.c (codegen_emit): Moved ICMD_POP and
	ICMD_POP2 to ICMD_NOP case.
	[093ed0794c43]

	* src/vm/array.c, src/vm/array.h:
	* src/vm/array.c: Changed copyright.
	* src/vm/array.h: Likewise.
	[9b71c7a705e9]

2007-10-20  Peter Molnar  <pm@complang.tuwien.ac.at>

	* src/vm/jit/s390/codegen.c, src/vm/jit/s390/disass.c,
	src/vm/jit/s390/md.c:
	* src/vm/jit/s390/codegen.c, src/vm/jit/s390/disass.c,
	src/vm/jit/s390/md.c: Fixed compile warnings.
	[2a39b1f8c18d]

2007-10-19  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/x86_64/md-abi.c:
	* src/vm/jit/x86_64/md-abi.c (abi_registers_integer_saved): Fixed
	severe typo.
	[f3c3d927ba54]

2007-10-19  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/properties.c:
	* src/vm/properties.c (properties_set) [ENABLE_JAVASE &&
	WITH_CLASSPATH_GNU]: Fixed endorseddirs length.
	[fba8f04fd91f]

2007-10-18  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* configure.ac, src/vmcore/system.c, src/vmcore/system.h:
	* configure.ac (AC_CHECK_HEADERS): Added assert.h, errno.h.
	(AC_CHECK_FUNCS): Added memcpy, memset, realloc.

	* src/vmcore/system.c (errno.h): Added. (stdint.h): Likewise.
	(string.h): Likewise. (unistd.h): Likewise. (sys/mman.h): Likewise.
	(system_mmap_anonymous): New function.

	* src/vmcore/system.h (stdint.h): Added. (stdlib.h): Likewise.
	(string.h): Likewise. (unistd.h): Likewise. (system_calloc): New
	function. (system_free): Likewise. (system_getpagesize): Likewise.
	(system_malloc): Likewise. (system_memcpy): Likewise.
	(system_memset): Likewise. (system_realloc): Likewise.
	(system_mmap_anonymous): Likewise.
	[cfa50d0a150e]

2007-10-18  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/threads/threads-common.c:
	* src/threads/threads-common.c (threads_dump): Ignore NEW threads
	while dumping.
	[65dc1b64848f]

2007-10-18  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/vm/gnu/java_lang_VMRuntime.c, src/native/vm/sun/jvm.c,
	src/vm/Makefile.am, src/vm/system.c, src/vm/system.h,
	src/vmcore/Makefile.am, src/vmcore/system.c, src/vmcore/system.h:
	* src/vm/system.c: Removed.
	* src/vm/system.h: Likewise.
	* src/vm/Makefile.am (libvm_la_SOURCES): Removed system.[ch].

	* src/vmcore/system.c: Added.
	* src/vmcore/system.h: Likewise.
	* src/vmcore/Makefile.am (libvmcore_la_SOURCES): Added system.[ch].

	* src/native/vm/gnu/java_lang_VMRuntime.c (vm/system.h): Renamed to
	vmcore/system.h.
	* src/native/vm/sun/jvm.c: Likewise.
	[28c2716784ad]

2007-10-18  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/exceptions.c:
	* src/vm/exceptions.c (exceptions_handle_exception): Use LLNI macro
	for unlocking synchronized methods during stack unwinding.
	[6bd290291ff9]

	* src/vm/builtin.c, src/vm/builtin.h, src/vm/jit/alpha/linux/md-os.c,
	src/vm/jit/i386/linux/md-os.c, src/vm/jit/powerpc/darwin/md-os.c,
	src/vm/jit/powerpc/linux/md-os.c, src/vm/jit/powerpc64/linux/md-
	os.c, src/vm/jit/x86_64/linux/md-os.c:
	* src/vm/builtin.h (builtin_retrieve_exception): Added prototype.
	* src/vm/builtin.c (builtin_retrieve_exception): Implemented.

	* src/vm/jit/alpha/linux/md-os.c (md_signal_handler_sigsegv): Use
	above builtin.
	* src/vm/jit/i386/linux/md-os.c,
	* src/vm/jit/powerpc/darwin/md-os.c,
	* src/vm/jit/powerpc/linux/md-os.c,
	* src/vm/jit/powerpc64/linux/md-os.c,
	* src/vm/jit/x86_64/linux/md-os.c: Likewise.
	[20827c0dbb8e]

2007-10-18  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* * Merged with 5c4efabb7787.
	[4e1e7758b87a]

2007-10-14  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/dseg.h:
	* src/vm/jit/dseg.h (dseg_exception_entry): Removed.
	[35647a987380]

2007-10-18  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/replace.c:
	* src/vm/jit/replace.c (replace_create_replacement_points): Removed
	bogus flag tampering of codeinfo.
	[5c4efabb7787]

2007-10-17  Roland Lezuo  <tbfg@complang.tuwien.ac.at>

	* src/vm/jit/m68k/asmpart.S, src/vm/jit/m68k/codegen.c,
	src/vm/jit/m68k/emit.c, src/vm/jit/m68k/patcher.c, src/vm/jit
	/patcher-common.h, src/vmcore/linker.c:
	* changed src/vm/jit/m68k/asmpart.S (asm_patcher_wrapper): Removed.
	* changed src/vm/jit/m68k/codegen.c (patcher.h): Include removed.
	(emit_codegen): Replaced emit_patcher_stubs by emit_patcher_trap.
	(codegen_emit_stub_native): Likewise.

	* changed src/vm/jit/m68k/emit.c (emit_patcher_stubs): Removed.

	* changed src/vm/jit/m68k/patcher.c
	(patcher_resolve_classref_to_classinfo): Ported to new patcher
	signature.

	* changed src/vm/jit/patcher-common.h: Enabled new patchers for
	__M68K__.

	* changed src/vmcore/linker.c (linker_preinit): __M68K__ has 4 byte
	long alignment.
	[b1e5181f9e58]

2007-10-17  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/properties.c:
	* src/vm/properties.c (properties_set) [ENABLE_JAVASE &&
	WITH_CLASSPATH_SUN]: Set java.ext.dirs and java.ext.endorsed
	properly.
	[455021c09495]

2007-10-14  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/intrp/codegen.c:
	* src/vm/jit/intrp/codegen.c (intrp_codegen): Ported methodheader
	changes (IsSync, exception table).
	[b19e41db4eca]

	* src/native/vm/gnu/java_lang_VMThrowable.c, src/native/vm/sun/jvm.c,
	src/vm/jit/stacktrace.c:
	* src/vm/jit/stacktrace.c (stacktrace_stack_walk): Changed return
	type to bool, fill the temporary stackframe info with the values
	from the stackframe info chain, if available. (stacktrace_create):
	Don't include fillInStackTrace and init methods in the trace (as
	HotSpot does).

	* src/native/vm/gnu/java_lang_VMThrowable.c (getStackTrace): Removed
	fillInStackTrace and init checks.

	* src/native/vm/sun/jvm.c (JVM_GetStackTraceDepth): Use
	TRACEJVMCALLS, check for NPE, check if backtrace is NULL.
	[e2c1b1f539de]

	* src/vm/system.c, src/vm/system.h:
	* src/vm/system.c: Changed copyright to CACAOVM.
	* src/vm/system.h: Likewise.
	[5db6925c6843]

	* src/vm/jit/powerpc/codegen.c:
	* src/vm/jit/powerpc/codegen.c (codegen_emit): Removed unused
	variable ex.
	[1a1bf81aba73]

	* src/vm/exceptions.c, src/vm/jit/Makefile.am,
	src/vm/jit/alpha/asmpart.S, src/vm/jit/alpha/codegen.c,
	src/vm/jit/arm/asmpart.S, src/vm/jit/arm/codegen.c,
	src/vm/jit/code.h, src/vm/jit/codegen-common.c, src/vm/jit/dseg.c,
	src/vm/jit/exceptiontable.c, src/vm/jit/exceptiontable.h,
	src/vm/jit/i386/asmpart.S, src/vm/jit/i386/codegen.c,
	src/vm/jit/m68k/asmpart.S, src/vm/jit/m68k/codegen.c,
	src/vm/jit/methodheader.h, src/vm/jit/mips/asmpart.S,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/asmpart.S,
	src/vm/jit/powerpc/codegen.c, src/vm/jit/powerpc64/asmpart.S,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/s390/asmpart.S,
	src/vm/jit/s390/codegen.c, src/vm/jit/sparc64/asmpart.S,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/x86_64/asmpart.S,
	src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/exceptiontable.c: New file.
	* src/vm/jit/exceptiontable.h: Likewise.

	* src/vm/jit/Makefile.am (libjit_la_SOURCES): Added
	exceptiontable.[ch].

	* src/vm/exceptions.c (exceptions_handle_exception): Use new
	exception table.

	* src/vm/jit/code.h (vm/jit/exceptiontable.h): Added. (codeinfo):
	Added exceptiontable.

	* src/vm/jit/codegen-common.c (codegen_finish): Call
	exceptiontable_create.

	* src/vm/jit/dseg.c (dseg_addlinenumbertablesize): Removed padding.

	* src/vm/jit/methodheader.h (ExTableSize, ExTableStart): Removed.

	* src/vm/jit/alpha/asmpart.S, src/vm/jit/arm/asmpart.S,
	src/vm/jit/i386/asmpart.S, src/vm/jit/m68k/asmpart.S,
	src/vm/jit/mips/asmpart.S, src/vm/jit/powerpc/asmpart.S,
	src/vm/jit/powerpc64/asmpart.S, src/vm/jit/s390/asmpart.S,
	src/vm/jit/sparc64/asmpart.S, src/vm/jit/x86_64/asmpart.S
	(asm_vm_call_method): Removed exception table stuff.

	* src/vm/jit/alpha/codegen.c, src/vm/jit/arm/codegen.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/m68k/codegen.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/x86_64/codegen.c
	(codegen_emit): Likewise.
	[33a0fdfa4121]

2007-10-13  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/codegen-common.c:
	* src/vm/jit/codegen-common.c (codegen_generate_stub_builtin): Use
	jit_jitdata_new, this is more safe. (codegen_generate_stub_native):
	Likewise.
	[cd5057db2ddd]

	* src/vm/exceptions.c:
	* src/vm/exceptions.c (exceptions_handle_exception): Handle the
	asm_vm_call_method special case outside the loop checking for code
	== NULL.
	[63c8a32690c6]

	* src/vm/exceptions.c, src/vm/jit/alpha/codegen.c,
	src/vm/jit/arm/codegen.c, src/vm/jit/i386/codegen.c,
	src/vm/jit/m68k/codegen.c, src/vm/jit/mips/codegen.c,
	src/vm/jit/powerpc/codegen.c, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/s390/codegen.c, src/vm/jit/sparc64/codegen.c,
	src/vm/jit/x86_64/codegen.c:
	* src/vm/exceptions.c (exceptions_handle_exception): Use
	code->synchronizedoffset directly for all architectures.

	* src/vm/jit/alpha/codegen.c, src/vm/jit/arm/codegen.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/m68k/codegen.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/x86_64/codegen.c
	(codegen_emit): Set code->synchronizedoffset to rd->memuse * 8.
	[16ddb27b00ef]

	* src/vm/exceptions.c, src/vm/jit/arm/codegen.c:
	* src/vm/exceptions.c (exceptions_handle_exception) [__ARM__]: Added
	#ifdef to the -8 path.

	* src/vm/jit/arm/codegen.c (codegen_emit): Added +1 to rd->memuse
	for synchronizedoffset.
	[303bfaab95ac]

	* src/vm/jit/alpha/asmpart.S, src/vm/jit/alpha/codegen.c,
	src/vm/jit/arm/asmpart.S, src/vm/jit/arm/codegen.c,
	src/vm/jit/arm/md.c, src/vm/jit/dseg.c, src/vm/jit/i386/asmpart.S,
	src/vm/jit/i386/codegen.c, src/vm/jit/m68k/asmpart.S,
	src/vm/jit/m68k/codegen.c, src/vm/jit/methodheader.h,
	src/vm/jit/mips/asmpart.S, src/vm/jit/mips/codegen.c,
	src/vm/jit/powerpc/asmpart.S, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/asmpart.S, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/s390/asmpart.S, src/vm/jit/s390/codegen.c,
	src/vm/jit/sparc64/asmpart.S, src/vm/jit/sparc64/codegen.c,
	src/vm/jit/x86_64/asmpart.S, src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/methodheader.h (IsSync): Removed.

	* src/vm/jit/dseg.c (dseg_addlinenumbertablesize): Removed one of
	the paddings.

	* src/vm/jit/arm/md.c (md_codegen_get_pv_from_pc): Commented the
	IsLeaf-check (this should be removed).

	* src/vm/jit/alpha/asmpart.S, src/vm/jit/arm/asmpart.S,
	src/vm/jit/i386/asmpart.S, src/vm/jit/m68k/asmpart.S,
	src/vm/jit/mips/asmpart.S, src/vm/jit/powerpc/asmpart.S,
	src/vm/jit/powerpc64/asmpart.S, src/vm/jit/s390/asmpart.S,
	src/vm/jit/sparc64/asmpart.S, src/vm/jit/x86_64/asmpart.S
	(asm_vm_call_method): Removed IsSync from method-header.

	* src/vm/jit/alpha/codegen.c, src/vm/jit/arm/codegen.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/m68k/codegen.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/x86_64/codegen.c
	(codegen_emit): Removed IsSync-dummy entry.
	[b9a4396d7410]

	* src/vm/exceptions.c, src/vm/jit/allocator/lsra.c,
	src/vm/jit/allocator/simplereg.c, src/vm/jit/alpha/codegen.c,
	src/vm/jit/arm/codegen.c, src/vm/jit/code.c, src/vm/jit/code.h,
	src/vm/jit/i386/codegen.c, src/vm/jit/m68k/codegen.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/code.h (codeinfo): Added synchronizedoffset
	(temporarily).

	* src/vm/exceptions.c (exceptions_handle_exception): Don't use
	IsSync but code->synchronizedoffset.

	* src/vm/jit/allocator/lsra.c, src/vm/jit/allocator/simplereg.c,
	src/vm/jit/code.c: Use code_is_synchronized.

	* src/vm/jit/alpha/codegen.c, src/vm/jit/arm/codegen.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/m68k/codegen.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/x86_64/codegen.c: Use
	code_is_synchronized and set code->synchronizedoffset.
	[b2916cc961d6]

2007-10-13  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/Makefile.am:
	* src/vm/jit/Makefile.am (noinst_HEADERS): Removed patcher.h
	[29b2f2887b40]

	* src/threads/lock-common.h, src/threads/native/lock.c, src/vm/jit
	/codegen-common.c, src/vm/jit/codegen-common.h, src/vm/jit/emit-
	common.h, src/vm/jit/patcher-common.h, src/vm/jit/patcher.h:
	* src/threads/lock-common.h (lock_get_initial_lock_word): Removed
	prototype.
	* src/threads/native/lock.c (lock_get_initial_lock_word): Removed.

	* src/vm/jit/codegen-common.c (codegen_add_patch_ref): Removed.
	* src/vm/jit/codegen-common.h (patchref) Removed structure.
	(codegendata): Removed patchrefs. (codegen_add_patch_ref): Removed
	prototype.

	* src/vm/jit/emit-common.h (emit_patcher_stubs): Removed prototype.

	* src/vm/jit/patcher-common.h: Removed ifdefs around patcher
	function macros.

	* src/vm/jit/patcher.h: Removed file.
	[1fe0cccd3f9e]

2007-10-13  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/arm/codegen.c:
	* src/vm/jit/arm/codegen.c (codegen_emit_stub_native): Removed
	patcher stub.
	[fb92cc407e44]

	* src/vm/jit/mips/codegen.c:
	* src/vm/jit/mips/codegen.c (codegen_emit_stub_native): Removed
	patcher stuff.
	[a85035fe3af1]

2007-10-13  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/vm.c:
	* src/vm/vm.c (vm_call_method_objectarray): Moved primitive_box into
	the native world.
	[daaf716e707f]

2007-10-13  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/stacktrace.c:
	* src/vm/jit/stacktrace.c (stacktrace_stack_walk): Use the flags in
	codeinfo to check for leaf-methods.<
	[88cf8bfaa9ae]

	* src/native/jvmti/jvmti.c, src/vm/jit/replace.c,
	src/vm/jit/stacktrace.c, src/vm/jit/stacktrace.h:
	* src/vm/jit/stacktrace.h (stackframeinfo_t): Removed method, added
	code.

	* src/native/jvmti/jvmti.c, src/vm/jit/replace.c,
	src/vm/jit/stacktrace.c: Likewise.
	[5ac994bd30b6]

	* src/mm/cacao-gc/gc.c, src/native/jvmti/jvmti.c,
	src/threads/native/threads.h, src/threads/threads-common.c,
	src/vm/exceptions.c, src/vm/jit/alpha/codegen.c,
	src/vm/jit/arm/codegen.c, src/vm/jit/codegen-common.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/jit.c,
	src/vm/jit/m68k/codegen.c, src/vm/jit/m68k/patcher.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/replace.c,
	src/vm/jit/replace.h, src/vm/jit/s390/codegen.c,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/sparc64/patcher.c,
	src/vm/jit/stacktrace.c, src/vm/jit/stacktrace.h,
	src/vm/jit/x86_64/codegen.c, src/vm/signal.c:
	* src/vm/jit/stacktrace.h (stackframeinfo): Renamed to
	stackframeinfo_t.

	* src/mm/cacao-gc/gc.c, src/native/jvmti/jvmti.c,
	src/threads/native/threads.h, src/threads/threads-common.c,
	src/vm/exceptions.c, src/vm/jit/alpha/codegen.c,
	src/vm/jit/arm/codegen.c, src/vm/jit/codegen-common.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/jit.c,
	src/vm/jit/m68k/codegen.c, src/vm/jit/m68k/patcher.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/replace.c,
	src/vm/jit/replace.h, src/vm/jit/s390/codegen.c,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/sparc64/patcher.c,
	src/vm/jit/stacktrace.c, src/vm/jit/x86_64/codegen.c,
	src/vm/signal.c: Likewise.
	[cff7e69a6d3e]

2007-10-13  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/threads/native/threads.c, src/threads/threads-common.c:
	* src/threads/native/threads.c: Fixed some compiler warnings.
	* src/threads/threads-common.c: Likewise.
	[ddee8a127826]

	* tests/gc/LockRecords.java, tests/gc/Makefile,
	tests/gc/NativeWeakRef.java, tests/gc/native.c:
	* tests/gc/LockRecords.java: Added additional cleanup pass after
	waiting.
	* tests/gc/Makefile: Added NativeWeakRef testcase.
	* tests/gc/NativeWeakRef.java: Added new testcase.
	* tests/gc/native.c: Added native methods for NativeWeakRef testcase.
	[eb85b412deb5]

	* src/mm/cacao-gc/gc.c, src/mm/cacao-gc/gc.h,
	src/threads/native/threads.c, src/threads/threads-common.h:
	* src/mm/cacao-gc/gc.c (gc_global_lock): Removed obsolete global
	lock. (gc_collect): Use GC mutex as global gc lock.
	(gc_reference_register_intern, gc_reference_unregister_intern): Use
	GC mutex to lock the reference lists.

	* src/mm/cacao-gc/gc.h (GC_MUTEX_LOCK, GC_MUTEX_UNLOCK): Added
	macros.

	* src/threads/native/threads.c [ENABLE_GC_CACAO] (mutex_gc): Added
	GC mutex. [ENABLE_GC_CACAO] (threads_mutex_gc_lock,
	threads_mutex_gc_unlock): Implemented.

	* src/threads/threads-common.h [ENABLE_GC_CACAO]
	(threads_mutex_gc_lock, threads_mutex_gc_unlock): Added prototypes.
	[49eb4810d097]

	* src/vm/string.c:
	* src/vm/string.c (javastring_toutf): Added check for empty strings.
	[8c1dc97f1d6a]

2007-10-13  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/allocator/lsra.c, src/vm/jit/allocator/simplereg.c,
	src/vm/jit/alpha/codegen.c, src/vm/jit/alpha/emit.c,
	src/vm/jit/arm/codegen.c, src/vm/jit/arm/md-abi.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/i386/emit.c,
	src/vm/jit/inline/inline.c, src/vm/jit/jit.c, src/vm/jit/jit.h,
	src/vm/jit/m68k/codegen.c, src/vm/jit/mips/codegen.c,
	src/vm/jit/mips/emit.c, src/vm/jit/optimizing/lsra.c,
	src/vm/jit/optimizing/ssa.c, src/vm/jit/parse.c, src/vm/jit/parse.h,
	src/vm/jit/powerpc/codegen.c, src/vm/jit/powerpc/darwin/md-abi.c,
	src/vm/jit/powerpc/linux/md-abi.c, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/powerpc64/linux/md-abi.c, src/vm/jit/replace.c,
	src/vm/jit/s390/codegen.c, src/vm/jit/s390/emit.c, src/vm/jit/s390
	/md-abi.c, src/vm/jit/show.c, src/vm/jit/sparc64/codegen.c,
	src/vm/jit/sparc64/emit.c, src/vm/jit/stack.c,
	src/vm/jit/x86_64/codegen.c, src/vm/jit/x86_64/emit.c,
	src/vm/jit/x86_64/md-abi.c:
	* src/vm/jit/jit.h (jitdata): Removed isleafmethod.

	* src/vm/jit/allocator/lsra.c, src/vm/jit/allocator/simplereg.c,
	src/vm/jit/alpha/codegen.c, src/vm/jit/alpha/emit.c,
	src/vm/jit/arm/codegen.c, src/vm/jit/arm/md-abi.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/i386/emit.c,
	src/vm/jit/inline/inline.c, src/vm/jit/jit.c,
	src/vm/jit/m68k/codegen.c, src/vm/jit/mips/codegen.c,
	src/vm/jit/mips/emit.c, src/vm/jit/optimizing/lsra.c,
	src/vm/jit/optimizing/ssa.c, src/vm/jit/parse.c, src/vm/jit/parse.h,
	src/vm/jit/powerpc/codegen.c, src/vm/jit/powerpc/darwin/md-abi.c,
	src/vm/jit/powerpc/linux/md-abi.c, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/powerpc64/linux/md-abi.c, src/vm/jit/replace.c,
	src/vm/jit/s390/codegen.c, src/vm/jit/s390/emit.c, src/vm/jit/s390
	/md-abi.c, src/vm/jit/show.c, src/vm/jit/sparc64/codegen.c,
	src/vm/jit/sparc64/emit.c, src/vm/jit/stack.c,
	src/vm/jit/x86_64/codegen.c, src/vm/jit/x86_64/emit.c,
	src/vm/jit/x86_64/md-abi.c: Replaced jd->isleafmethod with
	code_is_leafmethod.
	[14e3f40c0673]

2007-10-12  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/mm/cacao-gc/gc.c, src/mm/cacao-gc/gc.h, src/mm/cacao-gc/mark.c,
	src/mm/cacao-gc/rootset.c, src/mm/gc-common.h,
	src/threads/native/lock.c:
	* src/mm/cacao-gc/gc.c (gc_reflist_weak): Added list for weak
	references. (gc_weakreference_register,
	gc_weakreference_unregister): Implemented. (gc_collect): Added
	preliminary call to lock_hashtable_cleanup.

	* src/mm/cacao-gc/gc.h (gc_reflist_weak): Added.

	* src/mm/cacao-gc/mark.c (mark_post): Added postprocessing function.

	* src/mm/cacao-gc/rootset.c (rootset_from_globals): Add weak
	references. (reftype_names): Adapted to new enumeration.

	* src/mm/gc-common.h: Reference types are now enumerated.
	(gc_weakreference_register, gc_weakreference_unregister): Added
	prototypes.

	* src/threads/native/lock.c [ENABLE_GC_CACAO]
	(lock_hashtable_cleanup): Added. (lock_record_new, lock_record_free)
	[ENABLE_GC_CACAO]: Register and unregister references to lock object
	with the GC (as weak references).
	[fb2f8cea78af]

	* src/vm/jit/code.c, src/vm/jit/code.h, src/vm/jit/replace.c:
	* src/vm/jit/code.c (code_get_codeinfo_for_pv): Added new function.
	(code_find_codeinfo_for_pc): Use above function.
	(code_get_methodinfo_for_pv): Likewise.

	* src/vm/jit/code.h (code_get_codeinfo_for_pv): Added prototype.

	* src/vm/jit/replace.c (replace_pop_activation_record): Use above
	function. (replace_patch_method_pointer): Likewise.
	(replace_pop_native_frame): Skip native stubs with new sfi
	correctly. (replace_push_native_frame): Likewise.
	[8a4d773ffcee]

	* * Merged with rev 974c36a815eb.
	[7a0bc326262a]

	* src/cacaoh/headers.h, src/vm/string.c, src/vm/stringlocal.h:
	* src/cacaoh/headers.h (literalstring_free): Removed obsolete
	prototype.

	* src/vm/stringlocal.h (literalstring_u2, literalstring_free):
	Likewise.

	* src/vm/string.c (heapstring_t): Added typedef.
	(stringtable_update): Adapted for handles. (javastring_tochar): Code
	cleanup. (javastring_toutf): Code cleanup. (literalstring_u2): Made
	static and adapted for handles. (literalstring_free): Likewise.
	(javastring_intern): Code cleanup and added comments.
	[f52d56ea383b]

2007-10-12  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* configure.ac, src/native/vm/sun/jvm.c:
	* configure.ac (AC_CHECK_FUNCS): Added ftruncate.

	* src/native/vm/sun/jvm.c (JVM_DefineClassWithSource): Handle when
	name is NULL properly. (JVM_Lseek): Use TRACEJVMCALLS.
	(JVM_SetLength): Implemented.
	[974c36a815eb]

2007-10-11  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/threads/native/threads.c:
	* src/threads/native/threads.c (threads_detach_thread): Fixed CLDC
	build.
	[03703b6d4855]

2007-10-09  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/powerpc64/codegen.c:
	* src/vm/jit/powerpc64/codegen.c (codegen_emit_stub_native): Removed
	patcher stuff.
	[8d1744a5a128]

	* * Merged with b23caa4282a5.
	[8f008c01aec4]

	* tests/regression/Makefile.am:
	* tests/regression/Makefile.am (SOURCE_FILES): Removed
	extest_clinit.java.
	[e9d81d59eea6]

	* * Merged with 3b6c3b177749.
	[b23caa4282a5]

	* tests/regression/extest_clinit.java:
	* Merged with 59ff46a9e236.
	[d6f8c68e5b5f]

	* src/vm/jit/code.h:
	* src/vm/jit/code.h (stdint.h): Added. (CODE_FLAG_SYNCHRONIZED): New
	flag. (code_is_synchronized): New function.
	(code_flag_synchronized): Likewise. (code_unflag_synchronized):
	Likewise.
	[eed84225afd7]

2007-10-09  Roland Lezuo  <tbfg@complang.tuwien.ac.at>

	* tests/regression/extest_clinit.java:
	Merged?
	[3b6c3b177749]

	* src/vm/jit/m68k/codegen.c, src/vm/jit/m68k/linux/md-os.c,
	src/vm/jit/m68k/md.c, src/vm/jit/m68k/patcher.c, src/vm/jit/patcher-
	common.h:
	(codegen_emit_stub_builtin): Removed. (codegen_emit_stub_native):
	Ported to new interface.

	Ported to new interface, removed warnings.
	(md_signal_handler_sigill): Likewise.

	(offset.h): Removed.

	(PATCH_BACK_ORIGINAL_MCODE): Added. (patcher_patch_back): Removed.
	(patcher_patch_code): Added. (patcher_*): Use patchref_t instead of
	void *sp everywhere.
	[1f374ab123d9]

2007-10-09  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/system.c:
	* src/vm/system.c [__DARWIN__]: Fixed includes.
	[3fc50ec37a00]

	* src/threads/native/lock.c, src/vm/finalizer.c, src/vmcore/options.c,
	src/vmcore/options.h, tests/gc/LockRecords.java:
	* src/vm/finalizer.c (finalizer_run): Fixed for handles and added
	boehm-hack. (finalizer_thread, finalizer_notify): Added debug
	output.

	* src/vmcore/options.c (opt_DebugFinalizer): Added debug switch.
	* src/vmcore/options.h (opt_DebugFinalizer): Likewise.

	* src/threads/native/lock.c (lock_hashtable_remove): Also frees the
	lock record. (lock_record_finalizer): Same as for finalizer_run
	above. (lock_hashtable_get) [ENABLE_GC_BOEHM]: Fixed registration of
	finalizer.

	* tests/gc/LockRecords.java: Added new testcase for lock records
	cleanup.
	[59ff46a9e236]

	* src/native/vm/gnu/java_lang_reflect_Field.c,
	src/native/vm/gnu/java_lang_reflect_Method.c:
	* src/native/vm/gnu/java_lang_reflect_Field.c
	(cacao_get_field_address) Removed. (_field_access_check,
	_field_get_type, _field_set_type): Added new functions.
	(Java_java_lang_reflect_Field_XXX): Adapted to above changes and
	thereby fixing it for handles.

	* src/native/vm/gnu/java_lang_reflect_Method.c: Just removed bogus
	casting.
	[2ba3107ae158]

	* src/native/jni.c:
	* src/native/jni.c (_Jv_JNI_DeleteLocalRef): Fixed compiler warning.
	(_Jv_JNI_GetXXXField, _Jv_JNI_SetXXXField): Fixed for handles.
	(_Jv_JNI_GetStaticObjectField, _Jv_JNI_SetStaticObjectField):
	Likewise. (_Jv_JNI_SetObjectArrayElement): Adapted to new
	builtin_canstore. (_Jv_JNI_NewGlobalRef): Made LLNI critical
	sections smaller to avoid deadlock.
	[5e87139265f5]

	* src/threads/native/threads.c:
	* src/threads/native/threads.c (threads_detach_thread): Fixed debug
	output and compiler warning.
	[06ec3216cf7d]

2007-10-08  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/powerpc/arch.h, src/vm/jit/powerpc/asmpart.S,
	src/vm/jit/powerpc/codegen.c, src/vm/jit/powerpc/codegen.h,
	src/vm/jit/powerpc/darwin/md-asm.h, src/vm/jit/powerpc/darwin/md-
	os.c, src/vm/jit/powerpc/emit.c, src/vm/jit/powerpc/linux/md-os.c:
	* src/vm/jit/powerpc/arch.h (JIT_COMPILER_VIA_SIGNAL): Temporarily
	added.

	* src/vm/jit/powerpc/asmpart.S (asm_call_jit_compiler): Removed.
	(L_jit_asm_compile$stub): Likewise.
	(L_exceptions_get_and_clear_exception$stub): Likewise.

	* src/vm/jit/powerpc/codegen.c (codegen_emit_stub_compiler):
	Removed.

	* src/vm/jit/powerpc/codegen.h (COMPILERSTUB_CODESIZE): Adapted
	size.

	* src/vm/jit/powerpc/darwin/md-asm.h (asm_call_jit_compiler):
	Removed. (exceptions_get_and_clear_exception): Likewise.
	(jit_asm_compile): Likewise.

	* src/vm/jit/powerpc/emit.c (emit_trap_compiler): New function.

	* src/vm/jit/powerpc/darwin/md-os.c (md_signal_handler_sigsegv):
	Added compiler-by-signals code.
	* src/vm/jit/powerpc/linux/md-os.c: Likewise.
	[598cc626e0ee]

	* src/vm/jit/powerpc/codegen.c:
	* src/vm/jit/powerpc/codegen.c (codegen_emit_stub_native): Removed
	patcher stuff.
	[e4601e449e45]

	* tests/regression/extest.2output, tests/regression/extest.java,
	tests/regression/extest_clinit.java:
	* tests/regression/extest.java: Updated a bit and added another
	testcase.
	* tests/regression/extest.2output: Updated.
	* tests/regression/extest_clinit.java: Removed.
	[a95b70c0cad9]

	* src/vm/jit/stacktrace.c:
	* src/vm/jit/stacktrace.c (stacktrace_stackframeinfo_add) [!NDEBUG]:
	Added DebugStackFrameInfo output.
	(stacktrace_stackframeinfo_remove): Likewise.
	(stacktrace_stack_walk): Bugfix when a patcher in a leaf-method
	causes an exception.
	[cdbe094feb17]

2007-10-08  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/builtin.c, src/vm/builtin.h:
	* src/vm/builtin.c: Major cleanup of code and commentes, to much to
	list here, please accept my apologies for this short commit message.
	Everything is Handles-ready now.

	* src/vm/builtin.h: Adapted signatures of builtins and added vim
	boilerplate.
	[da567e175ac6]

	* src/native/llni.h, src/threads/native/lock.h, src/vm/finalizer.c,
	src/vm/jit/optimizing/recompile.c:
	* src/native/llni.h (LLNI_QUICKWRAP): Added new macro.

	* src/threads/native/lock.h: Use above macro for internal locking.
	(LOCK_WAIT_FOREVER, LOCK_NOTIFY): Added new macros.

	* src/vm/finalizer.c: Use internal locking macros throughout the
	code.
	* src/vm/jit/optimizing/recompile.c: Likewise.
	[6d2627458877]

2007-10-08  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/replace.c:
	* src/vm/jit/replace.c (replace_create_replacement_points): Use new
	code inline functions. (replace_pop_activation_record): Likewise.
	(replace_push_activation_record): Likewise.
	[cd0843508cff]

2007-10-08  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/arm/emit.c:
	* src/vm/jit/arm/emit.c (emit_verbosecall_exit): Fixed comments.
	[fbf41207864f]

	* src/vm/vm.c:
	* src/vm/vm.c (vm_create): Moved localref_table_init from
	vm_createjvm.
	[b924c9f5250c]

	* src/native/vm/cldc1.1/java_lang_Object.c,
	src/native/vm/gnu/java_lang_VMObject.c, src/native/vm/sun/jvm.c:
	* src/native/vm/cldc1.1/java_lang_Object.c
	(Java_java_lang_Object_notify): Adapted to new locking function
	signatures. (Java_java_lang_Object_notifyAll): Likewise.
	(Java_java_lang_Object_wait): Likewise.

	* src/native/vm/gnu/java_lang_VMObject.c
	(Java_java_lang_VMObject_notify): Adapted to new locking function
	signatures. (Java_java_lang_VMObject_notifyAll): Likewise.
	(Java_java_lang_VMObject_wait): Likewise.

	* src/native/vm/sun/jvm.c (JVM_MonitorWait): Adapted to new locking
	function signatures. (JVM_MonitorNotify): Likewise.
	(JVM_MonitorNotifyAll): Likewise.
	[6540073cf5a9]

2007-10-08  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* * Merged with ad640e81c710.
	[890fd7ef3d91]

	* src/vm/jit/code.h, src/vm/jit/jit.c:
	* src/vm/jit/code.h (codeinfo): Renamed codeflags to flags.
	(CODE_IS_VALID, CODE_IS_INVALID, CODE_IS_LEAFMETHOD)
	(CODE_SETFLAG_INVALID, CODE_SETFLAG_LEAFMETHOD): Removed.
	(code_is_invalid, code_flag_invalid, code_unflag_invalid): New
	inline function. (code_is_leafmethod, code_flag_leafmethod,
	code_unflag_leafmethod): Likewise.

	* src/vm/jit/jit.c (jit_invalidate_code): Use new inline functions.
	(jit_get_current_code): Likewise.
	[79af8d668a13]

2007-10-08  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/cacaoh/dummy.c, src/threads/lock-common.h,
	src/threads/native/lock.c:
	* src/threads/lock-common.h: Changed signature of most locking
	functions to take handles as arguments.

	* src/cacaoh/dummy.c: Adapted to new signatures.

	* src/threads/native/lock.c: Adapted to new signatures and added
	LLNI critical sections. Will slow down locking for [ENABLE_HANDLES
	&& ENABLE_GC_CACAO]. (lock_lockword_get). Implemented.
	(lock_lockword_set): Implemented.
	[ad640e81c710]

	* src/vm/jit/alpha/emit.c, src/vm/jit/alpha/md-abi.h:
	* src/vm/jit/alpha/emit.c (emit_verbosecall_enter): Adapted to use
	new tracer. (emit_verbosecall_exit): Likewise.

	* src/vm/jit/alpha/md-abi.h (TRACE_ARGS_NUM): Removed.
	[9e38d84cc222]

	* src/native/llni.c, src/native/llni.h:
	* src/native/llni.h (LLNI_CRITICAL_START_THREAD): Added faster
	macro. (LLNI_CRITICAL_END_THREAD): Likewise.

	* src/native/llni.c (llni_critical_start_thread): Implemented faster
	function. (llni_critical_end_thread): Likewise.
	[8cbaddb63fe3]

	* src/native/llni.h:
	* src/native/llni.h (LLNI_field_set_ref): Fixed problem with NULL
	references.
	[c765f13d96ff]

2007-10-07  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/builtin.c:
	* src/vm/builtin.c (builtin_print_argument): Removed obsolete
	function. (builtin_verbosecall_enter): Made a dummy function, use
	new tracer. (builtin_verbosecall_exit): Likewise.
	[88b3f386c93a]

	* src/vm/jit/powerpc64/emit.c, src/vm/jit/powerpc64/linux/md-abi.h:
	* src/vm/jit/powerpc64/emit.c (emit_verbosecall_enter): Adapted to
	use new tracer. (emit_verbosecall_exit): Likewise.

	* src/vm/jit/powerpc64/linux/md-abi.h (TRACE_ARGS_NUM): Removed.
	[53674e362433]

	* src/vm/jit/arm/emit.c, src/vm/jit/arm/md-abi.h:
	* src/vm/jit/arm/emit.c (emit_verbosecall_enter): Adapted to use new
	tracer. (emit_verbosecall_exit): Likewise.

	* src/vm/jit/arm/md-abi.h (TRACE_ARGS_NUM): Removed.
	[b630de06148c]

	* src/vm/jit/i386/emit.c, src/vm/jit/i386/md-abi.h:
	* src/vm/jit/i386/emit.c (emit_verbosecall_enter): Adapted to use
	new tracer. (emit_verbosecall_exit): Likewise.

	* src/vm/jit/i386/md-abi.h (TRACE_ARGS_NUM): Removed.
	[14c64bfb5899]

	* src/vm/jit/powerpc/darwin/md-abi.h, src/vm/jit/powerpc/emit.c,
	src/vm/jit/powerpc/linux/md-abi.h, src/vm/jit/powerpc/netbsd/md-
	abi.h, src/vm/jit/s390/md-abi.h, src/vm/jit/x86_64/emit.c,
	src/vm/jit/x86_64/md-abi.h:
	* src/vm/jit/x86_64/emit.c (emit_verbosecall_enter): Adapted to use
	new tracer. (emit_verbosecall_exit): Likewise.

	* src/vm/jit/x86_64/md-abi.h (TRACE_ARGS_NUM): Removed.

	* src/vm/jit/s390/md-abi.h (TRACE_ARGS_NUM): Removed, already uses
	new tracer.

	* src/vm/jit/powerpc/darwin/md-abi.h (TRACE_ARGS_NUM): Likewise.
	* src/vm/jit/powerpc/linux/md-abi.h (TRACE_ARGS_NUM): Likewise.
	* src/vm/jit/powerpc/netbsd/md-abi.h (TRACE_ARGS_NUM): Likewise.

	* src/vm/jit/powerpc/emit.c (vm/builtin.h): Removed obsolete
	include.
	[274bd505a69b]

2007-10-06  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/native/vm/java_lang_Thread.c, src/threads/native/threads.c,
	src/threads/threads-common.c, src/threads/threads-common.h:
	* src/threads/threads-common.h (threads_thread_get_object): Added.
	(threads_thread_set_object): Added.

	* src/threads/threads-common.c: Use above functions throughout the
	code.

	* src/threads/native/threads.c: Likewise.

	* src/native/vm/java_lang_Thread.c: Likewise.
	(_Jv_java_lang_Thread_start): Fixed compiler warning.
	(_Jv_java_lang_Thread_currentThread) [ENABLE_JAVASE]: Fixed for
	handles.
	[01272c7b7f7e]

	* src/native/jni.c, src/native/llni.h, src/vm/builtin.c:
	* src/native/llni.h (LLNI_objectarray_element_set) Removed.
	(LLNI_objectarray_element_get) Removed.

	* src/native/jni.c: Use array_objectarray functions throughout the
	code.
	* src/vm/builtin.c: Likewise.
	[841ec0d005f8]

	* src/native/jni.c, src/native/localref.c:
	* src/native/jni.c (_Jv_JNI_DeleteLocalRef): Handle NULL references
	correctly.
	* src/native/localref.c (localref_add, localref_del): Added assertion.
	[1b879af9b08e]

2007-10-06  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/jit.c, src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/jit.c (jit_compile_intern): Use native_method_resolve
	and check for exception.

	* src/vm/jit/x86_64/codegen.c (codegen_emit_stub_native): Removed
	patcher stuff.
	[3fceed4e5c71]

	* src/native/native.c, src/native/native.h, src/vm/jit/patcher-
	common.c:
	* src/native/native.c (native_resolve_function): Renamed to
	native_method_resolve.
	* src/native/native.h: Likewise.

	* src/vm/jit/patcher-common.c (patcher_resolve_native_function):
	Likewise.
	[fd16ab5d87f1]

	* src/vm/jit/allocator/simplereg.c, src/vm/jit/jit.h,
	src/vm/jit/powerpc/codegen.c, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/show.c, src/vm/jit/stack.c, src/vm/jit/verify/icmds.c:
	* src/vm/jit/allocator/simplereg.c (ICMD_IF_FCMPxx,
	ICMD_IF_FCMPL_xx): Removed.
	* src/vm/jit/jit.h: Likewise.
	* src/vm/jit/powerpc/codegen.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/show.c: Likewise.
	* src/vm/jit/stack.c: Likewise.
	* src/vm/jit/verify/icmds.c: Likewise.
	[ba6af13783a8]

2007-10-03  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/cacaoh/dummy.c, src/vm/array.c, src/vm/jit/argument.c,
	src/vm/jit/stacktrace.c:
	* src/vm/array.c (array_objectarray_element_set): Fixed for handles.
	(array_objectarray_element_get): Likewise.

	* src/cacaoh/dummy.c (array_objectarray_element_set): Do not use
	LLNI_objectarray macros. (array_objectarray_element_get): Likewise.

	* src/vm/jit/argument.c: Use array_objectarray functions instead of
	LLNI_objectarray.

	* src/vm/jit/stacktrace.c: Likewise.
	[a4856d5695d8]

2007-10-03  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/exceptions.c, src/vm/jit/codegen-common.c, src/vm/jit/jit.c,
	src/vm/jit/m68k/patcher.c, src/vm/jit/sparc64/patcher.c,
	src/vm/jit/stacktrace.c, src/vm/jit/stacktrace.h, src/vm/signal.c:
	* src/vm/jit/stacktrace.c (stacktrace_create_stackframeinfo):
	Removed. (stacktrace_create_extern_stackframeinfo): Renamed to
	stacktrace_stackframeinfo_add. (stacktrace_remove_stackframeinfo):
	Renamed to stacktrace_stackframeinfo_remove.
	* src/vm/jit/stacktrace.h: Likewise.

	* src/vm/exceptions.c, src/vm/jit/codegen-common.c,
	src/vm/jit/jit.c, src/vm/jit/m68k/patcher.c,
	src/vm/jit/sparc64/patcher.c, src/vm/signal.c: Renamed functions as
	above.
	[25cf57814a88]

2007-10-03  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/x86_64/codegen.c (codegen_emit_stub_native): Fixed
	stackframesize for (md->paramcount == 0 && md->returntype !=
	TYPE_VOID) cases.
	[a7482a807f1e]

	* src/native/localref.c, src/vmcore/options.c, src/vmcore/options.h:
	* src/native/localref.c: Improved debug output with
	-XX:+DebugLocalReferences. (localref_check_uncleared): Implemented.

	* src/vmcore/options.c (opt_DebugLocalReferences): Added.
	* src/vmcore/options.h (opt_DebugLocalReferences): Likewise.
	[8e0d054d7791]

2007-10-03  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/codegen-common.c, src/vm/jit/stacktrace.c:
	* src/vm/jit/codegen-common.c (codegen_start_native_call): Renamed
	currentsp to sp, removed javara, use
	stacktrace_create_extern_stackframeinfo instead of
	stacktrace_create_native_stackframeinfo.
	(codegen_finish_native_call): Renamed currentsp to sp.

	* src/vm/jit/stacktrace.c (stdint.h): Added.
	(stacktrace_create_extern_stackframe): Always get methodinfo and
	store it in stackframeinfo.
	(stacktrace_create_native_stackframeinfo): Removed.
	(stacktrace_add_entry): Renamed to stacktrace_entry_add, made
	inline. (stacktrace_add_method): Renamed to stacktrace_method_add,
	made inline. (stacktrace_stack_walk): New function.
	(stacktrace_create): Completely rewritten.
	[e61772b09f4d]

2007-10-03  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/native/vm/cldc1.1/java_lang_Throwable.c,
	src/native/vm/gnu/java_lang_VMThrowable.c, src/native/vm/sun/jvm.c,
	src/vm/jit/stacktrace.c, src/vm/jit/stacktrace.h:
	* src/vm/jit/stacktrace.c (stacktrace_fillInStackTrace): Returns a
	bytearray. (stacktrace_print_trace): Does not use
	stacktracecontainer anymore.

	* src/vm/jit/stacktrace.h (stacktracecontainer): Removed.
	(stacktrace_fillInStackTrace): Adapted prototype to above change.

	* src/native/vm/cldc1.1/java_lang_Throwable.c: Adapted to above
	changes.
	* src/native/vm/gnu/java_lang_VMThrowable.c: Likewise.
	* src/native/vm/sun/jvm.c: Likewise.
	[d528eb08966a]

2007-10-03  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/jit.c:
	* src/vm/jit/jit.c (jit_compile_handle): Removed unused variable.
	[417ec2928806]

	* src/vm/jit/powerpc64/arch.h, src/vm/jit/powerpc64/asmpart.S,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/powerpc64/codegen.h,
	src/vm/jit/powerpc64/emit.c, src/vm/jit/powerpc64/linux/md-os.c:
	* src/vm/jit/powerpc64/arch.h (JIT_COMPILER_VIA_SIGNAL): Temporarily
	added.

	* src/vm/jit/powerpc64/asmpart.S (asm_call_jit_compiler): Removed.
	* src/vm/jit/powerpc64/codegen.c (codegen_emit_stub_compiler):
	Likewise.

	* src/vm/jit/powerpc64/codegen.h (COMPILERSTUB_CODESIZE): Adapted
	size.

	* src/vm/jit/powerpc64/emit.c (emit_trap_compiler): New function.

	* src/vm/jit/powerpc64/linux/md-os.c (md_signal_handler_sigsegv):
	Added compiler-by-signals code.
	[f7859b7aea62]

	* src/vm/jit/alpha/arch.h, src/vm/jit/alpha/asmpart.S,
	src/vm/jit/alpha/codegen.c, src/vm/jit/alpha/codegen.h,
	src/vm/jit/alpha/emit.c, src/vm/jit/alpha/linux/md-os.c:
	* src/vm/jit/alpha/arch.h (JIT_COMPILER_VIA_SIGNAL): Temporarily
	added.

	* src/vm/jit/alpha/asmpart.S (asm_call_jit_compiler): Removed.
	* src/vm/jit/alpha/codegen.c (codegen_emit_stub_compiler): Likewise.

	* src/vm/jit/alpha/codegen.h (COMPILERSTUB_CODESIZE): Adapted size.

	* src/vm/jit/alpha/emit.c (emit_trap_compiler): New function.

	* src/vm/jit/alpha/linux/md-os.c (vm/exceptions.h): Added.
	(md_signal_handler_sigsegv): Added compiler-by-signals code.
	[41acab1bbc53]

2007-10-03  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/native/vm/gnu/gnu_classpath_VMStackWalker.c,
	src/native/vm/gnu/java_lang_VMThrowable.c,
	src/native/vm/java_lang_Class.c, src/vm/vm.c:
	* src/vm/vm.c: Use array_objectarray functions instead of
	LLNI_objectarray.
	* src/native/vm/gnu/gnu_classpath_VMStackWalker.c: Likewise.
	* src/native/vm/gnu/java_lang_VMThrowable.c: Likewise.
	* src/native/vm/java_lang_Class.c: Likewise.
	[dfd4ba44560b]

2007-10-03  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/m68k/md.c, src/vm/jit/powerpc64/md.c,
	src/vm/jit/s390/md.c:
	* src/vm/jit/m68k/md.c (md_codegen_patch_branch): Removed.
	* src/vm/jit/powerpc64/md.c: Likewise.
	* src/vm/jit/s390/md.c: Likewise.
	[74debb2c5834]

2007-10-03  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/builtintable.inc:
	* src/vm/builtintable.inc (builtintable_internal): Added preliminary
	entry for builtin_multianewarray.
	[4728593261f4]

	* src/mm/memory.h, src/native/localref.c, src/vmcore/class.c,
	src/vmcore/field.c:
	* src/mm/memory.h [ENABLE_GC_BOEHM]: GCNEW macros are available for
	boehm only.

	* src/native/localref.c: Adapted ifdefs to above change.

	* src/vmcore/class.c: Adapted ifdefs to above change. (class_free):
	Fixed, fields array get freed properly.

	* src/vmcore/field.c: Adapted ifdefs to above change. (field_free):
	Implemented, field value memory gets freed.
	[c33e0df79652]

2007-10-01  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/native/vm/reflect.c:
	* src/native/vm/reflect.c [ENABLE_ANNOTATIONS]: Fixed includes.
	[fc72108d11a3]

	* doc/Makefile.am, doc/handbook/Makefile.am:
	* doc/Makefile.am: Fixed clean target to work properly.
	* doc/handbook/Makefile.am: Likewise.
	[a380a08533a3]

2007-10-01  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/i386/md.c:
	* src/vm/jit/i386/md.c (vm/vm.h): Added.
	(md_jit_method_patch_address): Rewritten to new proposed version.
	[ec8797d1e6e4]

	* src/vm/jit/i386/linux/md-os.c:
	* src/vm/jit/i386/linux/md-os.c (md_signal_handler_sigsegv): Set PV
	and XPC correctly.
	[6a09e13f9f75]

	* src/vm/jit/i386/emit.c:
	* src/vm/jit/i386/emit.c (emit_verbosecall_enter): Use M_CLTD.
	[c476a916878f]

	* src/vm/jit/jit.c, src/vm/jit/jit.h, src/vm/jit/x86_64/linux/md-os.c,
	src/vm/signal.c:
	* src/vm/jit/jit.c (jit_compile_handle): Changed signature.
	* src/vm/jit/jit.h: Likewise.

	* src/vm/jit/x86_64/linux/md-os.c (md_signal_handler_sigsegv): Set
	PV and XPC correctly.

	* src/vm/signal.c (signal_handle): Get the methodinfo pointer and
	pass it to jit_compile_handle.
	[005f80121869]

	* src/vm/jit/i386/arch.h, src/vm/jit/i386/asmpart.S,
	src/vm/jit/i386/codegen.c, src/vm/jit/i386/codegen.h,
	src/vm/jit/i386/emit.c, src/vm/jit/i386/emit.h,
	src/vm/jit/i386/linux/md-os.c:
	* src/vm/jit/i386/arch.h (JIT_COMPILER_VIA_SIGNAL): Temporarily
	added.

	* src/vm/jit/i386/asmpart.S (asm_call_jit_compiler): Removed.

	* src/vm/jit/i386/codegen.c (codegen_emit_stub_compiler): Likewise.

	* src/vm/jit/i386/codegen.h (COMPILERSTUB_CODESIZE): Adapted size.
	(M_BYTE1, M_BYTE2): New macros. (M_CLTD, M_RET, M_NOP): Use M_BYTE1.
	(M_UD2): Use M_BYTE2.

	* src/vm/jit/i386/emit.c (emit_trap_compiler): New function.
	(emit_trap): Use macros. (emit_cltd, emit_ret, emit_nop): Removed.
	* src/vm/jit/i386/emit.h (emit_cltd, emit_ret, emit_nop): Likewise.

	* src/vm/jit/i386/linux/md-os.c (md_signal_handler_sigsegv): Added
	JIT compiler code.
	[67dda8c1dc3d]

	* src/vm/jit/x86_64/emit.c:
	* src/vm/jit/x86_64/emit.c (emit_trap_compiler): Fixed comment.
	[a3ff74c5b8b0]

	* src/vm/jit/x86_64/linux/md-os.c:
	* src/vm/jit/x86_64/linux/md-os.c (md_signal_handler_sigsegv):
	Removed debug output.
	[79001d4e5c15]

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (JVM_InitProperties): Fixed warning.
	[f91157763a26]

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (vm/system.h): Added.
	(JVM_ActiveProcessorCount): Implemented.
	[121bbaac9f59]

	* src/native/vm/gnu/java_lang_VMRuntime.c, src/vm/Makefile.am,
	src/vm/system.c, src/vm/system.h:
	* src/native/vm/gnu/java_lang_VMRuntime.c (vm/system.h): Added.
	(availableProcessors): Use system_processors_online.

	* src/vm/Makefile.am (libvm_la_SOURCES): Added system.[ch].

	* src/vm/system.c: New file.
	* src/vm/system.h: Likewise.
	[3215b4903941]

	* src/vm/jit/jit.c, src/vm/vm.c:
	* src/vm/jit/jit.c (jit_compile_handle): Fixed warning.
	* src/vm/vm.c (vm_abort_disassemble): Likewise.
	[294eb7f45035]

	* src/native/vm/sun/jvm.c, src/vmcore/class.h:
	* src/native/vm/sun/jvm.c (JVM_SetClassSigners): Implemented.
	* src/vmcore/class.h (classinfo) [WITH_CLASSPATH_SUN]: Added signers.
	[3fd887e6e438]

	* src/vm/jit/jit.c:
	* src/vm/jit/jit.c (jit_compile_intern) [WITH_CLASSPATH_SUN]: Don't
	verify sub-classes of sun/reflect/MagicAccessorImpl.
	[51ab7abeebc5]

2007-09-29  Peter Molnar  <pm@complang.tuwien.ac.at>

	* src/vm/jit/s390/patcher.c:
	* src/vm/jit/s390/patcher.c
	(patcher_checkcast_instanceof_interface): Fix error introduced in
	changeset 7586.
	[d5b33f1afb30]

	* src/vm/jit/s390/codegen.c, src/vm/jit/s390/codegen.h,
	src/vm/jit/s390/emit.c, src/vm/jit/s390/md.c,
	src/vm/jit/s390/patcher.c:
	* src/vm/jit/s390/codegen.h: Added functions for instruction parsing
	and manipulation, added opcode defines.
	* src/vm/jit/s390/codegen.c (codegen_emit): Replaced handcrafted
	machined code patching by marco.
	* src/vm/jit/s390/emit.c (emit_branch): Likewise.
	* src/vm/jit/s390/md.c (md_jit_method_patch_address,
	md_signal_handler_sigsegv, md_signal_handler_sigill,
	md_signal_handler_sigfpe): Replaced handcrafted machine code parsing
	and patching by calls to new functions.
	* src/vm/jit/s390/patcher.c (patcher_invokeinterface,
	patcher_invokevirtual, patcher_get_putfield): Likewise.
	[4a9b0a8de18b]

2007-09-29  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/asmpart.h, src/vm/jit/codegen-common.c, src/vm/jit
	/codegen-common.h, src/vm/jit/emit-common.h, src/vm/jit/jit.c,
	src/vm/jit/jit.h, src/vm/jit/x86_64/arch.h,
	src/vm/jit/x86_64/asmpart.S, src/vm/jit/x86_64/codegen.c,
	src/vm/jit/x86_64/codegen.h, src/vm/jit/x86_64/emit.c,
	src/vm/jit/x86_64/linux/md-os.c, src/vm/signal.c:
	* src/vm/jit/asmpart.h [!JIT_COMPILER_VIA_SIGNAL]
	(asm_call_jit_compiler): Added #ifdef.

	* src/vm/jit/codegen-common.c (codegen_generate_stub_compiler)
	[JIT_COMPILER_VIA_SIGNAL]: Added new code.

	* src/vm/jit/codegen-common.h [!JIT_COMPILER_VIA_SIGNAL]
	(codegen_emit_stub_compiler): Added #ifdef.

	* src/vm/jit/emit-common.h (emit_trap_compiler): Added.

	* src/vm/jit/jit.c [!JIT_COMPILER_VIA_SIGNAL] (jit_asm_compile):
	Added #ifdef. (jit_compile_handle): New function.

	* src/vm/jit/jit.h (vm/jit/stacktrace.h): Added.
	[!JIT_COMPILER_VIA_SIGNAL] (jit_asm_compile): Added #ifdef.

	* src/vm/jit/x86_64/arch.h (JIT_COMPILER_VIA_SIGNAL): Added
	temporarily.

	* src/vm/jit/x86_64/asmpart.S (asm_call_jit_compiler): Removed.

	* src/vm/jit/x86_64/codegen.c (codegen_emit_stub_compiler): Removed.
	* src/vm/jit/x86_64/codegen.h (COMPILERSTUB_CODESIZE): Adapted.

	* src/vm/jit/x86_64/emit.c (emit_trap_compiler): New function.

	* src/vm/jit/x86_64/linux/md-os.c (md_signal_handler_sigsegv): Added
	JIT compiler handling code.
	* src/vm/signal.c (signal_handle): Likewise.
	[1625eb0b4231]

	* src/vm/jit/alpha/md.c, src/vm/jit/arm/md.c, src/vm/jit/i386/md.c,
	src/vm/jit/jit.c, src/vm/jit/jit.h, src/vm/jit/m68k/md.c,
	src/vm/jit/md.h, src/vm/jit/mips/md.c, src/vm/jit/powerpc/md.c,
	src/vm/jit/powerpc64/md.c, src/vm/jit/replace.c,
	src/vm/jit/s390/md.c, src/vm/jit/sparc64/md.c,
	src/vm/jit/x86_64/md.c:
	* src/vm/jit/md.h (md_get_method_patch_address): Removed.
	* src/vm/jit/jit.h (md_jit_method_patch_address): Added.

	* src/vm/jit/jit.c (jit_asm_compile): Call
	md_jit_method_patch_address with new signature.

	* src/vm/jit/replace.c (replace_patch_future_calls): Likewise.

	* src/vm/jit/alpha/md.c, src/vm/jit/arm/md.c, src/vm/jit/i386/md.c,
	src/vm/jit/m68k/md.c, src/vm/jit/mips/md.c, src/vm/jit/powerpc/md.c,
	src/vm/jit/powerpc64/md.c, src/vm/jit/s390/md.c,
	src/vm/jit/sparc64/md.c, src/vm/jit/x86_64/md.c: Tried to fix the
	includes. (md_get_method_patch_address): Renamed to
	md_jit_method_patch_address and changed the signature.
	[5a0a7be1c61c]

	* src/vm/jit/alpha/codegen.h, src/vm/jit/alpha/linux/md-os.c:
	* src/vm/jit/alpha/codegen.h (M_MEM_GET_Opcode): New macro.
	(M_MEM_GET_A): Renamed to M_MEM_GET_Ra to be consistent with
	handbook. (M_MEM_GET_B): Renamed to M_MEM_GET_Rb. (M_MEM_GET_DISP):
	Renamed to M_MEM_GET_Memory_disp.

	* src/vm/jit/alpha/linux/md-os.c (md_signal_handler_sigsegv): Use
	new macro names.
	[01d55d426e53]

	* src/vm/vm.c, src/vm/vm.h:
	* src/vm/vm.c [ENABLE_DISASSEMBLER] (vm/jit/disass.h): Added.
	(vm_abort_disassemble): New function.
	* src/vm/vm.h (vm_abort_disassemble): Likewise.
	[3666493a0162]

2007-09-28  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/jni.c:
	* src/native/jni.c: Merged with 93595e0b477d.
	[e03e02f0135d]

	* src/vm/jit/powerpc/asmpart.S:
	* src/vm/jit/powerpc/asmpart.S (asm_vm_call_method): Don't fake a
	Java call, because we don't patch this call anymore (TODO: all other
	architectures as well).
	[93595e0b477d]

	* src/native/jni.c:
	* src/native/jni.c (_Jv_JNI_GetEnv): Use jni_version_check.
	[4194e7194975]

	* src/vm/jit/powerpc/asmpart.S, src/vm/jit/powerpc/darwin/md-asm.h:
	* src/vm/jit/powerpc/asmpart.S
	(L_stacktrace_create_extern_stackframeinfo$stub): Removed.
	(L_stacktrace_remove_stackframeinfo$stub): Likewise.
	(L_replace_me$stub): Likewise.
	(L_replace_build_execution_state$stub): Likewise.
	(L_replace_free_safestack$stub): Likewise.

	* src/vm/jit/powerpc/darwin/md-asm.h (jumptable_int,
	jumptable_long): Removed. (asm_patcher_wrapper): Likewise.
	(patcher_wrapper): Likewise. (replace_me): Likewise.
	(replace_build_execution_state): Likewise. (replace_free_safestack):
	Likewise. (stacktrace_create_extern_stackframeinfo): Likewise.
	(stacktrace_remove_stackframeinfo): Likewise.
	[1eea65d453be]

2007-09-28  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/mm/cacao-gc/rootset.c, src/vm/jit/replace.c:
	* src/vm/jit/replace.c (replace_gc_into_native): Implemented.
	* src/mm/cacao-gc/rootset.c (rootset_writeback): Use above function.
	[f324661aa9c8]

	* src/mm/cacao-gc/compact.c, src/mm/cacao-gc/mark.c:
	* src/mm/cacao-gc/compact.c (compact_thread_classes): Removed
	obsolete function.
	* src/mm/cacao-gc/mark.c (mark_classes): Likewise.
	[70164b6b8eac]

	* src/vm/jit/argument.c, src/vm/vm.c:
	* src/vm/jit/argument.c: Added missing method comments.
	(vm/exceptions.h): Removed include.
	(argument_vmarray_from_objectarray): Do not throw exceptions, but
	return NULL.

	* src/vm/vm.c (vm_call_method_objectarray): Adapted to above changes
	and fixed nativeworld sections.
	[d7d6dadc37c5]

2007-09-28  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/jit.c, src/vmcore/options.c, src/vmcore/options.h:
	* src/vm/jit/jit.c (TRACECOMPILERCALLS): New macro. (jit_compile):
	Use TRACECOMPILERCALLS. (jit_compile_intern): Removed some
	DEBUG_JIT_COMPILEVERBOSE.

	* src/vmcore/options.c (opt_TraceCompilerCalls): New variable.
	(options_xx): Handle opt_TraceCompilerCalls.
	* src/vmcore/options.h (opt_TraceCompilerCalls): Added.
	[0d92a96dd835]

2007-09-27  Peter Molnar  <pm@complang.tuwien.ac.at>

	* src/vm/jit/s390/codegen.h:
	* src/vm/jit/s390/codegen.h (N_BRANCH_MIN, N_BRANCH_MAX): Fix
	(muliply by 2).
	[b2999afc3d91]

2007-09-27  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/argument.c, src/vm/vm.c:
	* src/vm/jit/argument.c (argument_vmarray_store_adr): Fixed for
	handles.
	* src/vm/vm.c (vm_call_array): Likewise.
	[ced954316377]

	* src/native/jni.c, src/vm/vm.c, src/vm/vm.h:
	* src/vm/vm.c (vm_call_array): Made static, removed compiler call.
	(vm_call_method_objectarray): Added. (vm_call_method_valist): Added
	nativeworld macros, added compiler call. (vm_call_method_jvalue):
	Likewise.

	* src/vm/vm.h (vm_call_array): Removed prototypes.
	(vm_call_method_objectarray): Added prototype.

	* src/native/jni.c (_Jv_jni_invokeNative): Moved parts to vm.c for
	clearness.
	[a39b92f53b6a]

2007-09-27  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/code.c:
	* src/vm/jit/code.c (code_get_methodinfo_for_pv): Return NULL if
	code is NULL (asm_vm_call_method).
	[351e6063c865]

2007-09-27  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/threads/threads-common.c:
	* src/threads/threads-common.c (vmcore/options.h): Fixed include.
	[d1a28f42c379]

2007-09-27  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/mm/memory.c, src/mm/memory.h:
	* src/mm/memory.c (memory_mprotect): Fixed signature, manpage is
	wrong about the signature of mprotect.
	* src/mm/memory.h: Likewise.
	[06d06747d56c]

2007-09-27  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/native/jni.c, src/vm/jit/argument.c, src/vm/jit/argument.h,
	src/vm/vm.c, src/vm/vm.h:
	* src/vm/jit/argument.c (argument_vmarray_store_int),
	(argument_vmarray_store_lng), (argument_vmarray_store_flt),
	(argument_vmarray_store_dbl), (argument_vmarray_store_adr),
	(argument_vmarray_from_valist), (argument_vmarray_from_jvalue),
	(argument_vmarray_from_objectarray): Moved from vm.c to this file.

	* src/vm/jit/argument.h (argument_vmarray_from_valist): Added
	prototype. (argument_vmarray_from_jvalue): Likewise.
	(argument_vmarray_from_objectarray): Likewise.

	* src/vm/vm.c: See above!

	* src/vm/vm.h (vm_array_from_objectarray): Removed prototype.

	* src/native/jni.c (_Jv_jni_invokeNative): Adapted to above changes.
	[cac920852cf7]

2007-09-27  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vmcore/class.c, src/vmcore/class.h:
	* src/vmcore/class.c (class_is_primitive, class_is_anonymousclass,
	class_is_array, class_is_interface, class_is_localclass,
	class_is_memberclass, class_get_classloader, class_get_superclass):
	Moved to class.h and made them static inline.
	* src/vmcore/class.h: Likewise.
	[42bf0070c359]

2007-09-27  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/threads/lock-common.h, src/toolbox/logging.c:
	* src/threads/lock-common.h: Removed obsolete comment.
	* src/toolbox/logging.c (threads/threads-common.h): Added include.
	[efd01191b1ee]

	* src/mm/gc-common.h, src/native/jni.c,
	src/native/vm/gnu/java_lang_VMSystem.c, src/threads/native/lock.c,
	src/vmcore/loader.c:
	* src/mm/gc-common.h (heap_hashcode): Added inline function.

	* src/native/jni.c: Use above function throughout file.
	* src/native/vm/gnu/java_lang_VMSystem.c: Likewise.
	* src/threads/native/lock.c: Likewise.
	* src/vmcore/loader.c: Likewise.
	[7e2d5fdf3012]

2007-09-26  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/threads/native/lock.c, src/vm/global.h:
	* src/threads/native/lock.c: Renamed monitorPtr to lockword in the
	whole file. (stdint.h): Added.

	* src/vm/global.h (stdint.h): Added. (java_object_t): Renamed
	monitorPtr to lockword and changed the type to uintptr_t.
	[853865d3df15]

2007-09-26  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/threads/native/threads.c, src/threads/threads-common.c:
	* src/threads/native/threads.c (threads_init): Removed obsolete call
	to register references with the GC.

	* src/threads/threads-common.c (threads_thread_new): Also register
	reference to exception object with the GC.
	[019681a01270]

	* src/threads/native/threads.c, src/threads/threads-common.c,
	src/threads/threads-common.h, src/vm/vm.c, src/vmcore/options.c,
	src/vmcore/options.h:
	* src/threads/native/threads.c: Improved debug output.
	* src/threads/threads-common.c: Likewise.

	* src/threads/threads-common.h (DEBUGTHREADS): Added.

	* src/vm/vm.c (vm_create): Removed -verbose:threads option.

	* src/vmcore/options.c (opt_DebugThreads): Added -XX:+DebugThreads
	option.
	* src/vmcore/options.h (opt_DebugThreads): Likewise.
	[4ab0c57483a9]

	* src/threads/native/threads.c, src/threads/native/threads.h,
	src/threads/threads-common.c, src/threads/threads-common.h:
	* src/threads/native/threads.h (native/include/java_lang_Thread.h):
	Removed. (threadobject): The object pointer is of type java_object_t
	now.

	* src/threads/native/threads.c: Adapted to above changes and use
	LLNI macros.

	* src/threads/threads-common.h (threads_thread_start): Changed
	signature to not use java_lang_Thread anymore.

	* src/threads/threads-common.c: Adapted to above changes and use
	LLNI macros. (threads_preinit): Fixed corruption of
	mainthread->flags.
	[26e085a276e8]

2007-09-25  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/alpha/md.c, src/vm/jit/i386/md.c, src/vm/jit/mips/md.c,
	src/vm/jit/powerpc/md.c, src/vm/jit/powerpc64/md.c,
	src/vm/jit/replace.c, src/vm/jit/sparc64/md.c,
	src/vm/jit/x86_64/md.c:
	* src/vm/jit/alpha/md.c (md_patch_replacement_point): Removed debug
	code.
	* src/vm/jit/i386/md.c: Likewise.
	* src/vm/jit/mips/md.c: Likewise.
	* src/vm/jit/powerpc/md.c: Likewise.
	* src/vm/jit/powerpc64/md.c: Likewise.
	* src/vm/jit/sparc64/md.c: Likewise.
	* src/vm/jit/x86_64/md.c: Likewise.

	* src/vm/jit/replace.c (replace_activate_replacement_points)
	[ENABLE_DISASSEMBLER]: Improved debug.
	(replace_deactivate_replacement_points) [ENABLE_DISASSEMBLER]:
	Likewise.
	[778ca7b0994f]

	* src/native/localref.c, src/native/localref.h, src/vm/jit/argument.c,
	src/vm/jit/argument.h, src/vm/jit/codegen-common.c:
	* src/native/localref.c [ENABLE_HANDLES] (localref_native_exit):
	Implemented. (localref_native_enter): Renamed from localref_fill.

	* src/native/localref.h (localref_native_exit): Added prototype.
	(localref_native_enter): Renamed from localref_fill.

	* src/vm/jit/argument.c (argument_jitreturn_store): Implemented.

	* src/vm/jit/argument.h (argument_jitreturn_store): Added prototype.

	* src/vm/jit/codegen-common.c (codegen_start_native_call): Improved
	comments and adapted to above changes. (codegen_finish_native_call):
	Likewise.
	[cb9745650425]

	* src/cacaoh/dummy.c:
	* src/cacaoh/dummy.c (llni_critical_start, llni_critical_end):
	Removed aborts.
	[e73922f2480c]

	* src/vm/signal.c:
	* src/vm/signal.c (signal_handle): Wrap and unwrap references
	correctly.
	[a9c206e70c58]

	* src/vm/jit/replace.c:
	* src/vm/jit/replace.c (replace_find_replacement_point_for_pc):
	Fixed assertion. (replace_me_wrapper): Simplified search for
	replacement point.
	[fd550f06fd83]

	* src/vm/jit/alpha/linux/md-os.c, src/vm/jit/x86_64/linux/md-os.c:
	* src/vm/jit/alpha/linux/md-os.c (md_replace_executionstate_write):
	Fixed compiler warning.

	* src/vm/jit/x86_64/linux/md-os.c (md_replace_executionstate_read):
	Implemented. (md_replace_executionstate_write): Likewise.
	[437c4ce74de8]

	* src/vm/jit/i386/arch.h, src/vm/jit/x86_64/arch.h:
	* src/vm/jit/i386/arch.h (REPLACEMENT_PATCH_SIZE): Adapted to new
	trap mcode.
	* src/vm/jit/x86_64/arch.h (REPLACEMENT_PATCH_SIZE): Likewise.
	[cdd632019391]

	* src/vm/jit/codegen-common.c, src/vm/jit/replace.c,
	src/vm/jit/replace.h, src/vm/signal.c:
	* src/vm/jit/codegen-common.c (codegen_set_replacement_point): Add
	NOPs if replacement testing mode is enabled.

	* src/vm/jit/replace.c (replace_me_wrapper): Finished
	implementation. (replace_me): Major code cleanup. Removed safestack
	stuff. (replace_build_execution_state): Likewise.
	(replace_activate_replacement_points): Adapted changes from previous
	rev. (replace_deactivate_replacement_points): Likewise.
	(replace_alloc_safestack): Removed. (replace_free_safestack):
	Removed.

	* src/vm/jit/replace.h (replace_safestack_t): Removed.
	(md_replace_executionstate_read): Added prototype.
	(md_replace_executionstate_write): Likewise.

	* src/vm/signal.c (signal_handle): Adapted to new
	replace_me_wrapper.
	[a97a8699e3f3]

	* src/vm/jit/alpha/linux/md-os.c, src/vm/jit/arm/linux/md-os.c,
	src/vm/jit/i386/darwin/md-os.c, src/vm/jit/i386/linux/md-os.c,
	src/vm/jit/m68k/linux/md-os.c, src/vm/jit/mips/irix/md-os.c,
	src/vm/jit/mips/linux/md-os.c, src/vm/jit/powerpc/darwin/md-os.c,
	src/vm/jit/powerpc/linux/md-os.c, src/vm/jit/powerpc64/linux/md-
	os.c, src/vm/jit/s390/md.c, src/vm/jit/sparc64/linux/md-os.c,
	src/vm/jit/sparc64/solaris/md-os.c, src/vm/jit/x86_64/linux/md-os.c,
	src/vm/signal.c, src/vm/signallocal.h:
	* src/vm/signallocal.h (signal_handle): Changed signature.

	* src/vm/signal.c (signal_handles): Create stackframeinfo here.

	* src/vm/jit/alpha/linux/md-os.c (md_signal_handler_sigsegv):
	Adapted to new signature and removed stackframeinfo creation.

	* src/vm/jit/arm/linux/md-os.c: Likewise.
	* src/vm/jit/i386/darwin/md-os.c: Likewise.
	* src/vm/jit/i386/linux/md-os.c: Likewise.
	* src/vm/jit/m68k/linux/md-os.c: Likewise.
	* src/vm/jit/mips/irix/md-os.c: Likewise.
	* src/vm/jit/mips/linux/md-os.c: Likewise.
	* src/vm/jit/powerpc/darwin/md-os.c: Likewise.
	* src/vm/jit/powerpc/linux/md-os.c: Likewise.
	* src/vm/jit/powerpc64/linux/md-os.c: Likewise.
	* src/vm/jit/s390/md.c: Likewise.
	* src/vm/jit/sparc64/linux/md-os.c: Likewise.
	* src/vm/jit/sparc64/solaris/md-os.c: Likewise.
	* src/vm/jit/x86_64/linux/md-os.c: Likewise.
	[60c0ebbe4e43]

2007-09-24  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/i386/asmpart.S, src/vm/jit/i386/cygwin/md-asm.h,
	src/vm/jit/i386/darwin/md-asm.h, src/vm/jit/mips/asmpart.S,
	src/vm/jit/powerpc/asmpart.S, src/vm/jit/powerpc/darwin/md-asm.h,
	src/vm/jit/powerpc64/asmpart.S, src/vm/jit/s390/asmpart.S,
	src/vm/jit/x86_64/asmpart.S:
	* src/vm/jit/i386/asmpart.S (asm_replacement_in,
	asm_replacement_out): Removed obsolete functions.

	* src/vm/jit/i386/cygwin/md-asm.h: Likewise.
	* src/vm/jit/i386/darwin/md-asm.h: Likewise.
	* src/vm/jit/mips/asmpart.S: Likewise.
	* src/vm/jit/powerpc/asmpart.S: Likewise.
	* src/vm/jit/powerpc/darwin/md-asm.h: Likewise.
	* src/vm/jit/powerpc64/asmpart.S: Likewise.
	* src/vm/jit/s390/asmpart.S: Likewise.
	* src/vm/jit/x86_64/asmpart.S: Likewise.
	[b740aa39a6b3]

	* src/vm/jit/i386/linux/md-os.c, src/vm/jit/m68k/emit.c:
	* src/vm/jit/m68k/emit.c (emit_replacement_stubs): Removed obsolete
	function.
	* src/vm/jit/i386/linux/md-os.c: Reordered functions in file.
	[ee8508729ad0]

	* src/vm/jit/alpha/md.c, src/vm/jit/i386/md.c, src/vm/jit/mips/md.c,
	src/vm/jit/powerpc/md.c, src/vm/jit/powerpc64/md.c,
	src/vm/jit/s390/md.c, src/vm/jit/sparc64/md.c,
	src/vm/jit/x86_64/md.c:
	* src/vm/jit/alpha/md.c (md_patch_replacement_point): Changed
	signature.

	* src/vm/jit/i386/md.c: Likewise.
	* src/vm/jit/mips/md.c: Likewise.
	* src/vm/jit/powerpc/md.c: Likewise.
	* src/vm/jit/powerpc64/md.c: Likewise.
	* src/vm/jit/s390/md.c: Likewise.
	* src/vm/jit/sparc64/md.c: Likewise.
	* src/vm/jit/x86_64/md.c: Likewise.
	[8607a4e4bab5]

	* src/vm/jit/jit.c, src/vmcore/options.c, src/vmcore/options.h:
	* src/vm/jit/jit.c (jit_compile_intern) [ENABLE_REPLACEMENT]:
	Activate replacement points after code generation if testing option
	is given.

	* src/vmcore/options.c [ENABLE_REPLACEMENT] (opt_TestReplacement):
	Added replacement testing option.

	* src/vmcore/options.h [ENABLE_REPLACEMENT] (opt_TestReplacement):
	Likewise.
	[b4b8349d4df5]

2007-09-23  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vmcore/statistics.c, src/vmcore/statistics.h:
	* src/vmcore/statistics.c (size_stacksize): New variable.
	(statistics_print_memory_usage): Print new variable.
	* src/vmcore/statistics.h (size_stacksize): Added.
	[9ffe8678ac20]

	* src/mm/memory.c, src/mm/memory.h:
	* src/mm/memory.c (memory_mprotect): New function.
	* src/mm/memory.h: Likewise.
	[9b7a3aee74a4]

	* src/vm/signal.c:
	* src/vm/signal.c (signal_handle): Fixed debug output.
	[18e1db4a4dd2]

	* src/threads/native/threads.c:
	* src/threads/native/threads.c (threads_impl_thread_start): Print
	error of return value (errno is not set by pthread functions).
	[1735a75ea91f]

	* src/threads/threads-common.c, src/vmcore/statistics.c,
	src/vmcore/statistics.h:
	* src/threads/threads-common.c (list_threads_free): Renamed to
	list_free_thread_index. (thread_index_t): New type.
	(threads_preinit): Initialize list_free_thread_index.
	(threads_thread_new): Use list_free_thread_index
	(threads_thread_free): Likewise and free the threadobject.

	* src/vmcore/statistics.c (stdint.h): Added. (size_thread_index_t):
	Likewise. (statistics_print_memory_usage): Print
	size_thread_index_t.
	* src/vmcore/statistics.h (stdint.h): Added. (size_thread_index_t):
	Likewise.
	[7938bddb23fe]

2007-09-22  Peter Molnar  <pm@complang.tuwien.ac.at>

	* src/vm/jit/codegen-common.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/s390/md-abi.c:
	* src/vm/jit/codegen-common.c (codegen_start_native_call,
	codegen_finish_native_call) [__S390__]: Adapted for s390.
	 * src/vm/jit/s390/codegen.c (codegen_emit_stub_native): Adapted for
	builtin stubs.
	 * src/vm/jit/s390/md-abi.c (md_param_alloc_native): On stack arguments
	are now already set off by the linkage area size.
	[cdba3e10f470]

	* src/vm/jit/s390/emit.c:
	* src/vm/jit/s390/emit.c (emit_verbosecall_enter,
	emit_verbosecall_exit): Adapted to modified trace_java_call_enter
	and trace_jave_call_exit.
	[b0b2a8ecfb7e]

2007-09-21  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* configure.ac, src/native/vm/sun/jvm.c:
	* configure.ac (AC_CHECK_FUNCS): Added getsockopt.

	* src/native/vm/sun/jvm.c (stdint.h): Added. (sys/types.h):
	Likewise. (JVM_HoldsLock): Implemented. (JVM_SocketAvailable):
	Likewise. (JVM_GetSockOpt): Likewise. (JVM_SetSockOpt)
	[HAVE_SETSOCKOPT]: Added #ifdef.
	[808f939f7d6c]

	* src/vm/jit/alpha/codegen.c:
	* src/vm/jit/alpha/codegen.c (codegen_emit_stub_native): Save and
	restore floats as float so the trace functions can print them
	correctly.
	[08f6e263bf88]

	* src/vmcore/options.c, src/vmcore/options.h:
	* src/vmcore/options.c (opt_DebugStackTrace): Changed type to int.
	(options_xx): Forgot to handle opt_DebugStackTrace.
	* src/vmcore/options.h (opt_DebugStackTrace): Changed type to int.
	[c6701c057d02]

2007-09-20  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vmcore/class.c:
	* src/vmcore/class.c [!NDEBUG]
	(class_classref_or_classinfo_println): Added missing #ifdef.
	[0216ea4e581b]

2007-09-19  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vmcore/loader.c, src/vmcore/utf8.c, src/vmcore/utf8.h:
	* src/vmcore/loader.c (loader_init): Don't use utf_java_lang_System.

	* src/vmcore/utf8.c (utf_java_lang_System): Removed. (utf8_init):
	Likewise.
	* src/vmcore/utf8.h: Likewise.
	[3c0f5dc5dd40]

	* src/vm/exceptions.c, src/vm/exceptions.h, src/vm/vm.c:
	* src/vm/exceptions.c (exceptions_init): Changed return value to
	void, removed class_java_lang_Throwable loading and linking.
	(exceptions_throw_linkageerror): Removed unused variable o.

	* src/vm/exceptions.h (exceptions_init): Changed return value to
	void. (new_exception_utfmessage): Removed.

	* src/vm/vm.c (vm_create): Don't check return value of
	exceptions_init.
	[c91eb1105dd8]

	* src/cacaoh/dummy.c, src/vm/exceptions.c, src/vm/initialize.c,
	src/vmcore/class.c, src/vmcore/class.h, src/vmcore/linker.c,
	src/vmcore/loader.c, src/vmcore/utf8.c, src/vmcore/utf8.h:
	* src/cacaoh/dummy.c (vm_initializing): Added.

	* src/vm/exceptions.c (exceptions_init): Removed all class loads and
	links. (exceptions_abort): New function. (exceptions_new_class):
	Removed. (exceptions_throw_class): Likewise.
	(exceptions_new_class_utf): Likewise. (exceptions_throw_class_utf):
	Likewise. (exceptions_throw_classnotfoundexception): Use
	exceptions_throw_utf_utf. (exceptions_throw_noclassdeffounderror):
	Likewise. (exceptions_throw_linkageerror): Likewise.
	(exceptions_throw_nosuchmethoderror): Likewise.
	(exceptions_throw_unsatisfiedlinkerror: Likewise.
	(exceptions_new_classcastexception): Use exceptions_new_utf_utf.
	(exceptions_throw_outofmemoryerror): Use exceptions_throw_utf.
	(exceptions_throw_nullpointerexception): Likewise.
	(exceptions_new_nullpointerexception): Use exceptions_new_utf.
	(exceptions_classnotfoundexception_to_noclassdeffounderror): Load
	java/lang/ClassNotFoundException explicitly.

	* src/vm/initialize.c (initialize_class_intern): Load
	java/lang/Exception explicitly.

	* src/vmcore/class.c (class_java_lang_Error): Removed.
	(class_java_lang_LinkageError): Likewise.
	(class_java_lang_NoClassDefFoundError): Likewise.
	(class_java_lang_OutOfMemoryError): Likewise.
	(class_java_lang_VirtualMachineError): Likewise.
	(class_java_lang_Exception): Likewise.
	(class_java_lang_ClassCastException): Likewise.
	(class_java_lang_ClassNotFoundException): Likewise.
	* src/vmcore/class.h: Likewise.

	* src/vmcore/linker.c (linker_init): Added class_java_lang_Throwable
	and class_java_lang_VMThrowable.

	* src/vmcore/loader.c (loader_preinit): Don't check for error on
	load_class_bootstrap, this is now done in the exception functions.
	(loader_init): Likewise. (load_class_bootstrap): Removed
	utf_java_lang_Object check.

	* src/vmcore/utf8.c (utf_java_lang_VMThrowable): Removed.
	* src/vmcore/utf8.h: Likewise.
	[f6e46b5abdac]

	* src/vm/properties.c, src/vm/properties.h:
	* src/vm/properties.c (properties_dump): New function.
	* src/vm/properties.h: Likewise.
	[3fe0447f57b7]

2007-09-18  Mathias Panzenboeck  <panzi@complang.tuwien.ac.at>

	* doc/Makefile.am, doc/annotations.tex, doc/jsr.bib:
	* doc/Makefile.am (dist_noinst_DATA): Added annotations.tex and
	jsr.bib (annotations): New target which creates annotations.dvi
	(clean): Clean the annotations.aux/.bbl/.dvi/... files.

	* doc/annotations.tex: New file. This is the documentation of the
	annotations support implementation.

	* doc/jsr.bib: New file. Contains bibtex reference for JSR202.
	[cbc7fae03947]

2007-09-18  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/cacaoh/cacaoh.c, src/vm/vm.c, src/vm/vm.h, src/vmcore/linker.c,
	src/vmcore/options.c, src/vmcore/options.h:
	* src/cacaoh/cacaoh.c (main): Removed linkverbose.

	* src/vm/vm.c (vm_printconfig): Made static. (vm_create): Call
	vm_printconfig after the VM is initialized.
	* src/vm/vm.h (vm_printconfig): Removed.

	* src/vmcore/linker.c (TRACELINKCLASS): New macro.
	(link_class_intern): Use TRACELINKCLASS.

	* src/vmcore/options.c (linkverbose): Removed. (opt_TraceLinkClass):
	Added. (options_xx): OPT_PrintConfig: Don't call vm_printconfig,
	OPT_TraceLinkClass: Added.
	* src/vmcore/options.h (linkverbose): Removed. (opt_TraceLinkClass):
	Added.
	[b6b94c056c1d]

	* src/vm/jit/patcher-common.c:
	* src/vm/jit/patcher-common.c (patcher_handler) [!NDEBUG]: #ifdef'ed
	debug output.
	[c61a9af5c9b5]

	* src/threads/native/lock.c:
	* src/threads/native/lock.c (lock_record_notify): Ignore already
	signaled threads.
	[2c60bb7d3a11]

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (JVM_GetClassAccessFlags): Use
	TRACEJVMCALLS.
	[6d11c71489c9]

2007-09-17  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* configure.ac, src/native/vm/sun/jvm.c:
	* configure.ac (AC_CHECK_FUNCS): Added fsync.
	* src/native/vm/sun/jvm.c (JVM_Sync): Implemented.
	[3bd273a402ef]

	* src/native/vm/sun_misc_Unsafe.c:
	* src/native/vm/sun_misc_Unsafe.c (staticFieldOffset): Return 0.
	(staticFieldBase): Return the pointer to value.
	[0e6f95db8141]

2007-09-16  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/vm/gnu/java_lang_VMClass.c,
	src/native/vm/java_lang_Class.c, src/native/vm/java_lang_Class.h,
	src/native/vm/sun/jvm.c, src/vmcore/class.c, src/vmcore/class.h:
	* src/native/vm/gnu/java_lang_VMClass.c (getModifiers): Use
	class_get_modifiers.
	* src/native/vm/sun/jvm.c (JVM_GetClassModifiers): Likewise.

	* src/native/vm/java_lang_Class.c (class_get_modifiers): Removed.
	* src/native/vm/java_lang_Class.h: Likewise.

	* src/vmcore/class.c (class_get_modifiers): New function.
	* src/vmcore/class.h: Likewise.
	[3438316160b3]

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (JVM_GetStackAccessControlContext): Use
	TRACEJVMCALLS. (JVM_AssertionStatusDirectives): Likewise.
	[3fcf29d58b0f]

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (JVM_IsThreadAlive): Use LLNI_equals.
	[86b85d556a58]

	* * Merged with 5a268f292149.
	[07d1c81692ee]

	* src/native/jni.c:
	* src/native/jni.c (_Jv_JNI_NewWeakGlobalRef): Use TRACEJNICALLS.
	(_Jv_JNI_DeleteWeakGlobalRef): Likewise.
	[741ac9cf4529]

2007-09-16  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* src/native/llni.h:
	* src/native/llni.h (LLNI_equals): Added macro.
	[5a268f292149]

2007-09-16  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/cacaoh/dummy.c, src/native/vm/sun/jvm.c, src/vm/Makefile.am,
	src/vm/package.c, src/vm/package.h, src/vm/vm.c,
	src/vmcore/loader.c, src/vmcore/options.c, src/vmcore/options.h:
	* src/cacaoh/dummy.c (package_add): New function.

	* src/native/vm/sun/jvm.c (vm/package.h): Added.
	(JVM_GetSystemPackage): Implemented.

	* src/vm/Makefile.am (libvm_la_SOURCES): Added package.[ch].

	* src/vm/package.c: New file.
	* src/vm/package.h: Likewise.

	* src/vm/vm.c (vm/package.h): Added. (vm_create): Call package_init.

	* src/vmcore/loader.c (vm/package.h): Added. (load_class_bootstrap):
	Call package_add.

	* src/vmcore/options.c (opt_DebugPackage): Added. (options_xx):
	Likewise.
	* src/vmcore/options.h (opt_DebugPackage): Added.
	[e91bea6d1b62]

	* src/threads/native/threads.c:
	* src/threads/native/threads.c (threads_detach_thread): Notify all
	threads waiting on the Java thread-object.
	[db035cf768f7]

	* src/mm/nogc.c:
	* src/mm/nogc.c [HAVE_SYS_MMAN_H] (sys/mman.h): Added #ifdef.
	(heap_alloc_uncollectable): Added additional parameter for
	heap_alloc. (gc_init) [HAVE_MMAP]: Added #ifdef.
	[231910498e40]

2007-09-15  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vmcore/class.c:
	* src/vmcore/class.c (class_set_packagename): Added '/' to the
	internal package name.
	[44ff14c3e9a6]

	* src/native/vm/cldc1.1/java_lang_Thread.c,
	src/native/vm/java_lang_Thread.c, src/native/vm/java_lang_Thread.h,
	src/native/vm/sun/jvm.c:
	* src/native/vm/java_lang_Thread.c (isAlive): Removed.
	* src/native/vm/java_lang_Thread.h: Likewise.

	* src/native/vm/cldc1.1/java_lang_Thread.c (stdint.h): Added.
	(isAlive): Use threads_thread_is_alive.

	* src/native/vm/sun/jvm.c (JVM_IsThreadAlive): Likewise.
	[bc11be8a1e7c]

2007-09-14  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/vm.c:
	* src/vm/vm.c (vm_array_from_objectarray): TYPE_LNG: Added missing
	primitive_type_get_by_wrapperclass to get type (fixes JBoss).
	[395643eaf5e9]

	* src/vm/vm.c:
	* src/vm/vm.c (vm_array_from_objectarray): Removed illegal_arg label
	and throw exception directly. This makes it easier for debugging
	and newer compilers can optimize that.
	[2b62829628e6]

	* src/threads/threads-common.c, src/threads/threads-common.h:
	* src/threads/threads-common.c (threads_thread_state_runnable):
	Don't change the state if the current state is
	THREAD_STATE_TERMINATED. (threads_thread_state_waiting): Likewise.
	(threads_thread_state_timed_waiting): Likewise.
	(threads_thread_is_alive): Smaller changes.
	* src/threads/threads-common.h (threads_thread_is_alive): Likewise.
	[1307fac97706]

	* src/threads/native/lock.c, src/vmcore/options.c,
	src/vmcore/options.h:
	* src/threads/native/lock.c (LOCK_LOG): Removed. (DEBUGLOCKS): New
	macro. (lock_record_new): Added DEBUGLOCKS. (lock_record_free):
	Likewise. (lock_hashtable_grow): Likewise. (lock_hashtable_get):
	Likewise. (lock_inflate): Likewise. (lock_monitor_enter): Likewise.
	(lock_monitor_exit): Likewise. (lock_record_wait): Likewise.
	(lock_record_notify): Likewise.

	* src/vmcore/options.c (opt_DebugLocks): Added. (options_xx):
	Likewise.
	* src/vmcore/options.h (opt_DebugLocks): Added.
	[ab953b0c5ac1]

	* src/native/vm/sun_misc_Unsafe.c:
	* src/native/vm/sun_misc_Unsafe.c (getShort): New function.
	(putLong): Likewise. (getDouble): Likewise. (putDouble): Likewise.
	[d4deff26f6d1]

	* src/threads/native/lock.c, src/threads/native/lock.h:
	* src/threads/native/lock.c (toolbox/list.h): Added.
	(lock_record_t): Create waiters list. (lock_record_free): Free
	waiters list. (lock_record_add_waiter): Use list.
	(lock_record_remove_waiter): Likewise. (lock_record_notify):
	Likewise.

	* src/threads/native/lock.h (toolbox/list.h): Added.
	(lock_waiter_t): Removed next, added linkage. (lock_record_t):
	Changed waiters to a list_t.
	[ff6d5c593e7f]

	* src/vm/jit/codegen-common.c:
	* src/vm/jit/codegen-common.c [WITH_CLASSPATH_SUN]
	(native/include/java_lang_Object.h,
	native/include/java_lang_String.h,
	native/include/java_nio_ByteBuffer.h,
	native/include/java_lang_ClassLoader.h): Added.
	[d04eadb70c7f]

2007-09-14  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* src/vmcore/annotation.c:
	* src/vmcore/annotation.c: Fixed comment.
	[3bc1be6d9164]

2007-09-14  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/threads/native/threads.c:
	* src/threads/native/threads.c (threads_wait_with_timeout): Renamed
	thread to t.
	[00f8940164ee]

2007-09-13  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/toolbox/list.c, src/toolbox/list.h:
	* src/toolbox/list.c (list_free): New function. (list_lock):
	Likewise. (list_unlock): Likewise.
	* src/toolbox/list.h: Likewise.
	[70f5642b3e83]

	* src/vm/exceptions.c, src/vmcore/options.c, src/vmcore/options.h:
	* src/vm/exceptions.c (exceptions_get_exception): Simplyfied.
	(exceptions_set_exception): Added debug output.
	(exceptions_clear_exception): Use explicit implementation and added
	debug output. (exceptions_get_and_clear_exception): Only clear when
	an exception is set.

	* src/vmcore/options.c (opt_DebugExceptions): Added. (options_xx):
	Likewise.
	* src/vmcore/options.h: Likewise.
	[8456a18d18be]

2007-09-13  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/threads/native/lock.c:
	* src/threads/native/lock.c (lock_record_wait): No longer throws and
	exception but returns a boolean value indicating the interruption.
	(lock_monitor_enter): Ignore interruption of lock_record_wait.
	(lock_monitor_wait): Throw an exception if interrupted.
	[3433056d2e6e]

2007-09-13  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/cacaoh/headers.h, src/threads/native/threads.h,
	src/threads/none/threads.h, src/vm/exceptions.c,
	src/vm/jit/inline/inline.c:
	* src/cacaoh/headers.h (_exceptionptr): Removed.

	* src/threads/native/threads.h (exceptionptr): Removed.
	* src/threads/none/threads.h: Likewise.

	* src/vm/exceptions.c (exceptions_get_exception): Rewritten to use
	threadobject directly. (exceptions_set_exception): Likewise.

	* src/vm/jit/inline/inline.c (inline_transform)
	[INLINE_VERIFY_RESULT]: Use exceptions_clear_exception.
	[3bd4728a8c59]

2007-09-13  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/arm/asmpart.S:
	* src/vm/jit/arm/asmpart.S (asm_exceptionptr): Removed.
	[f6cbcaf2f4fc]

2007-09-13  tbfg  <tbfg@localhost.localdomain>

	* src/vm/jit/powerpc64/asmpart.S:
	Removed misleading comment about copying stuff from linux kernel.
	This was true, but the implementation has been removed and the ppc
	solution was adapted for pp64.
	[5f48da04a418]

2007-09-13  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/show.c, src/vm/vm.c, src/vmcore/options.c,
	src/vmcore/options.h:
	* src/vm/vm.c (vm_create): Removed obsolete -se option.
	* src/vm/jit/show.c (show_method): No longer show exception stubs.
	* src/vmcore/options.c (opt_showexceptionstubs): Removed.
	* src/vmcore/options.h (opt_showexceptionstubs): Likewise.
	[76dad440809f]

	* src/vm/jit/arm/codegen.c, src/vm/jit/arm/codegen.h:
	* src/vm/jit/arm/codegen.h: Major code cleanup and support VFP
	instructions.
	* src/vm/jit/arm/codegen.c: Adapted to above changes.
	[979eaad7469b]

	* src/native/vm/sun/jvm.c, src/vm/jit/s390/codegen.c, src/vm/vm.c,
	src/vmcore/options.c, src/vmcore/options.h:
	* Merged with michi branch at rev 21fd42e049a3.
	[4d32767b4c1d]

	* src/vm/builtintable.inc:
	* src/vm/builtintable.inc (builtintable_internal): Create builtin
	stubs for LOCK_monitor_enter and LOCK_monitor_exit, because they
	throw exceptions. This will slow down Cacao, we need the fast-path
	or inline those builtins!
	[21fd42e049a3]

	* src/vm/jit/arm/asmpart.S:
	* src/vm/jit/arm/asmpart.S (asm_cacheflush): Code cleanup and
	support for EABI syscall calling conventions.
	[4933a3684852]

2007-09-12  Peter Molnar  <pm@complang.tuwien.ac.at>

	* src/vm/jit/s390/codegen.c:
	* src/vm/jit/s390/codegen.c (codegen_emit_stub_native): Replaced N_*
	code generation macros by alpha-like M_* ones.
	[5a4e35cb3ab5]

2007-09-12  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* src/vmcore/annotation.c:
	* src/vmcore/annotation.c (LLNI_objectarray_copy): Removed macro.
	(annotation_bytearrays_resize): Use MCOPY instead of my own macro.
	[86a989abbdea]

2007-09-12  Peter Molnar  <pm@complang.tuwien.ac.at>

	* src/vm/jit/s390/asmpart.S, src/vm/jit/s390/codegen.c,
	src/vm/jit/s390/codegen.h, src/vm/jit/s390/emit.c,
	src/vm/jit/s390/emit.h, src/vm/jit/s390/md-abi.c, src/vm/jit/s390
	/md-abi.h, src/vm/jit/s390/md-asm.h, src/vm/jit/s390/md.c:
	* src/vm/jit/s390/asmpart.S src/vm/jit/s390/codegen.c,
	src/vm/jit/s390/codegen.h, src/vm/jit/s390/emit.c,
	src/vm/jit/s390/emit.h, src/vm/jit/s390/md-abi.c, src/vm/jit/s390
	/md-abi.h, src/vm/jit/s390/md-asm.h, src/vm/jit/s390/md.c: Changed
	JIT ABI on s390: R0 is now REG_ITMP3, R12 is a saved register,
	REG_ITMPs are reordered, REG_ITMP1_XPTR is now REG_ITMP3_XPTR,
	REG_ITMP2_XPC is now REG_ITMP1_XPC.
	[75ecbbddead3]

2007-09-12  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* src/native/llni.h, src/vmcore/annotation.c, src/vmcore/class.c,
	src/vmcore/class.h, src/vmcore/field.c, src/vmcore/method.c:
	* src/native/llni.h (LLNI_classinfo_field_get): New macro.
	(LLNI_classinfo_field_set): Likewise.

	* src/vmcore/annotation.c (LLNI_objectarray_copy): New macro. This
	macro will be replaced by a appropriate array_* function once such a
	function exists. (annotation_bytearrays_resize): Use above macro and
	improved variable naming. (annotation_bytearrays_insert): Changed
	type of parameter 1 and return type and improved variable naming.
	(annotation_load_attribute_body): Use LLNI_CRITICAL_START and
	LLNI_CRITICAL_END.
	(annotation_load_method_attribute_annotationdefault): Use
	LLNI_classinfo_field_get and LLNI_classinfo_field_set macros. (annot
	ation_load_method_attribute_runtimevisibleparameterannotations):
	Likewise.
	(annotation_load_method_attribute_runtimevisibleannotations):
	Likewise.
	(annotation_load_field_attribute_runtimevisibleannotations):
	Likewise.
	(annotation_load_class_attribute_runtimevisibleannotations): Use
	LLNI_classinfo_field_set macro.

	* src/vmcore/class.c (class_get_annotations): Use
	LLNI_classinfo_field_get macro.

	* src/vmcore/class.h (classinfo.annotations),
	(classinfo.method_annotations),
	(classinfo.method_parameterannotations),
	(classinfo.method_annotationdefaults),
	(classinfo.field_annotations): Changed type to java_object_t*.

	* src/vmcore/field.c (native/llni.h): Added include.
	(field_get_annotations): Use LLNI_classinfo_field_get macro.

	* src/vmcore/method.c (method_get_annotations): Use
	LLNI_classinfo_field_get macro. (method_get_parameterannotations):
	Likewise. (method_get_annotationdefault): Likewise.
	[b49f32206108]

2007-09-12  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/jni.c, src/native/jni.h, src/native/vm/sun/jvm.c,
	src/vm/vm.c:
	* src/native/jni.c (jni_version_check): New function.
	* src/native/jni.h: Likewise.

	* src/native/vm/sun/jvm.c (JVM_IsSupportedJNIVersion): Use
	jni_version_check.
	* src/vm/vm.c (vm_create): Likewise.
	[6b9b172f7f02]

	* src/vm/vm.c:
	* src/vm/vm.c (vm_create): Initialize properties list before
	handling
	-XX options handling.
	[066d4ccbfde9]

	* src/vm/properties.c, src/vm/vm.c, src/vmcore/options.c,
	src/vmcore/options.h:
	* src/vm/properties.c (properties_add) [!NDEBUG]: Added debug
	output.

	* src/vm/vm.c (opts): Removed XX. (vm_create): Call options_xx
	almost as first function, so we can enable debugging from all stuff.

	* src/vmcore/options.c (opt_DebugProperties): New option.
	(options_xx): Changed signature and parse all options in the array.
	* src/vmcore/options.h (opt_DebugProperties): Added. (options_xx):
	Changed signature.
	[313f2b9ea69f]

2007-09-12  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/threads/native/threads.c, src/vm/jit/mips/codegen.c:
	* src/threads/native/threads.c: Renamed bogus __MIPS__ ifdefs to
	__IRIX__.

	* src/vm/jit/mips/codegen.c (codegen_emit): Fixed ICMD_BUILTIN stub
	calling. (codegen_emit_stub_native): Adapted to new signature and
	builtin stubs.
	[3e3a6881ae1e]

2007-09-12  Peter Molnar  <pm@complang.tuwien.ac.at>

	* Merged 7484:52fc709fd248.
	[ab50703b66af]

	* src/vm/jit/s390/asmpart.S, src/vm/jit/s390/codegen.c,
	src/vm/jit/s390/md-abi.c, src/vm/jit/s390/md-abi.h, src/vm/jit/s390
	/md-asm.h:
	* src/vm/jit/s390/codegen.c (codegen_emit_stub_native): Changed some
	N_MOV to M_MOV.
	* src/vm/jit/s390/asmpart.S, src/vm/jit/s390/md-asm.h, src/vm/jit/s390
	/md-abi.h, src/vm/jit/s390/md-abi.c: Reverted [7237:9a2ce00b716e]
	where f4 and f6 were made callee saved.
	[2842827952fd]

2007-09-12  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/patcher-common.c, src/vmcore/options.c,
	src/vmcore/options.h:
	* src/vm/jit/patcher-common.c: Improved comments. (patcher_handler):
	Enabled use of -XX:+DebugPatcher.

	* src/vmcore/options.c (opt_DebugPatcher): Added and set by above
	debug flag.
	* src/vmcore/options.h (opt_DebugPatcher): Added.
	[52fc709fd248]

	* src/vm/jit/alpha/codegen.c, src/vm/jit/arm/codegen.c, src/vm/jit
	/codegen-common.c:
	* src/vm/jit/alpha/codegen.c (codegen_emit_stub_builtin): Removed.
	(codegen_emit_stub_native): Adapted to new signature and builtins.

	* src/vm/jit/arm/codegen.c (codegen_emit_stub_native): Adapted to
	new signature.

	* src/vm/jit/alpha/codegen.c (codegen_start_native_call)
	[__ALPHA__]: Call tracing is done from here now.
	(codegen_finish_native_call) [__ALPHA__]: Likewise.
	[75ee30764b92]

2007-09-12  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/vm/Makefile.am,
	src/native/vm/gnu/java_util_concurrent_atomic_AtomicLong.c,
	src/native/vm/java_util_concurrent_atomic_AtomicLong.c,
	src/native/vm/java_util_concurrent_atomic_AtomicLong.h,
	src/native/vm/sun/jvm.c:
	* src/native/vm/Makefile.am
	(JAVA_UTIL_CONCURRENT_ATOMIC_ATOMICLONG_SOURCES): Removed.
	(libnativevm_la_SOURCES): Removed
	JAVA_UTIL_CONCURRENT_ATOMIC_ATOMICLONG_SOURCES.

	* src/native/vm/gnu/java_util_concurrent_atomic_AtomicLong.c
	(native/vm/java_util_concurrent_atomic_AtomicLong.h): Removed.
	(native/include/java_util_concurrent_atomic_AtomicLong.h): Added.
	(methods): VMSupportsCS8: Use
	Java_java_util_concurrent_atomic_AtomicLong_VMSupportsCS8.
	(Java_java_util_concurrent_atomic_AtomicLong_VMSupportsCS8): New
	function.

	* src/native/vm/sun/jvm.c
	(native/vm/java_util_concurrent_atomic_AtomicLong.h): Removed.
	(JVM_SupportsCX8): Just return 0 for now.

	* src/native/vm/java_util_concurrent_atomic_AtomicLong.c: Removed.
	* src/native/vm/java_util_concurrent_atomic_AtomicLong.h: Likewise.
	[063194d7fa99]

	* src/native/vm/cldc1.1/java_lang_Class.c,
	src/native/vm/gnu/java_lang_VMClass.c,
	src/native/vm/java_lang_Class.c, src/native/vm/java_lang_Class.h:
	* src/native/vm/cldc1.1/java_lang_Class.c (methods): isInterface:
	Use Java_java_lang_Class_isInterface. (isInterface): New function.

	* src/native/vm/gnu/java_lang_VMClass.c (vm/exceptions.h): Added.
	(vm/stringlocal.h): Likewise. (isInterface): Use class_is_interface.
	(getInterfaces): Use class_get_interfaces. (getDeclaredClasses): Use
	class_get_declaredclasses. (throwException): Use
	exceptions_set_exception. (getClassSignature): Implemented directly.

	* src/native/vm/java_lang_Class.c (isInterface): Removed.
	(getInterfaces): Likewise. (getDeclaredClasses): Likewise.
	(throwException): Likewise. (getClassSignature): Likewise.
	* src/native/vm/java_lang_Class.h: Likewise.
	[7b4ace71939e]

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (JVM_GetClassSignature): Use
	LLNI_classinfo_unwrap and java_handle_t.
	[e95f6b9676ca]

2007-09-12  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* src/native/vm/java_lang_Class.c:
	* Merged with default branch at rev 8806c9bebf3e.
	[f30b107daf01]

	* src/lib/gnu/java/lang/reflect/Constructor.java,
	src/lib/gnu/java/lang/reflect/Field.java,
	src/lib/gnu/java/lang/reflect/Method.java,
	src/lib/gnu/sun/reflect/annotation/AnnotationParser.java,
	src/lib/gnu/sun/reflect/annotation/AnnotationType.java,
	src/native/vm/gnu/java_lang_reflect_Constructor.c,
	src/native/vm/gnu/java_lang_reflect_Field.c,
	src/native/vm/gnu/java_lang_reflect_Method.c,
	src/native/vm/gnu/sun_reflect_ConstantPool.c,
	src/native/vm/java_lang_Class.c, src/native/vm/reflect.c,
	src/native/vm/sun/jvm.c, src/vmcore/annotation.c,
	src/vmcore/class.c, src/vmcore/field.c, src/vmcore/method.c,
	src/vmcore/utf8.c, tests/regression/MinimalClassReflection.java:
	* src/vmcore/annotation.c: Improved comments.
	(annotation_bytearrays_resize), (annotation_bytearrays_insert),
	(annotation_load_method_attribute_annotationdefault), (annotation_lo
	ad_method_attribute_runtimevisibleparameterannotations),
	(annotation_load_class_attribute_runtimevisibleannotations),
	(annotation_load_method_attribute_runtimevisibleannotations),
	(annotation_load_field_attribute_runtimevisibleannotations):
	Restructured so that when it comes to the point when I have to use
	LLNI macros for accessing the java objects I store in classinfo I
	will have not much to do.

	* src/lib/gnu/java/lang/reflect/Constructor.java: Improved comments.
	* src/lib/gnu/java/lang/reflect/Field.java: Likewise.
	* src/lib/gnu/java/lang/reflect/Method.java: Likewise.
	* src/lib/gnu/sun/reflect/annotation/AnnotationParser.java: Likewise.
	* src/lib/gnu/sun/reflect/annotation/AnnotationType.java: Likewise.
	* src/native/vm/gnu/java_lang_reflect_Constructor.c: Likewise.
	* src/native/vm/gnu/java_lang_reflect_Field.c: Likewise.
	* src/native/vm/gnu/java_lang_reflect_Method.c: Likewise.
	* src/native/vm/gnu/sun_reflect_ConstantPool.c: Likewise.
	* src/native/vm/java_lang_Class.c: Likewise.
	* src/native/vm/reflect.c: Likewise.
	* src/native/vm/sun/jvm.c: Likewise.
	* src/vmcore/class.c: Likewise.
	* src/vmcore/field.c: Likewise.
	* src/vmcore/method.c: Likewise.
	* src/vmcore/utf8.c: Likewise.
	* tests/regression/MinimalClassReflection.java: Likewise.
	[ddc0f25c5fad]

2007-09-11  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/vm/gnu/java_lang_VMClass.c,
	src/native/vm/java_lang_Class.c, src/native/vm/java_lang_Class.h:
	* src/native/vm/gnu/java_lang_VMClass.c (getSuperclass): Use
	class_get_superclass.
	* src/native/vm/java_lang_Class.c (getSuperclass): Removed.
	* src/native/vm/java_lang_Class.h: Likewise.
	[8806c9bebf3e]

	* src/native/vm/gnu/java_lang_VMClass.c,
	src/native/vm/java_lang_Class.c, src/native/vm/java_lang_Class.h:
	* src/native/vm/gnu/java_lang_VMClass.c (isPrimitive): Use
	class_is_primitive.
	* src/native/vm/java_lang_Class.c (isPrimitive): Removed.
	* src/native/vm/java_lang_Class.h: Likewise.
	[11d19ca12473]

2007-09-11  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/native/vm/gnu/gnu_classpath_VMSystemProperties.c,
	src/vm/properties.c:
	* src/vm/properties.c (properties_set) [WITH_JRE_LAYOUT]: Fixed old
	variable.
	* src/native/vm/gnu/gnu_classpath_VMSystemProperties.c
	(Java_gnu_classpath_VMSystemProperties_postInit) [WITH_JRE_LAYOUT]:
	Likewise.
	[bbd10f4c3e87]

	* src/vm/jit/arm/patcher.c, src/vm/jit/mips/codegen.c:
	* Merged with default branch at rev bac772081960.
	[26f4007804bb]

	* src/vm/jit/arm/disass.c, src/vm/jit/arm/linux/md-os.c,
	src/vm/jit/disass.h:
	* src/vm/jit/disass.h (global.h): Added.

	* src/vm/jit/arm/disass.c (disass_pseudo_instr): Implemented.
	(disassinstr): Call above function.

	* src/vm/jit/arm/linux/md-os.c (md_signal_handler_sigill): Better
	debug output.
	[c41a6282ec30]

	* src/vm/jit/codegen-common.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c:
	* src/vm/jit/codegen-common.c (codegen_generate_stub_compiler):
	Stubs are generated for all archs now. [__POWERPC64__]: Enabled
	tracing of native and builtin stubs.

	* src/vm/jit/powerpc/codegen.c (codegen_emit_stub_native): Adapted
	to new signature.

	* src/vm/jit/powerpc64/codegen.c (codegen_emit_stub_native):
	Likewise. Removed tracing code. Rewrote argument register saving and
	restoring code.
	[808d21867a99]

2007-09-11  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/mips/codegen.c:
	* src/vm/jit/mips/codegen.c (codegen_emit_stub_native): Fixed offset
	of result saving and restoring (hint: MIPS32 has a PA).
	[bac772081960]

2007-09-11  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/alpha/codegen.c, src/vm/jit/m68k/codegen.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/s390/codegen.c, src/vm/jit/sparc64/codegen.c:
	* src/vm/jit/alpha/codegen.c (codegen_emit): ICMD_BUILTIN no longer
	checks for exceptions, this is done by the stub itself. Stubs are
	called now.

	* src/vm/jit/m68k/codegen.c: Likewise.
	* src/vm/jit/mips/codegen.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/s390/codegen.c: Likewise.
	* src/vm/jit/sparc64/codegen.c: Likewise.
	[cc75afc2b563]

2007-09-11  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/codegen-common.c, src/vm/jit/codegen-common.h,
	src/vm/jit/i386/codegen.c, src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/codegen-common.c (codegen_generate_stub_builtin): Set
	skipparams and pass it to codegen_emit_stub_native.
	(codegen_generate_stub_native): Likewise.
	* src/vm/jit/codegen-common.h (codegen_emit_stub_native): Changed
	signature.

	* src/vm/jit/i386/codegen.c (codegen_emit): ICMD_BUILTIN: Removed
	emit_exception_check. (codegen_emit_stub_builtin): Removed.
	(codegen_emit_stub_native): Changed signature.
	* src/vm/jit/x86_64/codegen.c: Likewise.
	[001bda7ec5c8]

2007-09-08  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/x86_64/patcher.c:
	* src/vm/jit/x86_64/patcher.c (patcher_resolve_native_function):
	Removed.
	[fc26f752bd43]

	* src/vm/jit/patcher-common.h, src/vm/jit/x86_64/asmpart.S,
	src/vm/jit/x86_64/codegen.c, src/vm/jit/x86_64/codegen.h,
	src/vm/jit/x86_64/emit.c, src/vm/jit/x86_64/linux/md-os.c,
	src/vm/jit/x86_64/patcher.c, src/vm/signal.c, src/vm/signallocal.h:
	* src/vm/jit/patcher-common.h: Added __X86_64__ ifdef.
	* src/vm/signal.c (signal_init): Likewise.
	* src/vm/signallocal.h: Likewise.

	* src/vm/jit/x86_64/asmpart.S (asm_patcher_wrapper): Removed.

	* src/vm/jit/x86_64/codegen.c (vm/jit/patcher.h): Removed. (vm/jit
	/patcher-common.h): Added. (codegen_emit): Implemented patchers-by-
	signal and load data from data segment instead of moving inline.
	(codegen_emit_stub_native): Likewise. (codegen_emit_stub_compiler):
	Quick hack for ALD.

	* src/vm/jit/x86_64/codegen.h (PATCHER_CALL_SIZE): Changed to 2.
	(PATCHER_NOPS): Likewise. (M_ALD): Handle RIP properly.

	* src/vm/jit/x86_64/emit.c (vm/jit/patcher-common.h): Added.
	(emit_patcher_stubs): Removed. (emit_trap): Emit UD2.

	* src/vm/jit/x86_64/linux/md-os.c (md_signal_handler_sigill): New
	function.

	* src/vm/jit/x86_64/patcher.c (vm/jit/patcher.h): Removed. (vm/jit
	/patcher-common.h): Added. (patcher_wrapper): Removed.
	(PATCH_BACK_ORIGINAL_MCODE): New macro. (patcher_patch_code): New
	function. (patcher_resolve_classref_to_classinfo): Likewise.
	(patcher_resolve_classref_to_vftbl): Likewise.
	(patcher_resolve_classref_to_flags): Likewise.
	(patcher_resolve_native_function): Likewise. (patcher_aconst):
	Removed. (patcher_builtin_multianewarray): Likewise.
	(patcher_builtin_arraycheckcast): Likewise.
	(patcher_checkcast_instanceof_flags): Likewise.
	(patcher_checkcast_class): Likewise. (patcher_instanceof_class):
	Likewise. (patcher_clinit): Likewise. (patcher_athrow_areturn):
	Likewise. (patcher_resolve_native): Likewise.
	[1aca46b07127]

	* src/vm/jit/patcher-common.c:
	* src/vm/jit/patcher-common.c (patcher_add_patch_ref): Added
	lastmcodeptr code. This can be removed when we don't use UD2 on i386
	and x86_64 anymore.
	[3adba9571bcd]

2007-09-08  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/alpha/patcher.c, src/vm/jit/arm/patcher.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/i386/patcher.c,
	src/vm/jit/mips/patcher.c, src/vm/jit/patcher-common.c,
	src/vm/jit/powerpc/patcher.c, src/vm/jit/powerpc64/patcher.c,
	src/vm/jit/s390/patcher.c:
	* src/vm/jit/i386/codegen.c (codegen_emit_stub_native): Loads
	function pointer from data segment now.

	* src/vm/jit/patcher-common.c (patcher_resolve_native_function):
	Implemented generalized version.

	* src/vm/jit/alpha/patcher.c (patcher_resolve_native_function):
	Removed obsolete function.

	* src/vm/jit/arm/patcher.c: Likewise.
	* src/vm/jit/i386/patcher.c: Likewise.
	* src/vm/jit/mips/patcher.c: Likewise.
	* src/vm/jit/powerpc/patcher.c: Likewise.
	* src/vm/jit/powerpc64/patcher.c: Likewise.
	* src/vm/jit/s390/patcher.c: Likewise.
	[18dcc80c8e9e]

	* src/vm/jit/alpha/md.c, src/vm/jit/arm/md.c:
	* src/vm/jit/alpha/md.c (md_dcacheflush): Added dummy function.
	* src/vm/jit/arm/md.c (md_dcacheflush): Does nothing now.
	[4fff503b29e5]

2007-09-07  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/alpha/patcher.c, src/vm/jit/arm/patcher.c,
	src/vm/jit/i386/patcher.c, src/vm/jit/mips/patcher.c, src/vm/jit
	/patcher-common.c, src/vm/jit/patcher-common.h,
	src/vm/jit/powerpc/patcher.c, src/vm/jit/powerpc64/patcher.c,
	src/vm/jit/s390/patcher.c:
	* src/vm/jit/patcher-common.h (patcher_patch_code): Added prototype.

	* src/vm/jit/patcher-common.c (patcher_handle) [TRACE_PATCHER]:
	Improved debug. (patcher_initialize_class): Implemented generalized
	version. (patcher_resolve_class): Likewise.

	* src/vm/jit/alpha/patcher.c (patcher_patch_code): Implemented.
	(patcher_initialize_class): Removed obsolete patcher function.
	(patcher_resolve_class): Likewise.

	* src/vm/jit/arm/patcher.c: Likewise.
	* src/vm/jit/i386/patcher.c: Likewise.
	* src/vm/jit/mips/patcher.c: Likewise.
	* src/vm/jit/powerpc/patcher.c: Likewise.
	* src/vm/jit/powerpc64/patcher.c: Likewise.
	* src/vm/jit/s390/patcher.c: Likewise.
	[876be29c51a6]

2007-09-08  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/arm/codegen.c, src/vm/jit/arm/patcher.c:
	* src/vm/jit/arm/codegen.c: Removed patcher NOPs creation, this is
	done by the patcher_add_patch_ref function itself.

	* src/vm/jit/arm/patcher.c: Patcher NOPs are triggered by the
	opt_shownops flag.
	[2855f422cb84]

	* src/vm/jit/arm/codegen.c:
	* src/vm/jit/arm/codegen.c (codegen_emit_stub_builtin): Removed.
	(codegen_emit_stub_native): Deals with builtin stubs as well now.
	[5914becb88b2]

	* src/vm/jit/codegen-common.c, src/vm/jit/codegen-common.h,
	src/vm/vm.c, src/vmcore/options.c, src/vmcore/options.h:
	* src/vm/jit/codegen-common.c (codegen_disassemble_stub): Renamed
	and works with builtin stubs as well.
	(codegen_generate_stub_builtin) [ENABLE_DISASSEMBLER]: Stub gets
	disassembled. (codegen_generate_stub_native) [ENABLE_DISASSEMBLER]:
	Likewise.

	* src/vm/jit/codegen-common.h (codegen_disassemble_stub): Renamed.

	* src/vm/vm.c: Removed old option flag opt_shownativestub.

	* src/vmcore/options.h [ENABLE_DISASSEMBLER] (opt_DisassembleStubs):
	Added.

	* src/vmcore/options.c [ENABLE_DISASSEMBLER] (opt_DisassembleStubs):
	Added and included into options list.
	[cc83f2f16624]

2007-09-08  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/x86_64/patcher.c:
	* src/vm/jit/x86_64/patcher.c (patcher_resolve_native_function):
	Removed.
	[bbee0a3c3f34]

	* src/vm/jit/patcher-common.h, src/vm/jit/x86_64/asmpart.S,
	src/vm/jit/x86_64/codegen.c, src/vm/jit/x86_64/codegen.h,
	src/vm/jit/x86_64/emit.c, src/vm/jit/x86_64/linux/md-os.c,
	src/vm/jit/x86_64/patcher.c, src/vm/signal.c, src/vm/signallocal.h:
	* src/vm/jit/patcher-common.h: Added __X86_64__ ifdef.
	* src/vm/signal.c (signal_init): Likewise.
	* src/vm/signallocal.h: Likewise.

	* src/vm/jit/x86_64/asmpart.S (asm_patcher_wrapper): Removed.

	* src/vm/jit/x86_64/codegen.c (vm/jit/patcher.h): Removed. (vm/jit
	/patcher-common.h): Added. (codegen_emit): Implemented patchers-by-
	signal and load data from data segment instead of moving inline.
	(codegen_emit_stub_native): Likewise. (codegen_emit_stub_compiler):
	Quick hack for ALD.

	* src/vm/jit/x86_64/codegen.h (PATCHER_CALL_SIZE): Changed to 2.
	(PATCHER_NOPS): Likewise. (M_ALD): Handle RIP properly.

	* src/vm/jit/x86_64/emit.c (vm/jit/patcher-common.h): Added.
	(emit_patcher_stubs): Removed. (emit_trap): Emit UD2.

	* src/vm/jit/x86_64/linux/md-os.c (md_signal_handler_sigill): New
	function.

	* src/vm/jit/x86_64/patcher.c (vm/jit/patcher.h): Removed. (vm/jit
	/patcher-common.h): Added. (patcher_wrapper): Removed.
	(PATCH_BACK_ORIGINAL_MCODE): New macro. (patcher_patch_code): New
	function. (patcher_resolve_classref_to_classinfo): Likewise.
	(patcher_resolve_classref_to_vftbl): Likewise.
	(patcher_resolve_classref_to_flags): Likewise.
	(patcher_resolve_native_function): Likewise. (patcher_aconst):
	Removed. (patcher_builtin_multianewarray): Likewise.
	(patcher_builtin_arraycheckcast): Likewise.
	(patcher_checkcast_instanceof_flags): Likewise.
	(patcher_checkcast_class): Likewise. (patcher_instanceof_class):
	Likewise. (patcher_clinit): Likewise. (patcher_athrow_areturn):
	Likewise. (patcher_resolve_native): Likewise.
	[0d8acddb33d2]

	* src/vm/jit/patcher-common.c:
	* src/vm/jit/patcher-common.c (patcher_add_patch_ref): Added
	lastmcodeptr code. This can be removed when we don't use UD2 on i386
	and x86_64 anymore.
	[5f39dedf7b68]

2007-09-08  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/alpha/patcher.c, src/vm/jit/arm/patcher.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/i386/patcher.c,
	src/vm/jit/mips/patcher.c, src/vm/jit/patcher-common.c,
	src/vm/jit/powerpc/patcher.c, src/vm/jit/powerpc64/patcher.c,
	src/vm/jit/s390/patcher.c:
	* src/vm/jit/i386/codegen.c (codegen_emit_stub_native): Loads
	function pointer from data segment now.

	* src/vm/jit/patcher-common.c (patcher_resolve_native_function):
	Implemented generalized version.

	* src/vm/jit/alpha/patcher.c (patcher_resolve_native_function):
	Removed obsolete function.

	* src/vm/jit/arm/patcher.c: Likewise.
	* src/vm/jit/i386/patcher.c: Likewise.
	* src/vm/jit/mips/patcher.c: Likewise.
	* src/vm/jit/powerpc/patcher.c: Likewise.
	* src/vm/jit/powerpc64/patcher.c: Likewise.
	* src/vm/jit/s390/patcher.c: Likewise.
	[8586d2a077ef]

	* src/vm/jit/alpha/md.c, src/vm/jit/arm/md.c:
	* src/vm/jit/alpha/md.c (md_dcacheflush): Added dummy function.
	* src/vm/jit/arm/md.c (md_dcacheflush): Does nothing now.
	[8b25e9581736]

	* * Merged with default branch at rev ce451bbfaf18.
	[a001beae1804]

2007-09-07  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/alpha/patcher.c, src/vm/jit/arm/patcher.c,
	src/vm/jit/i386/patcher.c, src/vm/jit/mips/patcher.c, src/vm/jit
	/patcher-common.c, src/vm/jit/patcher-common.h,
	src/vm/jit/powerpc/patcher.c, src/vm/jit/powerpc64/patcher.c,
	src/vm/jit/s390/patcher.c:
	* src/vm/jit/patcher-common.h (patcher_patch_code): Added prototype.

	* src/vm/jit/patcher-common.c (patcher_handle) [TRACE_PATCHER]:
	Improved debug. (patcher_initialize_class): Implemented generalized
	version. (patcher_resolve_class): Likewise.

	* src/vm/jit/alpha/patcher.c (patcher_patch_code): Implemented.
	(patcher_initialize_class): Removed obsolete patcher function.
	(patcher_resolve_class): Likewise.

	* src/vm/jit/arm/patcher.c: Likewise.
	* src/vm/jit/i386/patcher.c: Likewise.
	* src/vm/jit/mips/patcher.c: Likewise.
	* src/vm/jit/powerpc/patcher.c: Likewise.
	* src/vm/jit/powerpc64/patcher.c: Likewise.
	* src/vm/jit/s390/patcher.c: Likewise.
	[5912fd263053]

	* src/vm/jit/i386/asmpart.S, src/vm/jit/i386/codegen.c,
	src/vm/jit/i386/codegen.h, src/vm/jit/i386/emit.c,
	src/vm/jit/i386/linux/md-os.c, src/vm/jit/i386/patcher.c, src/vm/jit
	/patcher-common.h, src/vm/jit/patcher.h, src/vm/signal.c,
	src/vm/signallocal.h:
	* src/vm/jit/i386/emit.c (emit_patcher_stubs): Removed, this is
	obsolete. (emit_trap): Fixed trap instruction.

	* src/vm/jit/i386/asmpart.S (asm_patcher_wrapper): Removed, this is
	obsolete.

	* src/vm/jit/i386/patcher.c: Adapted patchers to new signature for
	traps. (patcher_wrapper): Removed, this is obsolete.

	* src/vm/jit/i386/codegen.h (PATCHER_CALL_SIZE, PATCHER_NOPS):
	Adapted to new trap instruction.

	* src/vm/jit/i386/codegen.c (codegen_emit,
	codegen_emit_stub_native): Call the new patcher functions via traps
	and adapted to above change.

	* src/vm/jit/i386/linux/md-os.c (md_signal_handler_sigill):
	Implemented.

	* src/vm/jit/patcher-common.h [__I386__]: Enabled new patcher stuff.

	* src/vm/jit/patcher.h [__I386__]: Defined away old patcher stuff.

	* src/vm/signal.c (signal_init) [__I386__]: Install SIGILL handler
	now.

	* src/vm/signallocal.h [__I386__] (md_signal_handler_sigill):
	Enabled prototype.
	[ce451bbfaf18]

2007-09-07  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* * Merged with 79e3a1932e59.
	[7d26a3fdc72c]

	* src/vm/jit/x86_64/codegen.h, src/vm/jit/x86_64/emit.c,
	src/vm/jit/x86_64/emit.h:
	* src/vm/jit/x86_64/codegen.h (M_BYTE1, M_BYTE2): New macros.
	(M_UD2): Added. (M_RET, M_NOP): Use M_BYTE1.

	* src/vm/jit/x86_64/emit.c (emit_ret): Removed. (emit_nop):
	Likewise.
	* src/vm/jit/x86_64/emit.h: Likewise.
	[5f0db0ae7ffe]

2007-09-07  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vmcore/loader.c:
	* src/vmcore/loader.c (load_class_from_classloader): Fixed
	classloader issues.
	[79e3a1932e59]

	* src/native/vm/cldc1.1/java_lang_System.c,
	src/native/vm/gnu/java_lang_VMSystem.c, src/native/vm/sun/jvm.c,
	src/vm/builtin.c, src/vm/builtin.h:
	* src/vm/builtin.c (builtin_arraycopy): Returns void instead of bool
	now.
	* src/vm/builtin.h (builtin_arraycopy): Adapted signature.
	* src/native/vm/cldc1.1/java_lang_System.c: Removed obsolete void
	case.
	* src/native/vm/gnu/java_lang_VMSystem.c: Likewise.
	* src/native/vm/sun/jvm.c: Likewise.
	[e8610bdc4cd2]

	* src/vm/jit/powerpc/codegen.c:
	* src/vm/jit/powerpc/codegen.c (codegen_emit): Removed exception
	check for ICMD_BUILTIN because of the new stubs.
	(codegen_emit_stub_builtin): Removed obsolete function.
	(codegen_emit_stub_native): Checks for m->flags instead of nmd being
	NULL.
	[29c6007441f2]

	* src/vm/jit/codegen-common.c, src/vm/jit/codegen-common.h:
	* src/vm/jit/codegen-common.c (codegen_generate_stub_compiler): Pass
	bte->md to native stub emmiter. (codegen_stub_builtin_enter):
	Removed. (codegen_stub_builtin_exit): Likewise.

	* src/vm/jit/codegen-common.h: Removed obsolete prototypes.
	[c4eab7fd33e2]

	* src/vm/jit/powerpc/codegen.c:
	* src/vm/jit/powerpc/codegen.c (codegen_emit_stub_native): Ported
	for builtins.
	[9fd540662096]

	* src/vm/jit/trace.c:
	* src/vm/jit/trace.c (trace_java_call_enter): Can handle m->class ==
	NULL now and prints flag for builtin method stubs.
	(trace_java_call_exit): Likewise.
	[d5d8d96798c5]

	* src/vm/jit/codegen-common.c:
	* src/vm/jit/codegen-common.c (codegen_generate_stub_builtin): Calls
	same emmiter function as for native methods now.
	(codegen_stub_builtin_enter): Disabled. (codegen_stub_builtin_exit):
	Disabled.
	[3a5220bcb252]

	* src/vmcore/method.h:
	* src/vmcore/method.h (method_new_builtin): Fixed typo in function
	prototype.
	[63861f87010d]

	* src/vm/jit/stacktrace.c:
	* src/vm/jit/stacktrace.c (stacktrace_create): Skip entries for
	builtin stubs.
	[4e96d91ad089]

	* src/vm/builtin.c, src/vm/builtin.h, src/vm/jit/codegen-common.c,
	src/vm/jit/codegen-common.h, src/vmcore/method.c,
	src/vmcore/method.h:
	* src/vm/builtin.c (builtintable_init): Create methodinfos for
	builtins.
	* src/vm/builtin.h (builtintable_entry): Added forward typedef.
	* src/vmcore/method.h (method_new_builtin): Added prototype.
	* src/vmcore/method.c (method_new_builtin): Implemented.
	* src/vm/jit/codegen-common.h (codegen_generate_stub_builtin): Changed
	sig.
	* src/vm/jit/codegen-common.c (codegen_generate_stub_builtin): Pass
	methodinfo.
	[e3cc0027dbdd]

2007-09-06  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/native/localref.c, src/vm/jit/Makefile.am,
	src/vm/jit/argument.c, src/vm/jit/argument.h, src/vm/jit/trace.c:
	* src/vm/jit/argument.c: Added file for argument array handling.
	* src/vm/jit/argument.h: Likewise.

	* src/vm/jit/Makefile.am (libjit_la_SOURCES): Added above two files.

	* src/vm/jit/trace.c: Moved array handling functions to argument.c
	and adapted to new name and signature.

	* src/native/localref.c (localref_fill): Likewise.
	[f596a20dd95f]

	* src/vm/jit/powerpc64/patcher.c:
	* src/vm/jit/powerpc64/patcher.c: Removed obsolete patcher
	functions.
	[90715e4cfa31]

	* src/native/vm/gnu/gnu_classpath_VMStackWalker.c, src/vmcore/class.c,
	src/vmcore/loader.c, src/vmcore/loader.h:
	* src/vmcore/loader.h (classloader) [!ENABLE_HANDLES]: Classloader
	is a object.

	* src/vmcore/loader.c (loader_hashtable_classloader_add)
	[!ENABLE_HANDLES]: Return classloader object instead of entry. Added
	some debug output. (loader_hashtable_classloader_find): Likewise.

	* src/vmcore/class.c (class_get_classloader): No need to
	differentiate between handles or not-handles.

	* src/native/vm/gnu/gnu_classpath_VMStackWalker.c: Fixed bogus
	classloader usages.
	[0b269fbf04cd]

2007-09-06  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/native.c:
	* src/native/native.c (native_resolve_function): Use
	class_get_classloader.
	[7d5cec8c47b8]

2007-09-06  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/patcher-common.h, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/powerpc64/patcher.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/s390/patcher.c:
	* src/vm/jit/patcher-common.h: Removed obsolete patcher function
	defines.

	* src/vm/jit/powerpc64/codegen.c: Used newer patcher function names.
	* src/vm/jit/powerpc64/patcher.c: Likewise.
	* src/vm/jit/s390/codegen.c: Likewise.
	* src/vm/jit/s390/patcher.c: Likewise.
	[81ec7f8de378]

	* src/vm/jit/patcher-common.h, src/vm/jit/patcher.h,
	src/vm/jit/powerpc64/asmpart.S, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/powerpc64/emit.c, src/vm/jit/powerpc64/linux/md-os.c,
	src/vm/jit/powerpc64/patcher.c:
	* src/vm/jit/powerpc64/emit.c (emit_patcher_stubs): Removed, this is
	obsolete. (emit_trap): Fixed trap instruction:

	* src/vm/jit/powerpc64/codegen.c (codegen_emit,
	codegen_emit_stub_native): Call the new patcher functions and
	adapted to above change.

	* src/vm/jit/powerpc64/patcher.c: Adapted patchers to new signature
	for traps. (patcher_wrapper): Removed, this is obsolete.

	* src/vm/jit/powerpc64/asmpart.S (asm_patcher_wrapper): Removed,
	this is obsolete.

	* src/vm/jit/powerpc64/linux/md-os.c (md_signal_handler_sigsegv):
	Only calls the exception handling if exception object present.

	* src/vm/jit/patcher-common.h [__POWERPC64__]: Enabled new patcher
	stuff.

	* src/vm/jit/patcher.h [__POWERPC64__]: Defined away old patcher
	stuff.
	[6bc2f1d20c58]

2007-09-06  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* * Merged with 269162803388.
	[5cb77df28b85]

	* src/native/vm/Makefile.am, src/native/vm/cldc1.1/java_lang_Object.c,
	src/native/vm/gnu/java_lang_VMObject.c,
	src/native/vm/java_lang_Object.c, src/native/vm/java_lang_Object.h,
	src/native/vm/sun/jvm.c:
	* src/native/vm/Makefile.am (libnativevm_la_SOURCES): Removed
	java_lang_Object.[ch].

	* src/native/vm/java_lang_Object.c: Removed.
	* src/native/vm/java_lang_Object.h: Likewise.

	* src/native/vm/cldc1.1/java_lang_Object.c
	(native/vm/java_lang_Object.h): Removed. (threads/lock-common.h):
	Added. (vm/exceptions.h): Likewise. (getClass): Use LLNI_class_get.
	(notify): Use lock_notify_object. (notifyAll): Use
	lock_notify_all_object. (wait): Use lock_wait_for_object.

	* src/native/vm/gnu/java_lang_VMObject.c (native/llni.h): Added.
	(native/vm/java_lang_Object.h): Removed. (threads/lock-common.h):
	Added. (vm/builtin.h): Likewise. (vm/exceptions.h): Likewise.
	(getClass): Use LLNI_class_get. (clone): Use builtin_clone.
	(notify): Use lock_notify_object. (notifyAll): Use
	lock_notify_all_object. (wait): Use lock_wait_for_object.

	* src/native/vm/sun/jvm.c (native/vm/java_lang_Object.h): Removed.
	(JVM_MonitorWait): Use lock_wait_for_object. (JVM_MonitorNotify):
	Use lock_notify_object. (JVM_MonitorNotifyAll): Use
	lock_notify_all_object.
	[483fb5dd71d3]

2007-09-05  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/codegen-common.c, src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/codegen-common.c (codegen_start_native_call)
	[__X86_64__]: Tracer for native methods is called from here now.
	(codegen_finish_native_call) [__X86_64__]: Likewise.

	* src/vm/jit/x86_64/codegen.c (codegen_emit_stub_native): Removed
	verbosecall tracer.
	[269162803388]

	* src/vm/jit/alpha/codegen.c, src/vm/jit/arm/codegen.c, src/vm/jit
	/codegen-common.c, src/vm/jit/codegen-common.h,
	src/vm/jit/i386/codegen.c, src/vm/jit/m68k/codegen.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/codegen-common.h (codegen_finish_native_call): Changes
	signature.

	* src/vm/jit/codegen-common.c (codegen_finish_native_call): Takes
	the same arguments as the enter pendant now.

	* src/vm/jit/alpha/codegen.c (codegen_emit_stub_native): Adapted to
	new signature mentioned above.

	* src/vm/jit/arm/codegen.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/m68k/codegen.c: Likewise.
	* src/vm/jit/mips/codegen.c: Likewise.
	* src/vm/jit/powerpc/codegen.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/s390/codegen.c: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.
	[3d7dd4ddb484]

	* src/vm/jit/codegen-common.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc/emit.c, src/vm/jit/trace.c:
	* src/vm/jit/codegen-common.c (codegen_start_native_call)
	[__POWERPC__]: Tracer for native methods is called from here now.

	* src/vm/jit/powerpc/codegen.c (codegen_emit_stub_native): Removed
	verbosecall enter tracer.

	* src/vm/jit/powerpc/emit.c (emit_verbosecall_enter,
	emit_verbosecall_exit): Adapted to new tracer functions.

	* src/vm/jit/trace.c (_array_load_param, _array_load_return_value):
	Optimized passing of register arguments.
	[75c295a0dd45]

2007-09-05  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* src/native/vm/gnu/sun_reflect_ConstantPool.c,
	src/native/vm/sun/jvm.c, tests/regression/jasmin/runtest,
	tests/regression/jasmin/show:
	* changed src/native/vm/sun/jvm.c: Throw IllegalArgumentException in
	all ConstantPool.get*At(int) methods as expected by OpenJDK.

	* changed src/native/vm/gnu/sun_reflect_ConstantPool.c: Likewise.
	[614a7af9d894]

2007-09-05  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/vm/gnu/java_lang_VMClass.c,
	src/native/vm/java_lang_Class.c, src/native/vm/java_lang_Class.h:
	* src/native/vm/java_lang_Class.c (getDeclaringClass): Removed.
	* src/native/vm/java_lang_Class.h: Likewise.
	* src/native/vm/gnu/java_lang_VMClass.c (getDeclaringClass): Use
	class_get_declaringclass.
	[4481d9c381a3]

	* src/native/vm/cldc1.1/java_lang_Class.c,
	src/native/vm/gnu/java_lang_VMClass.c,
	src/native/vm/java_lang_Class.c, src/native/vm/java_lang_Class.h:
	* src/native/vm/java_lang_Class.c (isArray): Removed.
	* src/native/vm/java_lang_Class.h: Likewise.
	* src/native/vm/cldc1.1/java_lang_Class.c (isArray): New function.
	* src/native/vm/gnu/java_lang_VMClass.c (isArray): Use class_is_array.
	[10a1c5e2a7ca]

	* src/vm/jit/mips/linux/md-os.c:
	* src/vm/jit/mips/linux/md-os.c (mm/memory.h): Added. (md_init): Use
	int instead of u1 for GCNEW.
	[88289982f1fd]

	* configure.ac, m4/debug.m4, m4/dump.m4, m4/gc.m4, m4/intrp.m4:
	* configure.ac (AC_CHECK_ENABLE_INTRP): Added. (AC_CHECK_ENABLE_GC):
	Likewise. (AC_CHECK_ENABLE_DEBUG): Likewise. (AC_CHECK_ENABLE_DUMP):
	Likewise.

	* m4/debug.m4: New file.
	* m4/dump.m4: Likewise.
	* m4/gc.m4: Likewise.
	* m4/intrp.m4: Likewise.
	[9af6482b9325]

	* configure.ac, src/cacao/Makefile.am, src/cacao/cacao.c,
	src/native/Makefile.am, src/native/include/Makefile.am,
	src/native/native.c, src/native/native.h,
	src/native/tools/Makefile.am, src/native/tools/gennativetable.c,
	src/vm/jit/alpha/codegen.c, src/vm/jit/alpha/patcher.c,
	src/vm/jit/arm/codegen.c, src/vm/jit/arm/patcher.c,
	src/vm/jit/i386/codegen.c, src/vm/jit/i386/patcher.c,
	src/vm/jit/intrp/java.vmg, src/vm/jit/intrp/patcher.c,
	src/vm/jit/jit.c, src/vm/jit/m68k/codegen.c,
	src/vm/jit/m68k/patcher.c, src/vm/jit/mips/codegen.c,
	src/vm/jit/mips/patcher.c, src/vm/jit/patcher-common.h,
	src/vm/jit/patcher.h, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc/patcher.c, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/powerpc64/patcher.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/s390/patcher.c, src/vm/jit/sparc64/codegen.c,
	src/vm/jit/sparc64/patcher.c, src/vm/jit/x86_64/codegen.c,
	src/vm/jit/x86_64/patcher.c, src/vm/properties.c:
	* configure.ac (static-classpath): Removed.

	* src/cacao/Makefile.am, src/native/Makefile.am,
	src/native/include/Makefile.am: Removed WITH_STATIC_CLASSPATH if's.

	* src/native/native.c (native_findfunction): Removed.
	* src/native/native.h (nativeref, nativecompref): Removed.
	(native_findfunction): Removed.

	* src/native/tools/Makefile.am: Removed.
	* src/native/tools/gennativetable.c: Likewise.

	* src/cacao/cacao.c, src/vm/jit/alpha/codegen.c,
	src/vm/jit/alpha/patcher.c, src/vm/jit/arm/codegen.c,
	src/vm/jit/arm/patcher.c, src/vm/jit/i386/codegen.c,
	src/vm/jit/i386/patcher.c, src/vm/jit/intrp/java.vmg,
	src/vm/jit/intrp/patcher.c, src/vm/jit/jit.c,
	src/vm/jit/m68k/codegen.c, src/vm/jit/m68k/patcher.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/mips/patcher.c, src/vm/jit
	/patcher-common.h, src/vm/jit/patcher.h,
	src/vm/jit/powerpc/codegen.c, src/vm/jit/powerpc/patcher.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/powerpc64/patcher.c,
	src/vm/jit/s390/codegen.c, src/vm/jit/s390/patcher.c,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/sparc64/patcher.c,
	src/vm/jit/x86_64/codegen.c, src/vm/jit/x86_64/patcher.c,
	src/vm/properties.c: Removed WITH_STATIC_CLASSPATH #ifdef's.
	[d2a378158a66]

2007-09-05  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/mm/cacao-gc/gc.c, src/mm/cacao-gc/heap.c, src/mm/cacao-
	gc/rootset.c, src/vmcore/options.c, src/vmcore/options.h:
	* src/mm/cacao-gc/rootset.c (rootset_readout): Ignore threads in
	state new.

	* src/mm/cacao-gc/heap.c (heap_alloc): Wrap reference befor
	returning. (heap_alloc_intern): Respect stress-test option flag.

	* src/mm/cacao-gc/gc.c (gc_collect): Respect debug rootset option
	flag.

	* src/vmcore/options.h [ENABLE_GC_CACAO] (opt_GCDebugRootSet):
	Added. [ENABLE_GC_CACAO] (opt_GCStress): Likewise.

	* src/vmcore/options.c (options_xx) [ENABLE_GC_CACAO]: Parse above
	two options.
	[2e34e2e4d7ce]

2007-09-05  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* * Merged with 3aaaa9f60c5d.
	[ec7e530caf47]

	* * Merge with 405cda264bce.
	[9216d09f671d]

	* * Not sure what this commit should do, let's see.
	[8a98984ca196]

	* src/native/vm/gnu/java_lang_VMClass.c,
	src/native/vm/java_lang_Class.c, src/native/vm/java_lang_Class.h,
	src/native/vm/sun/jvm.c, src/vmcore/class.c, src/vmcore/class.h:
	* src/vmcore/class.c (class_get_classloader): New function.
	* src/vmcore/class.h: Likewise.
	* src/native/vm/java_lang_Class.c
	(_Jv_java_lang_Class_getClassLoader): Removed.
	* src/native/vm/java_lang_Class.h: Likewise.
	* src/native/vm/gnu/java_lang_VMClass.c (getClassLoader): Use
	class_get_classloader.
	* src/native/vm/sun/jvm.c (JVM_GetClassLoader): Likewise.
	[bd4ae591dcc4]

2007-09-05  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/native/llni.h, src/native/vm/reflect.c, src/vm/builtin.c:
	* src/native/llni.h: Fixed a lot of compiler warnings.

	* src/native/vm/reflect.c (reflect_field_new): Removed bogus cast.
	(reflect_method_new): Likewise.

	* src/vm/builtin.c (builtin_multianewarray): Fixed compiler warning.
	[3aaaa9f60c5d]

	* src/vm/jit/alpha/codegen.c, src/vm/jit/arm/codegen.c, src/vm/jit
	/codegen-common.c, src/vm/jit/codegen-common.h,
	src/vm/jit/i386/codegen.c, src/vm/jit/m68k/codegen.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/codegen-common.c (codegen_start_native_call): Return
	class argument for static native methods.

	* src/vm/jit/codegen-common.h (codegen_start_native_call): Adapted
	signature.

	* src/vm/jit/alpha/codegen.c (codegen_emit_stub_native): Class
	argument is no longer placed onto the data segment.

	* src/vm/jit/arm/codegen.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/m68k/codegen.c: Likewise.
	* src/vm/jit/mips/codegen.c: Likewise.
	* src/vm/jit/powerpc/codegen.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/s390/codegen.c: Likewise.
	* src/vm/jit/sparc64/codegen.c: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.
	[405cda264bce]

	* src/vm/exceptions.c:
	* src/vm/exceptions.c (exceptions_handle_exception): Restructured to
	create sfi.
	[f23b2db94198]

	* src/mm/cacao-gc/heap.h, src/mm/cacao-gc/mark.c:
	* src/mm/cacao-gc/heap.h (FOREACH_OBJECT_REF): Adapted to new
	classinfo->super.
	* src/mm/cacao-gc/mark.c (mark_recursive): Likewise.
	[ba936361b758]

	* src/native/localref.c, src/native/localref.h, src/vm/jit/codegen-
	common.c, src/vm/jit/trace.c:
	* src/native/localref.h (localref_fill): Added prototype.

	* src/native/localref.c (localref_fill): Implemented.
	(localref_frame_push): Fixed compiler warning. (_array_store_param):
	Added temporarily.

	* src/vm/jit/trace.c (_array_load_param): Made non-static.

	* src/vm/jit/codegen-common.c (codegen_start_native_call): Call
	localref_fill.
	[ded869549a11]

2007-09-05  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* * Merged with 291b838f1aed.
	[575e21f5ffea]

	* tests/regression/jasmin/runtest, tests/regression/jasmin/show:
	* tests/regression/jasmin/runtest: Make executable.
	* tests/regression/jasmin/show: Likewise.
	[a1b55f522e0d]

2007-09-04  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/codegen-common.c, src/vm/jit/powerpc/codegen.c:
	* src/vm/jit/codegen-common.c (codegen_generate_stub_builtin): Added
	workaround for builtins returning booleans to indicate exceptions.

	* src/vm/jit/powerpc/codegen.c (codegen_emit_stub_builtin):
	Workaround was moved to codegen-common.c to keep codegens clean.
	[291b838f1aed]

	* src/native/vm/sun_misc_Unsafe.c:
	* src/native/vm/sun_misc_Unsafe.c (Java_sun_misc_Unsafe_defineClass)
	[ENABLE_HANDLES]: Fixed array access.
	(Java_sun_misc_Unsafe_allocateInstance): Fixed compiler warning.
	[37c9348bdbe5]

2007-09-04  edwin  <edwin@localhost.localdomain>

	* src/vmcore/class.c:
	* src/vmcore/class.c (classref_or_classinfo_println): Fixed infinite
	recursion.
	[4c27eb92e935]

2007-09-04  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* tests/regression/native/testarguments.c:
	* tests/regression/native/testarguments.c: Adapted testcase to
	support handles.
	[59b815ba5555]

	* src/vm/jit/alpha/codegen.c, src/vm/jit/arm/codegen.c, src/vm/jit
	/codegen-common.c, src/vm/jit/codegen-common.h,
	src/vm/jit/i386/codegen.c, src/vm/jit/m68k/codegen.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/s390/codegen.c,
	src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/codegen-common.h (codegen_start_native_call): Changed
	signature.

	* src/vm/jit/codegen-common.c (codegen_start_native_call): Takes
	less arguments now and computes values by itself. This makes the
	codegens simpler.

	* src/vm/jit/alpha/codegen.c (codegen_emit_stub_native): Adapted to
	new signature mentioned above.

	* src/vm/jit/arm/codegen.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/m68k/codegen.c: Likewise.
	* src/vm/jit/mips/codegen.c: Likewise.
	* src/vm/jit/powerpc/codegen.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/s390/codegen.c: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.
	[109ce828d62d]

	* tests/gc/NativeGlobalRef.java, tests/gc/native.c:
	* tests/gc/NativeGlobalRef.java: Improved testcase.
	* tests/gc/native.c: Likewise.
	[12a8c1a6d1a7]

2007-09-03  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/native/localref.c:
	* src/native/localref.c (localref_del): Go through all local frames.
	[c492fcf2fcc8]

	* src/vm/exceptions.c:
	src/vm/exceptions.c (exceptions_asm_new_abstractmethoderror): Unwrap
	exception.
	[72076f9da934]

	* src/vm/jit/stacktrace.c, src/vmcore/options.c:
	* src/vm/jit/stacktrace.c (stacktrace_create): Enabled
	-XX:+DebugStackTrace.
	* src/vmcore/options.c (options_XX): Added some descriptions.
	[d2642fe48c1d]

2007-09-03  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/jni.c:
	* src/native/jni.c (_Jv_JNI_DetachCurrentThread): We need to pop all
	frames before we can destroy the table.
	[07bc83b81257]

	* src/vm/jit/trace.c:
	* src/vm/jit/trace.c (native/jni.h): Added.
	[6f33e8199e8a]

	* src/vm/jit/codegen-common.c, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc/linux/md-os.c:
	* src/vm/jit/codegen-common.c (codegen_generate_stub_builtin)
	[__POWERPC__]: Define added.
	* src/vm/jit/powerpc/codegen.c (codegen_emit): ICMD_BUILTIN: Use stub.
	(codegen_emit_stub_builtin): New function.
	(codegen_emit_stub_native): Fixed some offsets.
	* src/vm/jit/powerpc/linux/md-os.c (md_signal_handler_sigusr1): New
	function.
	[60976e6fae32]

2007-09-03  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* merge with branch e6c59621d39a
	[3912aedf3af4]

	* tests/regression/TestAnnotations.java:
	* tests/regression/TestAnnotations.java: Removed umlauts.
	[55d7d537bef0]

2007-09-03  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (JVM_FindClassFromClassLoader): Add CL to
	hashtable. (JVM_DefineClassWithSource): Likewise.
	(JVM_FindLoadedClass): Likewise.
	[e6c59621d39a]

	* src/vm/builtin.c, src/vm/exceptions.c, src/vm/jit/trace.c,
	src/vm/jit/trace.h:
	* src/vm/builtin.c (methodindent, callcount): Removed static
	variables. (builtin_throw_exception): Use trace_exception_builtin.
	(builtin_verbosecall_enter): Use thread-specific variables.
	(builtin_verbosecall_exit): Likewise.

	* src/vm/exceptions.c (exceptions_handle_exception): Fixed
	methodindent for java call traces.

	* src/vm/jit/trace.c: Added comments and minor cleanups.
	(trace_exception_builtin): Implemented (moved from builtin.c).

	* src/vm/jit/trace.h (trace_exception_builtin): Added prototype.
	[9e9d2b28cfea]

	* src/vm/jit/powerpc/emit.c:
	* src/vm/jit/powerpc/emit.c (emit_verbosecall_exit) [__DARWIN__]:
	Fixed passing of methodinfo argument.
	[a64cbc7fdf34]

	* src/vm/builtin.c, src/vm/builtin.h, src/vm/builtintable.inc,
	src/vm/exceptions.h, src/vm/jit/alpha/codegen.c,
	src/vm/jit/alpha/emit.c, src/vm/jit/arm/codegen.c,
	src/vm/jit/arm/emit.c, src/vm/jit/emit-common.h,
	src/vm/jit/i386/codegen.c, src/vm/jit/i386/emit.c,
	src/vm/jit/m68k/codegen.c, src/vm/jit/m68k/emit.c,
	src/vm/jit/mips/codegen.c, src/vm/jit/mips/emit.c,
	src/vm/jit/powerpc/codegen.c, src/vm/jit/powerpc/emit.c,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/powerpc64/emit.c,
	src/vm/jit/s390/codegen.c, src/vm/jit/s390/emit.c,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/sparc64/emit.c,
	src/vm/jit/stack.c, src/vm/jit/x86_64/codegen.c,
	src/vm/jit/x86_64/emit.c, src/vm/signal.c:
	* src/vm/builtin.c (builtin_canstore): Throw an ArrayStoreException.
	(builtin_fast_canstore): Do not throw any exceptions.

	* src/vm/builtin.h (BUILTIN_canstore): Removed.

	* src/vm/builtintable.inc: Adapted entry for builtin_canstore.

	* src/vm/exceptions.h (EXCEPTION_HARDWARE_ARRAYSTORE): Added.

	* src/vm/signal.c (signal_handle): Added case for
	ArrayStoreException.

	* src/vm/jit/emit-common.h (emit_arraystore_check): Added prototype.

	* src/vm/jit/stack.c (stack_analyse): ICMD_AASTORE now uses fast
	canstore.

	* src/vm/jit/alpha/codegen.c (codegen_emit): ICMD_AASTORE uses fast
	canstore.
	* src/vm/jit/alpha/emit.c (emit_arraystore_check): Implemented.

	* src/vm/jit/arm/codegen.c: Likewise.
	* src/vm/jit/arm/emit.c: Likewise.
	* src/vm/jit/i386/codegen.c: Likewise.
	* src/vm/jit/i386/emit.c: Likewise.
	* src/vm/jit/m68k/codegen.c: Likewise.
	* src/vm/jit/m68k/emit.c: Likewise.
	* src/vm/jit/mips/codegen.c: Likewise.
	* src/vm/jit/mips/emit.c: Likewise.
	* src/vm/jit/powerpc/codegen.c: Likewise.
	* src/vm/jit/powerpc/emit.c: Likewise.
	* src/vm/jit/powerpc64/codegen.c: Likewise.
	* src/vm/jit/powerpc64/emit.c: Likewise.
	* src/vm/jit/s390/codegen.c: Likewise.
	* src/vm/jit/s390/emit.c: Likewise.
	* src/vm/jit/sparc64/codegen.c: Likewise.
	* src/vm/jit/sparc64/emit.c: Likewise.
	* src/vm/jit/x86_64/codegen.c: Likewise.
	* src/vm/jit/x86_64/emit.c: Likewise.
	[e87c6675ff29]

	* src/vm/array.c:
	* src/vm/array.c (array_length_get): Better use LLNI_class_get here.
	[4076f8bfb9f5]

2007-09-03  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* THIRDPARTY, src/lib/Makefile.am, src/lib/gnu/sun/reflect/annotation/
	EnumConstantNotPresentExceptionProxy.java,
	src/lib/gnu/sun/reflect/annotation/ExceptionProxy.java:
	* THIRDPARTY: Added copyright notice for newly imported files.

	* src/lib/Makefile.am (VM_JAVA_FILES) [ENABLE_ANNOTATIONS]: Added
	$(top_srcdir)/src/lib/gnu/sun/reflect/annotation/ExceptionProxy.java
	and $(top_srcdir)/src/lib/gnu/sun/reflect/annotation/EnumConstantNot
	PresentExceptionProxy.java (VM_CLASS_FILES) [ENABLE_ANNOTATIONS]:
	Added classes/sun/reflect/annotation/ExceptionProxy.class and classe
	s/sun/reflect/annotation/EnumConstantNotPresentExceptionProxy.class

	* src/lib/gnu/sun/reflect/annotation/EnumConstantNotPresentException
	Proxy.java: Imported from OpenJDK. This file was only an
	unimplemented stub in GNU Classpath.

	* src/lib/gnu/sun/reflect/annotation/ExceptionProxy.java: Likewise.
	[0ac069bf6d22]

2007-09-02  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/jni.c:
	* src/native/jni.c (_Jv_JNI_FindClass) [ENABLE_JAVAME_CLDC1_1]:
	Implemented.
	[737aa9376ba1]

	* src/cacaoh/headers.c, src/vm/initialize.c, src/vm/jit/verify
	/typecheck-invoke.inc, src/vm/jit/verify/typeinfo.c,
	src/vm/resolve.c, src/vmcore/class.c, src/vmcore/class.h,
	src/vmcore/linker.c, src/vmcore/loader.c,
	src/vmcore/primitivecore.c:
	* src/vmcore/class.h (classinfo): Changed type of super and
	interfaces to classinfo*.
	* src/cacaoh/headers.c (printfields): Removed .cls for super class
	and/or interfaces.
	* src/vm/initialize.c (initialize_class_intern): Likewise.
	* src/vm/jit/verify/typecheck-invoke.inc: Likewise.
	* src/vm/jit/verify/typeinfo.c (interface_extends_interface):
	Likewise. (typeinfo_merge_nonarrays): Likewise.
	* src/vm/resolve.c (resolve_method_invokespecial_lookup): Likwise.
	* src/vmcore/class.c (class_free): Likewise. (class_resolvemethod):
	Likewise. (class_resolveinterface_intern): Likewise.
	(class_resolveclassmethod): Likewise. (class_findfield): Likewise.
	(class_resolvefield_int): Likewise. (class_get_interfaces):
	Likewise. (class_issubclass): Likewise. (class_get_superclass):
	Likewise. (class_showmethods): Likewise. (class_showmethods):
	Likewise. (class_resolve_superclass): Removed.
	* src/vmcore/linker.c (linker_init): Removed .cls for super class
	and/or interfaces. (linker_compute_subclasses): Likewise.
	(linker_addinterface): Likewise. (link_class_intern): Moved verifier
	checks into classfile parsing stage.
	* src/vmcore/loader.c (vm/resolve.h): Added.
	(load_class_from_classbuffer_intern): Resolve super class and super
	interfaces during loading. This is also done by the RI.
	(load_newly_created_array): Removed .cls for super class and/or
	interfaces.
	* src/vmcore/primitivecore.c (primitive_init): Likewise.
	[6a2784fb3be7]

	* .hgignore:
	* .hgignore: Ignore files in tests/.
	[0d0a9bd7bf72]

2007-09-01  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/jit/codegen-common.c:
	* src/vm/jit/codegen-common.c (llni.h): Added.
	(codegen_stub_builtin_exit): Use stacktrace function to remove
	stackframeinfo. (codegen_finish_native_call): Likewise. Unwrap
	exception object before return.
	[cc6e8e021e70]

	* src/vm/jit/stacktrace.c, src/vm/jit/stacktrace.h,
	tests/StackTraceBig.java:
	* src/vm/jit/stacktrace.h (stacktracebuffer): Entries are stored
	inside stb now. (stacktracecontainer): Removed data field.

	* src/vm/jit/stacktrace.c (stacktrace_add_entry) Adapted to above
	changes. (stacktrace_add_method): Likewise. (stacktrace_create):
	Likewise. (stacktrace_fillInStackTrace): Stacktracebuffer can be
	copied at once.

	* tests/StackTraceBig.java: Added testcase for large stacktraces.
	[42b041b8ea05]

	* src/vm/builtin.c:
	* src/vm/builtin.c (builtin_canstore): Fixed severe typo.
	[fc721266fcd8]

	* src/vm/builtin.c, src/vm/builtin.h, src/vm/exceptions.c,
	src/vm/jit/trace.c, src/vm/jit/trace.h:
	* src/vm/builtin.c: Use LLNI macros throughout the file.
	(builtin_fast_canstore): Previously builtin_canstore.
	(builtin_canstore): Implemented. (builtin_trace_exception): Moved to
	trace.c.

	* src/vm/builtin.h: Fixed prototypes.

	* src/vm/exceptions.c (exceptions_handle_exception): Use
	trace_exception instead of builtin.

	* src/vm/jit/trace.c (trace_exception): Added (moved from
	builtin.c).

	* src/vm/jit/trace.h (trace_exception): Added prototype.
	[e2c8ed46c130]

2007-08-31  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/vm/exceptions.c, src/vm/exceptions.h, src/vm/jit/trace.c,
	src/vm/vm.c:
	* src/vm/jit/trace.c (trace_java_call_print_argument): Deals with
	java_object_t.

	* src/vm/exceptions.h (exceptions_asm_new_abstractmethoderror):
	Fixed prototype.

	* src/vm/exceptions.c: Use LLNI_class_get throughout file.
	(exceptions_get_exception): Wrap exception object.
	(exceptions_set_exception): Unwrap exception object.

	* src/vm/vm.c: Use LLNI_class_get throughout file.
	[f7ad5f22979c]

	* src/cacaoh/dummy.c, src/native/include/Makefile.am,
	src/native/vm/gnu/java_lang_reflect_Constructor.c,
	src/native/vm/gnu/java_lang_reflect_Field.c,
	src/native/vm/gnu/java_lang_reflect_Method.c:
	* src/cacaoh/dummy.c (array_objectarray_element_set): Fixed for
	handles. (array_objectarray_element_get): Likewise.
	(builtin_anewarray): Likewise. (builtin_newarray_byte): Likewise.
	(localref_add): Added.

	* src/native/include/Makefile.am [ENABLE_ANNOTATIONS]: Create
	java_util_Map.h.

	* src/native/vm/gnu/java_lang_reflect_Constructor.c: Use above
	header.
	* src/native/vm/gnu/java_lang_reflect_Field.c: Likewise.
	* src/native/vm/gnu/java_lang_reflect_Method.c: Likewise.
	[aaaac3a75526]

	* src/native/vm/java_lang_ClassLoader.c:
	* src/native/vm/java_lang_ClassLoader.c
	(_Jv_java_lang_ClassLoader_defineClass): Removed bugging assertion.
	It seems defineClass can take NULL as classloader.
	[058fbd6b9a45]

	* src/native/jni.c, tests/regression/native/checkjni.c,
	tests/regression/native/checkjni.java,
	tests/regression/native/checkjni.output:
	* src/native/jni.c (_Jv_JNI_GetObjectField): Fixed implementation
	for handles. (_Jv_JNI_SetObjectField): Likewise.

	* tests/regression/native/checkjni.c: Added testcase for above
	change.
	* tests/regression/native/checkjni.java: Likewise.
	* tests/regression/native/checkjni.output: Adapted output to above
	changes.
	[f2aaccf82e27]

	* src/vm/jit/i386/codegen.c, src/vm/jit/m68k/codegen.c:
	* src/vm/jit/i386/codegen.c (codegen_emit_stub_builtin): Removed
	obsolete assertion.

	* src/vm/jit/m68k/codegen.c (codegen_emit_stub_builtin): Likewise.
	[245c495034d6]

	* * Merged with exact-gc branch at rev 2d4098fc2ea4.
	[70720e99787f]

	* src/lib/Makefile.am, src/native/vm/Makefile.am,
	src/native/vm/java_lang_String.c, src/native/vm/java_lang_String.h:
	* src/lib/Makefile.am: Fixed another merge problem.
	* src/native/vm/Makefile.am: Removed resurrected files.
	* src/native/vm/java_lang_String.c: Removed resurrected file.
	* src/native/vm/java_lang_String.h: Likewise.
	[2d4098fc2ea4]

	* src/vmcore/class.c:
	* src/vmcore/class.c (class_free): Fixed another merge problem (thx
	to panzi).
	[0ff8641a2a6d]

	* src/native/vm/gnu/java_lang_VMClassLoader.c:
	* src/native/vm/gnu/java_lang_VMClassLoader.c
	(Java_java_lang_VMClassLoader_findLoadedClass): Add classloader to
	hashtable instead of searching for it.
	[7789ad4e3f25]

	* src/threads/native/threads.c, src/vm/jit/codegen-common.c:
	* src/threads/native/threads.c (threads_stopworld) [__DARWIN__]:
	Disabled. (threads_startworld) [__DARWIN__]: Likewise.

	* src/vm/jit/codegen-common.c (codegen_generate_stub_builtin):
	Disabled for archs where codegen_emit_stub_builtin is not yet
	implemented.
	[123b52988611]

	* tests/gc/ClassUnload.java:
	* tests/gc/ClassUnload.java: Added testcase for class unloading.
	[7ef9d758714e]

	* src/native/vm/gnu/java_lang_reflect_Method.c,
	src/native/vm/java_lang_String.c, src/vm/access.c,
	src/vm/jit/stacktrace.c, src/vm/jit/stacktrace.h:
	* src/native/vm/gnu/java_lang_reflect_Method.c
	(Java_java_lang_reflect_Method_invokeNative): Fixed LLNI macro
	usage.

	* src/native/vm/java_lang_String.c (_Jv_java_lang_String_intern):
	Wrap interned strings into a handle.

	* src/vm/access.c (access_check_field): Use LLNI macro for array
	access. (access_check_method): Likewise.

	* src/vm/jit/stacktrace.c (stacktrace_getClassContext): Likewise.
	(stacktrace_getStack): Likewise.

	* src/vm/jit/stacktrace.h (md-abi.h): Added missing include.
	[2bda8b53eb85]

	* src/mm/cacao-gc/heap.c, src/vm/jit/codegen-common.c:
	* src/mm/cacao-gc/heap.c (heap_alloc_intern) [!NDEBUG]: Added sanity
	check.

	* src/vm/jit/codegen-common.c (codegen_stub_builtin_enter): Removed
	native-world flag manipulation. (codegen_stub_builtin_exit):
	Likewise. (codegen_start_native_call): Likewise.
	(codegen_finish_native_call): Likewise.
	[f561e7cc5606]

	* configure.ac, src/native/jni.c,
	src/native/vm/java_lang_ClassLoader.c, src/native/vm/nativevm.c,
	src/vmcore/loader.c:
	* configure.ac: Added missing newline.
	* src/native/jni.c: Fixed some merge problems
	* src/native/vm/java_lang_ClassLoader.c: Likewise.
	* src/native/vm/nativevm.c: Likewise.
	* src/vmcore/loader.c: Likewise.
	[3a5cad64b925]

	* tests/regression/native/checkjni.c,
	tests/regression/native/checkjni.java,
	tests/regression/native/checkjni.output:
	* tests/regression/native/checkjni.java: Added some new JNI
	testcases.
	* tests/regression/native/checkjni.c: Likewise.
	* tests/regression/native/checkjni.output: Adapted output to new
	testcases.
	[45a390db1fc6]

2007-08-30  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/mm/cacao-gc/copy.c, src/mm/cacao-gc/copy.h, src/mm/cacao-
	gc/final.c, src/mm/cacao-gc/final.h, src/mm/cacao-gc/heap.c, src/mm
	/cacao-gc/heap.h, src/mm/cacao-gc/mark.h, src/mm/cacao-gc/region.c,
	src/mm/cacao-gc/region.h, src/mm/cacao-gc/rootset.c, src/mm/cacao-
	gc/rootset.h, src/native/llni.c, src/native/vm/java_lang_String.c,
	src/native/vm/java_lang_String.h, src/vm/jit/m68k/codegen.h:
	* Removed leftover Id tags.
	[6b7f509fc859]

	* AUTHORS, ChangeLog, NEWS, configure.ac, contrib/log2xml.pl,
	m4/classpath.m4, src/Makefile.am, src/cacaoh/cacaoh.c,
	src/cacaoh/dummy.c, src/cacaoh/headers.c, src/lib/Makefile.am,
	src/mm/boehm-gc/callprocs, src/mm/boehm-gc/cord/de_win.ICO, src/mm
	/boehm-gc/doc/README.arm.cross, src/mm/boehm-
	gc/pthread_stop_world.c, src/mm/boehm-gc/win32_threads.c,
	src/mm/boehm.c, src/mm/cacao-gc/Makefile.am, src/mm/cacao-
	gc/compact.c, src/mm/cacao-gc/compact.h, src/mm/cacao-gc/gc.c,
	src/mm/cacao-gc/gc.h, src/mm/cacao-gc/mark.c, src/mm/gc-common.h,
	src/mm/memory.c, src/mm/memory.h, src/mm/nogc.c,
	src/native/Makefile.am, src/native/include/Makefile.am,
	src/native/jni.c, src/native/jni.h, src/native/llni.h,
	src/native/localref.c, src/native/localref.h, src/native/native.c,
	src/native/native.h, src/native/vm/Makefile.am,
	src/native/vm/cldc1.1/java_lang_Double.c,
	src/native/vm/cldc1.1/java_lang_Float.c,
	src/native/vm/cldc1.1/java_lang_Object.c,
	src/native/vm/cldc1.1/java_lang_String.c,
	src/native/vm/cldc1.1/java_lang_Throwable.c,
	src/native/vm/gnu/Makefile.am,
	src/native/vm/gnu/gnu_classpath_VMStackWalker.c,
	src/native/vm/gnu/java_lang_VMClass.c,
	src/native/vm/gnu/java_lang_VMClassLoader.c,
	src/native/vm/gnu/java_lang_VMObject.c,
	src/native/vm/gnu/java_lang_VMRuntime.c,
	src/native/vm/gnu/java_lang_VMString.c,
	src/native/vm/gnu/java_lang_VMSystem.c,
	src/native/vm/gnu/java_lang_VMThread.c,
	src/native/vm/gnu/java_lang_VMThrowable.c,
	src/native/vm/gnu/java_lang_reflect_Constructor.c,
	src/native/vm/gnu/java_lang_reflect_Field.c,
	src/native/vm/gnu/java_lang_reflect_Method.c,
	src/native/vm/gnu/sun_reflect_ConstantPool.c,
	src/native/vm/java_lang_Class.c, src/native/vm/java_lang_Class.h,
	src/native/vm/java_lang_ClassLoader.c,
	src/native/vm/java_lang_Object.c, src/native/vm/java_lang_Thread.c,
	src/native/vm/java_lang_reflect_Method.c, src/native/vm/nativevm.c,
	src/native/vm/nativevm.h, src/native/vm/reflect.c,
	src/native/vm/sun/jvm.c, src/native/vm/sun_misc_Unsafe.c,
	src/threads/critical.c, src/threads/native/lock.c,
	src/threads/native/lock.h, src/threads/native/threads.c,
	src/threads/native/threads.h, src/threads/none/threads.h,
	src/threads/threads-common.c, src/threads/threads-common.h,
	src/toolbox/avl.c, src/toolbox/avl.h, src/toolbox/list.c,
	src/toolbox/list.h, src/vm/Makefile.am, src/vm/access.c,
	src/vm/access.h, src/vm/builtin.c, src/vm/builtin.h,
	src/vm/builtintable.inc, src/vm/exceptions.c, src/vm/exceptions.h,
	src/vm/finalizer.c, src/vm/global.h, src/vm/jit/Makefile.am,
	src/vm/jit/abi.h, src/vm/jit/allocator/simplereg.c,
	src/vm/jit/alpha/arch.h, src/vm/jit/alpha/asmpart.S,
	src/vm/jit/alpha/codegen.c, src/vm/jit/alpha/codegen.h,
	src/vm/jit/alpha/emit.c, src/vm/jit/alpha/linux/md-os.c,
	src/vm/jit/alpha/md-abi.c, src/vm/jit/alpha/md.c,
	src/vm/jit/alpha/patcher.c, src/vm/jit/arm/arch.h,
	src/vm/jit/arm/asmpart.S, src/vm/jit/arm/codegen.c,
	src/vm/jit/arm/codegen.h, src/vm/jit/arm/emit.c,
	src/vm/jit/arm/linux/md-os.c, src/vm/jit/arm/md-abi.c,
	src/vm/jit/arm/md.c, src/vm/jit/arm/patcher.c, src/vm/jit/asmpart.h,
	src/vm/jit/code.c, src/vm/jit/code.h, src/vm/jit/codegen-common.c,
	src/vm/jit/codegen-common.h, src/vm/jit/disass-common.c,
	src/vm/jit/disass.h, src/vm/jit/dseg.c, src/vm/jit/dseg.h,
	src/vm/jit/emit-common.c, src/vm/jit/emit-common.h,
	src/vm/jit/i386/arch.h, src/vm/jit/i386/asmpart.S,
	src/vm/jit/i386/codegen.c, src/vm/jit/i386/codegen.h,
	src/vm/jit/i386/darwin/md-os.c, src/vm/jit/i386/emit.c,
	src/vm/jit/i386/linux/md-os.c, src/vm/jit/i386/md-abi.c,
	src/vm/jit/i386/md.c, src/vm/jit/i386/patcher.c,
	src/vm/jit/inline/inline.c, src/vm/jit/intrp/asmpart.c,
	src/vm/jit/intrp/intrp.h, src/vm/jit/intrp/patcher.c,
	src/vm/jit/intrp/peephole-gen, src/vm/jit/intrp/vmgenx,
	src/vm/jit/jit.c, src/vm/jit/jit.h, src/vm/jit/m68k/arch.h,
	src/vm/jit/m68k/asmpart.S, src/vm/jit/m68k/codegen.c,
	src/vm/jit/m68k/codegen.h, src/vm/jit/m68k/emit.c,
	src/vm/jit/m68k/linux/md-abi.c, src/vm/jit/m68k/linux/md-abi.h,
	src/vm/jit/m68k/linux/md-os.c, src/vm/jit/m68k/md.c,
	src/vm/jit/m68k/patcher.c, src/vm/jit/mips/arch.h,
	src/vm/jit/mips/asmpart.S, src/vm/jit/mips/codegen.c,
	src/vm/jit/mips/codegen.h, src/vm/jit/mips/emit.c,
	src/vm/jit/mips/irix/md-os.c, src/vm/jit/mips/linux/md-os.c,
	src/vm/jit/mips/md-abi.c, src/vm/jit/mips/md.c,
	src/vm/jit/mips/patcher.c, src/vm/jit/optimizing/profile.c,
	src/vm/jit/optimizing/recompile.c, src/vm/jit/parse.c,
	src/vm/jit/parse.h, src/vm/jit/patcher.h, src/vm/jit/powerpc/arch.h,
	src/vm/jit/powerpc/asmpart.S, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc/codegen.h, src/vm/jit/powerpc/darwin/md-abi.c,
	src/vm/jit/powerpc/darwin/md-os.c, src/vm/jit/powerpc/emit.c,
	src/vm/jit/powerpc/linux/md-abi.c, src/vm/jit/powerpc/linux/md-os.c,
	src/vm/jit/powerpc/md.c, src/vm/jit/powerpc/patcher.c,
	src/vm/jit/powerpc64/arch.h, src/vm/jit/powerpc64/asmpart.S,
	src/vm/jit/powerpc64/codegen.c, src/vm/jit/powerpc64/codegen.h,
	src/vm/jit/powerpc64/emit.c, src/vm/jit/powerpc64/linux/Makefile.am,
	src/vm/jit/powerpc64/linux/md-abi.c, src/vm/jit/powerpc64/linux/md-
	abi.h, src/vm/jit/powerpc64/linux/md-os.c,
	src/vm/jit/powerpc64/md.c, src/vm/jit/powerpc64/patcher.c,
	src/vm/jit/reg.c, src/vm/jit/replace.c, src/vm/jit/replace.h,
	src/vm/jit/s390/arch.h, src/vm/jit/s390/asmpart.S,
	src/vm/jit/s390/codegen.c, src/vm/jit/s390/codegen.h,
	src/vm/jit/s390/disass.c, src/vm/jit/s390/emit.c,
	src/vm/jit/s390/emit.h, src/vm/jit/s390/md-abi.c, src/vm/jit/s390
	/md-abi.h, src/vm/jit/s390/md-asm.h, src/vm/jit/s390/md.c,
	src/vm/jit/s390/patcher.c, src/vm/jit/s390/tests/dacapo.status,
	src/vm/jit/s390/tests/tests.java.pp, src/vm/jit/show.c,
	src/vm/jit/sparc64/Makefile.am, src/vm/jit/sparc64/asmpart.S,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/sparc64/codegen.h,
	src/vm/jit/sparc64/emit.c, src/vm/jit/sparc64/linux/md-os.c,
	src/vm/jit/sparc64/md-abi.c, src/vm/jit/sparc64/md-abi.h,
	src/vm/jit/sparc64/md.c, src/vm/jit/sparc64/patcher.c,
	src/vm/jit/sparc64/solaris/md-os.c, src/vm/jit/stack.c,
	src/vm/jit/stacktrace.c, src/vm/jit/stacktrace.h,
	src/vm/jit/trace.c, src/vm/jit/trace.h,
	src/vm/jit/verify/generate.pl, src/vm/jit/verify/typecheck-
	stackbased.c, src/vm/jit/verify/typecheck.c,
	src/vm/jit/verify/typeinfo.c, src/vm/jit/x86_64/arch.h,
	src/vm/jit/x86_64/asmpart.S, src/vm/jit/x86_64/codegen.c,
	src/vm/jit/x86_64/codegen.h, src/vm/jit/x86_64/emit.c,
	src/vm/jit/x86_64/emit.h, src/vm/jit/x86_64/linux/md-os.c,
	src/vm/jit/x86_64/md-abi.c, src/vm/jit/x86_64/md.c,
	src/vm/jit/x86_64/patcher.c, src/vm/jit_interface.h,
	src/vm/primitive.c, src/vm/primitive.h, src/vm/properties.c,
	src/vm/resolve.c, src/vm/resolve.h, src/vm/signal.c,
	src/vm/signallocal.h, src/vm/string.c, src/vm/stringlocal.h,
	src/vm/vm.c, src/vm/vm.h, src/vmcore/Makefile.am,
	src/vmcore/annotation.c, src/vmcore/class.c, src/vmcore/class.h,
	src/vmcore/classcache.c, src/vmcore/classcache.h,
	src/vmcore/descriptor.c, src/vmcore/descriptor.h,
	src/vmcore/field.c, src/vmcore/field.h, src/vmcore/linker.c,
	src/vmcore/linker.h, src/vmcore/loader.c, src/vmcore/loader.h,
	src/vmcore/method.c, src/vmcore/method.h, src/vmcore/options.c,
	src/vmcore/options.h, src/vmcore/rt-timing.c, src/vmcore/rt-
	timing.h, src/vmcore/statistics.c, src/vmcore/statistics.h,
	src/vmcore/utf8.c, src/vmcore/utf8.h, src/vmcore/zip.c,
	tests/regression/Makefile.am, tests/regression/jasmin/runtest,
	tests/regression/jasmin/show, tests/regression/native/Makefile.am,
	tests/regression/native/testarguments.c,
	tests/regression/native/testarguments.java,
	tests/regression/resolving/Makefile.am:
	* Merged with default branch at rev 16f3633aaa5a.
	[5580183476bc]

	* * Dummy commit to fix conversion problems with some files.
	[2a3f176c1847]

2007-08-30  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/jni.c:
	* src/native/jni.c (native/include/java_lang_Byte.h,
	native/include/java_lang_Character.h,
	native/include/java_lang_Short.h,
	native/include/java_lang_Integer.h,
	native/include/java_lang_Boolean.h, native/include/java_lang_Long.h,
	native/include/java_lang_Float.h,
	native/include/java_lang_Double.h): Removed. [WITH_CLASSPATH_SUN]
	(class_sun_nio_ch_DirectBuffer) (class_java_nio_DirectByteBuffer,
	dbb_init): Added. (jni_init) [WITH_CLASSPATH_SUN]: Added direct-
	buffer stuff. (_Jv_JNI_ExceptionOccurred): Added TRACEJNICALLS.
	(_Jv_JNI_ToReflectedMethod): Likewise. (_Jv_JNI_GetStaticMethodID):
	Likewise. (_Jv_JNI_DestroyJavaVM): Likewise.
	(_Jv_JNI_ExceptionDescribe): Fixed bug.
	(_Jv_JNI_NewDirectByteBuffer) [WITH_CLASSPATH_SUN]: Implemented.
	(_Jv_JNI_GetDirectBufferAddress): Likewise.
	[16f3633aaa5a]

	* src/native/vm/sun_misc_Unsafe.c:
	* src/native/vm/sun_misc_Unsafe.c (getFloat): Implemented.
	(getShort): Likewise. (getFloat): Likewise.
	[e93f7beb4914]

	* src/native/jni.c, src/native/vm/sun/jvm.c:
	* src/native/jni.c (_Jv_JNI_GetVersion): Return JNI_VERSION_1_6.
	(GetObjectRefType): New function. (_Jv_JNINativeInterface): Added
	jni_GetObjectRefType.
	* src/native/vm/sun/jvm.c (JVM_IsSupportedJNIVersion): Added
	JNI_VERSION_1_6.
	[1f464780e928]

	* src/native/vm/sun_misc_Unsafe.c:
	* src/native/vm/sun_misc_Unsafe.c (getLong): Implemented. (putByte):
	Likewise. (putShort): Likewise. (setMemory): Likewise.
	[6543e757c0dd]

2007-08-29  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* merge with b3167e4ef780
	[6ca1619ca330]

	* merge branch
	[b3167e4ef780]

	* src/vmcore/annotation.c:
	* src/vmcore/annotations.c (vmcore/loader.h): Added include.
	[b15974c0c943]

2007-08-28  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* src/native/vm/java_lang_Class.c, src/vmcore/annotation.c:
	* src/native/vm/java_lang_Class.c
	(_Jv_java_lang_Class_getDeclaredAnnotations): Removed unnecessary
	exceptions_get_exception() check.

	* src/vmcore/annotation.c (annotation_bytearrays_resize): Fixed
	comment.
	[487da8dcec58]

2007-08-29  Michael Starzinger  <michi@complang.tuwien.ac.at>

	* src/threads/native/threads.h, src/threads/none/threads.h,
	src/vm/jit/stacktrace.c:
	* src/threads/native/threads.h: Added THREAD_NATIVEWORLD macros.
	* src/threads/none/threads.h: Likewise.
	* src/vm/jit/stacktrace.c (stacktrace_remove_stackframeinfo): Use
	above macros. (stacktrace_create_extern_stackframe): Likewise.
	(stacktrace_create_native_stackframe): Likewise.
	[3cf6b87e4849]

2007-08-29  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (JVM_NewArray): Added NPE check.
	(JVM_NewMultiArray): Implemented, but needs review at a later point.
	[dc9b6899f051]

	* src/vmcore/loader.c:
	* src/vmcore/loader.c (load_class_from_classbuffer): Renamed to
	load_class_from_classbuffer_intern. (load_class_from_classbuffer):
	New function.
	[812cc24606bb]

	* src/vmcore/loader.c, src/vmcore/utf8.c, src/vmcore/utf8.h:
	* src/vmcore/loader.c (load_class_from_classloader)
	[WITH_CLASSPATH_SUN]: Call loadClassInternal.
	* src/vmcore/utf8.c (utf_loadClassInternal): Added. (utf8_init):
	Initialize utf_loadClassInternal.
	* src/vmcore/utf8.h (utf_loadClassInternal): Added.
	[7065d8389571]

	* src/cacaoh/cacaoh.c, src/vm/primitive.h, src/vm/vm.c,
	src/vmcore/linker.c, src/vmcore/linker.h, src/vmcore/loader.c,
	src/vmcore/loader.h, src/vmcore/primitivecore.c:
	* src/cacaoh/cacaoh.c (main): Added loader_preinit call.

	* src/vm/primitive.h (primitive_init): Changed return type to void.
	(primitive_postinit): New function.

	* src/vm/vm.c (vm_create): Use new init functions.

	* src/vmcore/linker.c (stdint.h): Added. (linker_preinit): New
	function. (linker_init): Moved basic stuff into linker_preinit, call
	vm_abort if error occurred.

	* src/vmcore/linker.h (linker_preinit): New function. (linker_init):
	Changed return type to void.

	* src/vmcore/loader.c (loader_preinit): New function. (loader_init):
	Moved basic stuff into loader_preinit, call vm_abort if error
	occurred.

	* src/vmcore/loader.h (loader_preinit): New function. (loader_init):
	Changed return type to void.

	* src/vmcore/primitivecore.c (vm/vm.h): Added. (primitive_init):
	Load and link primitive-type classes and array-class ASAP, this is
	important for annotations. (primitive_postinit): New function.
	[b562aa714e92]

2007-08-28  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vmcore/annotation.c:
	* src/vmcore/annotation.c (stdint.h): Added.
	[0dbc39d08b63]

2007-08-28  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* src/vmcore/field.c, src/vmcore/method.c:
	* src/vmcore/field.c (vm/array.h): Added include. (mm/memory.h):
	Removed doubled include. (field_get_annotations): Added cast for
	array_length_get()s parameter.

	* src/vmcore/method.c (vm/array.h): Added include.
	(method_get_annotations): Added cast for array_length_get()s
	parameter. (method_get_parameterannotations): Added cast for
	array_length_get()s parameter. (method_get_annotationdefault): Added
	cast for array_length_get()s parameter.
	[d6a85336983a]

2007-08-27  Mathias Panzenboeck  <e0427417@student.tuwien.ac.at>

	* src/vmcore/annotation.c, src/vmcore/annotation.h:
	* src/vmcore/annotation.c (annotation_bytearrays_resize): Removed
	unused variables.

	* src/vmcore/annotation.h: Sorted includes. (vmcore/utf8.h): Removed
	include.
	[6aee3768a843]

	* autogen.sh, src/cacaoh/dummy.c, src/mm/boehm-gc/autogen.sh,
	src/native/vm/gnu/java_lang_reflect_Constructor.c,
	src/native/vm/gnu/java_lang_reflect_Field.c,
	src/native/vm/gnu/java_lang_reflect_Method.c,
	src/native/vm/gnu/sun_reflect_ConstantPool.c,
	src/native/vm/java_lang_Class.c, src/vmcore/annotation.c,
	src/vmcore/annotation.h, src/vmcore/class.c, src/vmcore/class.h,
	src/vmcore/field.c, src/vmcore/loader.c, src/vmcore/method.c,
	src/vmcore/utf8.c, src/vmcore/utf8.h:
	* autogen.sh: Made executeable.

	* src/cacaoh/dummy.c (mm/memory.h): Added include. (native/llni.h):
	Added include. (array_objectarray_element_get): Added dummy
	implementation. (array_objectarray_element_set): Added dummy
	implementation. (array_length_get): Added dummy implementation.
	(builtin_anewarray): Added dummy implementation using MNEW.
	(builtin_newarray_byte): Added dummy implementation using MNEW.
	(primitive_arrayclass_get_by_type): Added dummy implementation.

	* src/mm/boehm-gc/autogen.sh: Made executeable.

	* src/native/vm/gnu/java_lang_reflect_Constructor.c
	(Java_java_lang_reflect_Constructor_declaredAnnotations): Removed
	unused variable o.
	(Java_java_lang_reflect_Constructor_getParameterAnnotations):
	Removed unused variable o.

	* src/native/vm/gnu/java_lang_reflect_Field.c
	(Java_java_lang_reflect_Field_declaredAnnotations): Removed unused
	variable o.

	* src/native/vm/gnu/java_lang_reflect_Method.c
	(Java_java_lang_reflect_Method_getDefaultValue): Removed unused
	variable o. (Java_java_lang_reflect_Method_declaredAnnotations):
	Removed unused variable o.
	(Java_java_lang_reflect_Method_getParameterAnnotations): Removed
	unused variable o.

	* src/native/vm/gnu/sun_reflect_ConstantPool.c
	(_Jv_sun_reflect_ConstantPool_init): Removed usage of global string
	utf_sun_reflect_ConstantPool.

	* src/native/vm/java_lang_Class.c [WITH_CLASSPATH_GNU]
	[ENABLE_ANNOTATIONS]: Sorted includes.
	(_Jv_java_lang_Class_getDeclaredAnnotations): Fixed comment.

	* src/vmcore/annotation.c (native/llni.h): Added include.
	(vm/array.h): Added include. (vm/builtin.h): Added include.
	(vm/primitive.h): Added include. (annotation_bytearray_new):
	Removed. (annotation_bytearray_free): Removed.
	(annotation_bytearrays_new): Removed. (annotation_bytearrays_free):
	Removed. (annotation_bytearrays_resize): Made static and now
	java_handle_objectarray_t is used instead of my own array type.
	(annotation_bytearrays_insert): Made static and now
	java_handle_objectarray_t is used instead of my own array type.
	(annotation_load_attribute_body): Using java_handle_bytearray_t
	instead of my own array type.
	(annotation_load_method_attribute_annotationdefault): Using
	java_handle_bytearray_t and java_handle_objectarray_t instead of my
	own array types. (annotation_load_method_attribute_runtimevisiblepar
	ameterannotations): Using java_handle_bytearray_t and
	java_handle_objectarray_t instead of my own array types.
	(annotation_load_method_attribute_runtimevisibleannotations): Using
	java_handle_bytearray_t and java_handle_objectarray_t instead of my
	own array types.
	(annotation_load_field_attribute_runtimevisibleannotations): Using
	java_handle_bytearray_t and java_handle_objectarray_t instead of my
	own array types.

	* src/vmcore/annotation.h (annotation_bytearray_t): Removed.
	(annotation_bytearrays_t): Removed. (annotation_bytearray_new):
	Removed. (annotation_bytearray_free): Removed.
	(annotation_bytearrays_new): Removed.
	(annotation_bytearrays_resize): Removed.
	(annotation_bytearrays_insert): Removed.
	(annotation_bytearrays_free): Removed.

	* src/vmcore/class.c
	(class_sun_reflect_annotation_AnnotationParser): Is only declared
	when WITH_CLASSPATH_GNU is defined. (class_free)
	[ENABLE_ANNOTATIONS]: Removed usage of annotation_bytearray*_free()
	functions. (class_get_annotations): Don't have to copy anything now,
	just return the java_handle_bytearray_t.

	* src/vmcore/class.h (classinfo): Fixed comments. (classinfo)
	[ENABLE_ANNOTATIONS]: Now using java_handle_bytearray_t and
	java_handle_objectarray_t instead of my own array types.

	* src/vmcore/loader.c (loader_init): Removed usage of global string
	utf_sun_reflect_ConstantPool and
	utf_sun_reflect_annotation_AnnotationParser.

	* src/vmcore/field.c (vm/array.h): Added include.
	(field_get_annotations): Don't have to copy anything now, just
	return the java_handle_bytearray_t.

	* src/vmcore/method.c (vm/array.h): Added include.
	(method_get_annotations): Don't have to copy anything now, just
	return the java_handle_bytearray_t.
	(method_get_parameterannotations): Don't have to copy anything now,
	just return the java_handle_bytearray_t.
	(method_get_annotationdefault): Don't have to copy anything now,
	just return the java_handle_bytearray_t.

	* src/vmcore/utf8.c (utf_sun_reflect_ConstantPool): Removed.
	(utf_sun_reflect_annotation_AnnotationParser): Removed.

	* src/vmcore/utf8.h (utf_sun_reflect_ConstantPool): Removed.
	(utf_sun_reflect_annotation_AnnotationParser): Removed.
	[3e20268e098e]

2007-08-27  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* src/vm/jit/show.c:
	* src/vm/jit/show.c (show_icmd): ICMD_MULTIANEWARRAY: Print class
	name.
	[1d28f69443d0]

	* Makefile.am, autogen.sh, configure.ac, contrib/Makefile.am,
	contrib/log2xml.pl, doc/Makefile.am, doc/handbook/Makefile.am,
	m4/annotations.m4, m4/cacaoh.m4, m4/java.m4, m4/jit.m4, m4/jni.m4,
	m4/jre-layout.m4, m4/libjvm.m4, m4/ltdl.m4, m4/soft.m4,
	m4/staticvm.m4, m4/threads.m4, m4/zlib.m4, man/Makefile.am,
	src/Makefile.am, src/cacao/Makefile.am, src/cacao/cacao.c,
	src/cacaoh/Makefile.am, src/cacaoh/cacaoh.c, src/cacaoh/dummy.c,
	src/cacaoh/headers.c, src/cacaoh/headers.h, src/fdlibm/Makefile.am,
	src/lib/Makefile.am, src/lib/gnu/java/lang/VMClassLoader.java,
	src/mm/Makefile.am, src/mm/boehm-gc/autogen.sh, src/mm/boehm-
	gc/callprocs, src/mm/boehm-gc/cord/de_win.ICO, src/mm/boehm-
	gc/doc/README.arm.cross, src/mm/boehm-gc/win32_threads.c,
	src/mm/boehm.c, src/mm/cacao-gc/Makefile.am, src/mm/cacao-
	gc/compact.c, src/mm/cacao-gc/compact.h, src/mm/cacao-gc/gc.c,
	src/mm/cacao-gc/gc.h, src/mm/cacao-gc/mark.c, src/mm/gc-common.h,
	src/mm/memory.c, src/mm/memory.h, src/mm/nogc.c,
	src/native/Makefile.am, src/native/include/Makefile.am,
	src/native/jni.c, src/native/jni.h, src/native/jvmti/Makefile.am,
	src/native/jvmti/cacaodbg.c, src/native/jvmti/cacaodbg.h,
	src/native/jvmti/cacaodbgserver.c,
	src/native/jvmti/cacaodbgserver.h, src/native/jvmti/dbg.h,
	src/native/jvmti/jvmti.c, src/native/jvmti/jvmti.h,
	src/native/llni.h, src/native/localref.c, src/native/localref.h,
	src/native/native.c, src/native/native.h,
	src/native/tools/Makefile.am, src/native/tools/gennativetable.c,
	src/native/vm/Makefile.am, src/native/vm/cldc1.1/Makefile.am,
	src/native/vm/cldc1.1/com_sun_cldc_io_ResourceInputStream.c,
	src/native/vm/cldc1.1/com_sun_cldc_io_j2me_socket_Protocol.c,
	src/native/vm/cldc1.1/com_sun_cldchi_io_ConsoleOutputStream.c,
	src/native/vm/cldc1.1/com_sun_cldchi_jvm_JVM.c,
	src/native/vm/cldc1.1/java_lang_Class.c,
	src/native/vm/cldc1.1/java_lang_Double.c,
	src/native/vm/cldc1.1/java_lang_Float.c,
	src/native/vm/cldc1.1/java_lang_Math.c,
	src/native/vm/cldc1.1/java_lang_Object.c,
	src/native/vm/cldc1.1/java_lang_Runtime.c,
	src/native/vm/cldc1.1/java_lang_String.c,
	src/native/vm/cldc1.1/java_lang_System.c,
	src/native/vm/cldc1.1/java_lang_Thread.c,
	src/native/vm/cldc1.1/java_lang_Throwable.c,
	src/native/vm/gnu/Makefile.am, src/native/vm/gnu/VMjdwp.c,
	src/native/vm/gnu/VMjdwp.h,
	src/native/vm/gnu/gnu_classpath_VMStackWalker.c,
	src/native/vm/gnu/gnu_classpath_VMSystemProperties.c,
	src/native/vm/gnu/gnu_classpath_jdwp_VMFrame.c,
	src/native/vm/gnu/gnu_classpath_jdwp_VMMethod.c,
	src/native/vm/gnu/gnu_classpath_jdwp_VMVirtualMachine.c, src/native/
	vm/gnu/gnu_java_lang_management_VMClassLoadingMXBeanImpl.c,
	src/native/vm/gnu/gnu_java_lang_management_VMMemoryMXBeanImpl.c,
	src/native/vm/gnu/gnu_java_lang_management_VMRuntimeMXBeanImpl.c,
	src/native/vm/gnu/gnu_java_lang_management_VMThreadMXBeanImpl.c,
	src/native/vm/gnu/java_lang_VMClass.c,
	src/native/vm/gnu/java_lang_VMClassLoader.c,
	src/native/vm/gnu/java_lang_VMObject.c,
	src/native/vm/gnu/java_lang_VMRuntime.c,
	src/native/vm/gnu/java_lang_VMString.c,
	src/native/vm/gnu/java_lang_VMSystem.c,
	src/native/vm/gnu/java_lang_VMThread.c,
	src/native/vm/gnu/java_lang_VMThrowable.c,
	src/native/vm/gnu/java_lang_management_VMManagementFactory.c,
	src/native/vm/gnu/java_lang_reflect_Constructor.c,
	src/native/vm/gnu/java_lang_reflect_Field.c,
	src/native/vm/gnu/java_lang_reflect_Method.c,
	src/native/vm/gnu/java_lang_reflect_VMProxy.c,
	src/native/vm/gnu/java_security_VMAccessController.c,
	src/native/vm/gnu/java_util_concurrent_atomic_AtomicLong.c,
	src/native/vm/gnu/sun_reflect_ConstantPool.c,
	src/native/vm/java_lang_Class.c, src/native/vm/java_lang_Class.h,
	src/native/vm/java_lang_ClassLoader.c,
	src/native/vm/java_lang_ClassLoader.h,
	src/native/vm/java_lang_Object.c, src/native/vm/java_lang_Object.h,
	src/native/vm/java_lang_Runtime.c,
	src/native/vm/java_lang_Runtime.h, src/native/vm/java_lang_Thread.c,
	src/native/vm/java_lang_Thread.h,
	src/native/vm/java_lang_reflect_Constructor.c,
	src/native/vm/java_lang_reflect_Constructor.h,
	src/native/vm/java_lang_reflect_Method.c,
	src/native/vm/java_lang_reflect_Method.h,
	src/native/vm/java_util_concurrent_atomic_AtomicLong.c,
	src/native/vm/java_util_concurrent_atomic_AtomicLong.h,
	src/native/vm/nativevm.c, src/native/vm/nativevm.h,
	src/native/vm/reflect.c, src/native/vm/reflect.h,
	src/native/vm/sun/Makefile.am, src/native/vm/sun/jvm.c,
	src/native/vm/sun_misc_Unsafe.c, src/scripts/Makefile.am,
	src/scripts/java.in, src/threads/Makefile.am,
	src/threads/critical.c, src/threads/critical.h, src/threads/lock-
	common.h, src/threads/native/Makefile.am, src/threads/native
	/generic-primitives.h, src/threads/native/lock.c,
	src/threads/native/lock.h, src/threads/native/threads.c,
	src/threads/native/threads.h, src/threads/none/Makefile.am,
	src/threads/none/lock.h, src/threads/none/threads.h, src/threads
	/threads-common.c, src/threads/threads-common.h,
	src/toolbox/Makefile.am, src/toolbox/avl.c, src/toolbox/avl.h,
	src/toolbox/bitvector.c, src/toolbox/bitvector.h,
	src/toolbox/chain.c, src/toolbox/chain.h, src/toolbox/hashtable.c,
	src/toolbox/hashtable.h, src/toolbox/list.c, src/toolbox/list.h,
	src/toolbox/logging.c, src/toolbox/logging.h, src/toolbox/tree.c,
	src/toolbox/tree.h, src/toolbox/util.c, src/toolbox/util.h,
	src/toolbox/worklist.c, src/toolbox/worklist.h, src/vm/Makefile.am,
	src/vm/access.c, src/vm/access.h, src/vm/array.c, src/vm/array.h,
	src/vm/builtin.c, src/vm/builtin.h, src/vm/builtintable.inc, src/vm
	/cycles-stats.c, src/vm/cycles-stats.h, src/vm/exceptions.c,
	src/vm/exceptions.h, src/vm/finalizer.c, src/vm/finalizer.h,
	src/vm/global.h, src/vm/initialize.c, src/vm/initialize.h,
	src/vm/jit/Makefile.am, src/vm/jit/abi-asm.h, src/vm/jit/abi.h,
	src/vm/jit/allocator/Makefile.am, src/vm/jit/allocator/liveness.c,
	src/vm/jit/allocator/liveness.h, src/vm/jit/allocator/lsra.c,
	src/vm/jit/allocator/lsra.h, src/vm/jit/allocator/simplereg.c,
	src/vm/jit/allocator/simplereg.h, src/vm/jit/alpha/Makefile.am,
	src/vm/jit/alpha/arch.h, src/vm/jit/alpha/asmpart.S,
	src/vm/jit/alpha/codegen.c, src/vm/jit/alpha/codegen.h,
	src/vm/jit/alpha/disass.c, src/vm/jit/alpha/emit.c,
	src/vm/jit/alpha/freebsd/Makefile.am, src/vm/jit/alpha/freebsd/md-
	os.c, src/vm/jit/alpha/linux/Makefile.am, src/vm/jit/alpha/linux/md-
	os.c, src/vm/jit/alpha/md-abi.c, src/vm/jit/alpha/md-abi.h,
	src/vm/jit/alpha/md-asm.h, src/vm/jit/alpha/md.c,
	src/vm/jit/alpha/md.h, src/vm/jit/alpha/patcher.c,
	src/vm/jit/arm/Makefile.am, src/vm/jit/arm/arch.h,
	src/vm/jit/arm/asmpart.S, src/vm/jit/arm/codegen.c,
	src/vm/jit/arm/codegen.h, src/vm/jit/arm/disass.c,
	src/vm/jit/arm/emit.c, src/vm/jit/arm/linux/Makefile.am,
	src/vm/jit/arm/linux/md-os.c, src/vm/jit/arm/md-abi.c,
	src/vm/jit/arm/md-abi.h, src/vm/jit/arm/md-asm.h,
	src/vm/jit/arm/md.c, src/vm/jit/arm/patcher.c, src/vm/jit/asmpart.h,
	src/vm/jit/cfg.c, src/vm/jit/cfg.h, src/vm/jit/code.c,
	src/vm/jit/code.h, src/vm/jit/codegen-common.c, src/vm/jit/codegen-
	common.h, src/vm/jit/disass-common.c, src/vm/jit/disass.h,
	src/vm/jit/dseg.c, src/vm/jit/dseg.h, src/vm/jit/emit-common.c,
	src/vm/jit/emit-common.h, src/vm/jit/i386/Makefile.am,
	src/vm/jit/i386/arch.h, src/vm/jit/i386/asmpart.S,
	src/vm/jit/i386/codegen.c, src/vm/jit/i386/codegen.h,
	src/vm/jit/i386/cygwin/Makefile.am, src/vm/jit/i386/cygwin/md-asm.h,
	src/vm/jit/i386/cygwin/md-os.c, src/vm/jit/i386/darwin/Makefile.am,
	src/vm/jit/i386/darwin/md-asm.h, src/vm/jit/i386/darwin/md-os.c,
	src/vm/jit/i386/disass.c, src/vm/jit/i386/emit.c,
	src/vm/jit/i386/emit.h, src/vm/jit/i386/freebsd/Makefile.am,
	src/vm/jit/i386/freebsd/md-asm.h, src/vm/jit/i386/freebsd/md-os.c,
	src/vm/jit/i386/linux/Makefile.am, src/vm/jit/i386/linux/md-asm.h,
	src/vm/jit/i386/linux/md-os.c, src/vm/jit/i386/md-abi.c,
	src/vm/jit/i386/md-abi.h, src/vm/jit/i386/md.c,
	src/vm/jit/i386/patcher.c, src/vm/jit/inline/Makefile.am,
	src/vm/jit/inline/inline.c, src/vm/jit/inline/inline.h,
	src/vm/jit/intrp/Makefile.am, src/vm/jit/intrp/asmpart.c,
	src/vm/jit/intrp/codegen.c, src/vm/jit/intrp/codegen.h,
	src/vm/jit/intrp/disass.c, src/vm/jit/intrp/dynamic-super.c,
	src/vm/jit/intrp/engine.c, src/vm/jit/intrp/engine1.c,
	src/vm/jit/intrp/engine2.c, src/vm/jit/intrp/intrp.h,
	src/vm/jit/intrp/md.c, src/vm/jit/intrp/patcher.c, src/vm/jit/intrp
	/peephole-gen, src/vm/jit/intrp/vmgenx, src/vm/jit/jit.c,
	src/vm/jit/jit.h, src/vm/jit/loop/Makefile.am,
	src/vm/jit/loop/analyze.c, src/vm/jit/loop/analyze.h,
	src/vm/jit/loop/graph.c, src/vm/jit/loop/graph.h,
	src/vm/jit/loop/loop.c, src/vm/jit/loop/loop.h,
	src/vm/jit/loop/tracing.c, src/vm/jit/loop/tracing.h,
	src/vm/jit/m68k/Makefile.am, src/vm/jit/m68k/arch.h,
	src/vm/jit/m68k/asmpart.S, src/vm/jit/m68k/codegen.c,
	src/vm/jit/m68k/codegen.h, src/vm/jit/m68k/disass.c,
	src/vm/jit/m68k/emit.c, src/vm/jit/m68k/emit.h,
	src/vm/jit/m68k/linux/Makefile.am, src/vm/jit/m68k/linux/md-abi.c,
	src/vm/jit/m68k/linux/md-abi.h, src/vm/jit/m68k/linux/md-os.c,
	src/vm/jit/m68k/linux/md-os.h, src/vm/jit/m68k/machine-instr.h,
	src/vm/jit/m68k/md.c, src/vm/jit/m68k/patcher.c, src/vm/jit/md.h,
	src/vm/jit/methodheader.h, src/vm/jit/mips/Makefile.am,
	src/vm/jit/mips/arch.h, src/vm/jit/mips/asmpart.S,
	src/vm/jit/mips/codegen.c, src/vm/jit/mips/codegen.h,
	src/vm/jit/mips/disass.c, src/vm/jit/mips/emit.c,
	src/vm/jit/mips/irix/Makefile.am, src/vm/jit/mips/irix/md-os.c,
	src/vm/jit/mips/linux/Makefile.am, src/vm/jit/mips/linux/md-os.c,
	src/vm/jit/mips/md-abi.c, src/vm/jit/mips/md-abi.h, src/vm/jit/mips
	/md-asm.h, src/vm/jit/mips/md.c, src/vm/jit/mips/patcher.c,
	src/vm/jit/mips/uclinux/Makefile.am, src/vm/jit/mips/uclinux/md-
	os.c, src/vm/jit/optimizing/Makefile.am,
	src/vm/jit/optimizing/dominators.c,
	src/vm/jit/optimizing/dominators.h, src/vm/jit/optimizing/graph.c,
	src/vm/jit/optimizing/graph.h, src/vm/jit/optimizing/ifconv.c,
	src/vm/jit/optimizing/ifconv.h, src/vm/jit/optimizing/lifetimes.c,
	src/vm/jit/optimizing/lifetimes.h, src/vm/jit/optimizing/lsra.c,
	src/vm/jit/optimizing/lsra.h, src/vm/jit/optimizing/profile.c,
	src/vm/jit/optimizing/profile.h, src/vm/jit/optimizing/recompile.c,
	src/vm/jit/optimizing/recompile.h, src/vm/jit/optimizing/reorder.c,
	src/vm/jit/optimizing/reorder.h, src/vm/jit/optimizing/ssa.c,
	src/vm/jit/optimizing/ssa.h, src/vm/jit/parisc/Makefile.am,
	src/vm/jit/parisc/arch.h, src/vm/jit/parisc/linux/Makefile.am,
	src/vm/jit/parisc/md-abi.h, src/vm/jit/parisc/md.c,
	src/vm/jit/parse.c, src/vm/jit/parse.h, src/vm/jit/patcher-common.c,
	src/vm/jit/patcher-common.h, src/vm/jit/patcher.h,
	src/vm/jit/powerpc/Makefile.am, src/vm/jit/powerpc/arch.h,
	src/vm/jit/powerpc/asmpart.S, src/vm/jit/powerpc/codegen.c,
	src/vm/jit/powerpc/codegen.h, src/vm/jit/powerpc/darwin/Makefile.am,
	src/vm/jit/powerpc/darwin/md-abi.c, src/vm/jit/powerpc/darwin/md-
	abi.h, src/vm/jit/powerpc/darwin/md-asm.h, src/vm/jit/powerpc/darwin
	/md-os.c, src/vm/jit/powerpc/disass.c, src/vm/jit/powerpc/emit.c,
	src/vm/jit/powerpc/linux/Makefile.am, src/vm/jit/powerpc/linux/md-
	abi.c, src/vm/jit/powerpc/linux/md-abi.h, src/vm/jit/powerpc/linux
	/md-asm.h, src/vm/jit/powerpc/linux/md-os.c,
	src/vm/jit/powerpc/md.c, src/vm/jit/powerpc/netbsd/Makefile.am,
	src/vm/jit/powerpc/netbsd/md-abi.c, src/vm/jit/powerpc/netbsd/md-
	abi.h, src/vm/jit/powerpc/netbsd/md-asm.h, src/vm/jit/powerpc/netbsd
	/md-os.c, src/vm/jit/powerpc/patcher.c,
	src/vm/jit/powerpc64/Makefile.am, src/vm/jit/powerpc64/arch.h,
	src/vm/jit/powerpc64/asmpart.S, src/vm/jit/powerpc64/codegen.c,
	src/vm/jit/powerpc64/codegen.h, src/vm/jit/powerpc64/disass.c,
	src/vm/jit/powerpc64/emit.c, src/vm/jit/powerpc64/linux/Makefile.am,
	src/vm/jit/powerpc64/linux/md-abi.c, src/vm/jit/powerpc64/linux/md-
	abi.h, src/vm/jit/powerpc64/linux/md-asm.h,
	src/vm/jit/powerpc64/linux/md-os.c, src/vm/jit/powerpc64/md.c,
	src/vm/jit/powerpc64/patcher.c, src/vm/jit/reg.c, src/vm/jit/reg.h,
	src/vm/jit/replace.c, src/vm/jit/replace.h,
	src/vm/jit/s390/Makefile.am, src/vm/jit/s390/arch.h,
	src/vm/jit/s390/asmpart.S, src/vm/jit/s390/codegen.c,
	src/vm/jit/s390/codegen.h, src/vm/jit/s390/disass.c,
	src/vm/jit/s390/emit.c, src/vm/jit/s390/emit.h, src/vm/jit/s390/md-
	abi.c, src/vm/jit/s390/md-abi.h, src/vm/jit/s390/md-asm.h,
	src/vm/jit/s390/md.c, src/vm/jit/s390/patcher.c,
	src/vm/jit/schedule/Makefile.am, src/vm/jit/schedule/schedule.c,
	src/vm/jit/schedule/schedule.h, src/vm/jit/show.c,
	src/vm/jit/show.h, src/vm/jit/sparc64/Makefile.am,
	src/vm/jit/sparc64/arch.h, src/vm/jit/sparc64/asmpart.S,
	src/vm/jit/sparc64/codegen.c, src/vm/jit/sparc64/codegen.h,
	src/vm/jit/sparc64/disass.c, src/vm/jit/sparc64/emit-arch.h,
	src/vm/jit/sparc64/emit.c, src/vm/jit/sparc64/emit.h,
	src/vm/jit/sparc64/linux/Makefile.am, src/vm/jit/sparc64/linux/md-
	os.c, src/vm/jit/sparc64/md-abi.c, src/vm/jit/sparc64/md-abi.h,
	src/vm/jit/sparc64/md-asm.h, src/vm/jit/sparc64/md.c,
	src/vm/jit/sparc64/patcher.c,
	src/vm/jit/sparc64/solaris/Makefile.am, src/vm/jit/sparc64/solaris
	/md-os.c, src/vm/jit/stack.c, src/vm/jit/stack.h,
	src/vm/jit/stacktrace.c, src/vm/jit/stacktrace.h,
	src/vm/jit/trace.c, src/vm/jit/trace.h,
	src/vm/jit/verify/Makefile.am, src/vm/jit/verify/generate.pl,
	src/vm/jit/verify/icmds.c, src/vm/jit/verify/typecheck-builtins.inc,
	src/vm/jit/verify/typecheck-common.c, src/vm/jit/verify/typecheck-
	common.h, src/vm/jit/verify/typecheck-fields.inc, src/vm/jit/verify
	/typecheck-invoke.inc, src/vm/jit/verify/typecheck-
	multianewarray.inc, src/vm/jit/verify/typecheck-stackbased.c,
	src/vm/jit/verify/typecheck-typeinferer.c, src/vm/jit/verify
	/typecheck-typeinferer.h, src/vm/jit/verify/typecheck.c,
	src/vm/jit/verify/typecheck.h, src/vm/jit/verify/typeinfo.c,
	src/vm/jit/verify/typeinfo.h, src/vm/jit/x86_64/Makefile.am,
	src/vm/jit/x86_64/arch.h, src/vm/jit/x86_64/asmpart.S,
	src/vm/jit/x86_64/codegen.c, src/vm/jit/x86_64/codegen.h,
	src/vm/jit/x86_64/disass.c, src/vm/jit/x86_64/emit.c,
	src/vm/jit/x86_64/emit.h, src/vm/jit/x86_64/freebsd/Makefile.am,
	src/vm/jit/x86_64/freebsd/md-os.c,
	src/vm/jit/x86_64/linux/Makefile.am, src/vm/jit/x86_64/linux/md-
	os.c, src/vm/jit/x86_64/md-abi.c, src/vm/jit/x86_64/md-abi.h,
	src/vm/jit/x86_64/md-asm.h, src/vm/jit/x86_64/md.c,
	src/vm/jit/x86_64/patcher.c, src/vm/jit_interface.h,
	src/vm/primitive.c, src/vm/primitive.h, src/vm/properties.c,
	src/vm/properties.h, src/vm/resolve.c, src/vm/resolve.h,
	src/vm/signal.c, src/vm/signallocal.h, src/vm/string.c,
	src/vm/stringlocal.h, src/vm/types.h, src/vm/vm.c, src/vm/vm.h,
	src/vmcore/Makefile.am, src/vmcore/annotation.c, src/vmcore/class.c,
	src/vmcore/class.h, src/vmcore/classcache.c,
	src/vmcore/classcache.h, src/vmcore/descriptor.c,
	src/vmcore/descriptor.h, src/vmcore/field.c, src/vmcore/field.h,
	src/vmcore/linker.c, src/vmcore/linker.h, src/vmcore/loader.c,
	src/vmcore/loader.h, src/vmcore/method.c, src/vmcore/method.h,
	src/vmcore/options.c, src/vmcore/options.h,
	src/vmcore/primitivecore.c, src/vmcore/references.h, src/vmcore/rt-
	timing.c, src/vmcore/rt-timing.h, src/vmcore/stackmap.c,
	src/vmcore/stackmap.h, src/vmcore/statistics.c,
	src/vmcore/statistics.h, src/vmcore/suck.c, src/vmcore/suck.h,
	src/vmcore/utf8.c, src/vmcore/utf8.h, src/vmcore/zip.c,
	src/vmcore/zip.h, tests/Makefile.am, tests/regression/Makefile.am,
	tests/regression/MinimalClassReflection.java,
	tests/regression/TestAnnotations.java,
	tests/regression/codepatching/Makefile.am,
	tests/regression/fptest.java, tests/regression/jasmin/Makefile.am,
	tests/regression/jasmin/runtest, tests/regression/jasmin/show,
	tests/regression/jctest.java, tests/regression/native/Makefile.am,
	tests/regression/native/checkjni.c,
	tests/regression/native/checkjni.java,
	tests/regression/native/test.c, tests/regression/native/test.java,
	tests/regression/native/testarguments.c,
	tests/regression/native/testarguments.java,
	tests/regression/native/testgetobjectclass0.c,
	tests/regression/native/testgetobjectclass0.java,
	tests/regression/resolving/Makefile.am,
	tests/regression/resolving/classes1/Makefile.am,
	tests/regression/resolving/classes2/Makefile.am,
	tests/regression/resolving/classes3/Makefile.am:
	* Removed all Id tags.
	[777633d18b4c]

	* src/vm/vm.c:
	* src/vm/vm.c (vm_printconfig): Better and correct output.
	[660822b1af20]

	* .hgignore:
	* Added *~.
	[c8678806a55c]

2007-08-25  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* .hgignore:
	* .hgignore: New file.
	[42382aa1e7b5]

2007-08-22  twisti  <twisti>

	* src/vm/vm.c, src/vmcore/suck.c:
	* src/vm/vm.c (vm_create) [ENABLE_JAVASE]: Removed #ifdef for
	setting sun.boot.class.path and java.boot.class.path.
	* src/vmcore/suck.c (suck_add_from_property): Likewise.
	[69da96539daa]

	* src/vm/properties.c, src/vm/vm.c, src/vmcore/suck.c:
	* src/vm/vm.c (vm_create): Free properties after they have been
	replaced.
	* src/vmcore/suck.c (suck_add_from_property): Likewise.

	* src/vm/properties.c (properties_set): Smaller changes.
	[c92f5716cba2]

	* src/threads/native/threads.c, src/vm/properties.c:
	* src/vm/properties.c (properties_set): Fixed build for CLDC-1.1,
	removed getenv of JAVA_HOME.

	* src/threads/native/threads.c (threads_detach_thread): Fixed build
	for CLDC-1.1.
	[b8e9f732a292]

	* src/native/vm/nativevm.c, src/vm/properties.c, src/vm/vm.c:
	* src/vm/vm.c [WITH_JRE_LAYOUT] (libgen.h, unistd.h): Removed.

	* src/vm/properties.c (errno.h): Added. [WITH_JRE_LAYOUT]
	(libgen.h): Likewise. (properties_set) [WITH_CLASSPATH_SUN]: Set
	sun.boot.library.path property.

	* src/native/vm/nativevm.c (vm/properties.h): Added.
	(nativevm_preinit) [WITH_CLASSPATH_SUN]: Use properties_get to get
	sun.boot.library.path.
	[a764c454c91c]

2007-08-22  pm  <pm>

	* src/vm/jit/s390/codegen.c, src/vm/jit/s390/codegen.h,
	src/vm/jit/s390/emit.c:
	* src/vm/jit/s390/codegen.h: Cleanup.
	* src/vm/jit/s390/codegen.c (codegen_emit): Tryed to improove ACONST.
	* src/vm/jit/s390/emit.c (emit_copy): Use MVC (memcpy instruction) for
	memory to memory copy.
	[870ff292761c]

2007-08-22  twisti  <twisti>

	* src/vm/properties.c, src/vm/properties.h, src/vm/vm.c, src/vm/vm.h,
	src/vmcore/suck.c:
	* src/vm/properties.c (list_properties_entry): Renamed to
	list_properties_entry_t. (properties_init): Only initialize the
	list. (properties_set): New function to set default properties
	(don't use JAVA_HOME to set java.home).

	* src/vm/properties.h (vm/types.h): Removed. (stdint.h): Added.
	(properties_init): Changed signature. (properties_set): New
	function.

	* src/vm/vm.c (cacao_prefix): Removed. (cacao_libjvm): Likewise.
	(classpath_libdir): Likewise. (_Jv_bootclasspath): Likewise.
	(_Jv_classpath): Likewise. (_Jv_java_library_path): Likewise.
	(specificmethodname): Likewise. (specificsignature): Likewise.
	(startit): Likewise. (vm_printconfig): Use properties_get to get
	properties. (vm_create): Moved properties stuff into properties_set.

	* src/vm/vm.h (cacao_prefix): Removed. (cacao_libjvm): Likewise.
	(classpath_libdir): Likewise. (_Jv_bootclasspath): Likewise.
	(_Jv_classpath): Likewise. (_Jv_java_library_path): Likewise.

	* src/vmcore/suck.c (suck_add_from_property): Use properties_get to
	manipulate bootclasspath.
	[b0bc14174f72]

	* m4/classpath.m4:
	* m4/classpath.m4 (AC_CHECK_WITH_CLASSPATH_CLASSES): Fixed typo.
	[232c19c34670]

	* src/vm/vm.c:
	* src/vm/vm.c (native/include/java_lang_Byte.h,
	native/include/java_lang_Character.h,
	native/include/java_lang_Short.h,
	native/include/java_lang_Integer.h,
	native/include/java_lang_Boolean.h, native/include/java_lang_Long.h,
	native/include/java_lang_Float.h,
	native/include/java_lang_Double.h): Removed.
	[aab3d93b5630]

	* configure.ac:
	* configure.ac (AC_CHECK_HEADERS): Added libgen.h. (AC_CHECK_FUNCS):
	Added dirname, readlink.
	[0cbbe3bcc3cd]

2007-08-22  panzi  <panzi>

	* src/native/vm/java_lang_Class.c, src/native/vm/sun/jvm.c,
	src/vmcore/class.c, src/vmcore/class.h:
	* src/vmcore/class.h (class_get_annotations): Added. This function
	encapsulates the access to the annotations field of the classinfo
	struct. It is defined even if ENABLE_ANNOTATIONS is not, but just
	returns NULL in that case.

	* src/vmcore/class.c (class_get_annotations): Added.

	* src/native/vm/java_lang_Class.c
	(_Jv_java_lang_Class_getDeclaredAnnotations): Now uses
	class_get_annotations().

	* src/native/vm/sun/jvm.c (JVM_GetClassAnnotations): Now uses
	class_get_annotations().
	[ae07ae0272eb]

	* m4/annotations.m4:
	* m4/annotations.m4: Fixed comment.
	[38e9d135d38d]

	* src/lib/gnu/java/lang/reflect/Constructor.java,
	src/lib/gnu/java/lang/reflect/Field.java,
	src/lib/gnu/java/lang/reflect/Method.java,
	src/lib/gnu/sun/reflect/annotation/AnnotationParser.java,
	src/native/vm/gnu/java_lang_reflect_Constructor.c,
	src/native/vm/gnu/java_lang_reflect_Field.c,
	src/native/vm/gnu/java_lang_reflect_Method.c,
	src/native/vm/gnu/sun_reflect_ConstantPool.c,
	src/native/vm/reflect.c, src/native/vm/sun/jvm.c,
	src/vmcore/annotation.h, src/vmcore/class.h:
	* src/lib/gnu/java/lang/reflect/Method.java (declaredAnnotations):
	Added generic type parameters to Class.

	* src/lib/gnu/java/lang/reflect/Field.java (declaredAnnotations):
	Added generic type parameters to Class.

	* src/lib/gnu/java/lang/reflect/Constructor.java
	(declaredAnnotations): Added generic type parameters to Class.

	* src/lib/gnu/sun/reflect/annotation/AnnotationParser.java: Fixed
	formatting.
	* src/native/vm/gnu/sun_reflect_ConstantPool.c
	(Java_sun_reflect_ConstantPool_getMemberRefInfoAt0): Fixed
	formatting of log output.

	* src/native/vm/gnu/java_lang_reflect_Method.c
	(Java_java_lang_reflect_Method_getDefaultValue),
	(Java_java_lang_reflect_Method_declaredAnnotations),
	(Java_java_lang_reflect_Method_getParameterAnnotations): Use
	LLNI_class_get macro.

	* src/native/vm/gnu/java_lang_reflect_Field.c
	(Java_java_lang_reflect_Method_declaredAnnotations): Use
	LLNI_class_get macro.

	* src/native/vm/gnu/java_lang_reflect_Constructor.c
	(Java_java_lang_reflect_Method_declaredAnnotations),
	(Java_java_lang_reflect_Method_getParameterAnnotations): Use
	LLNI_class_get macro.

	* src/native/vm/sun/jvm.c (JVM_GetClassConstantPool): Fixed
	formatting of log output.

	* src/native/vm/reflect.c (reflect_get_declaredannotatios): Fixed
	comment.

	* src/vmcore/class.h (classinfo): Added comments for annottation
	fields.

	* src/vmcore/annotation.h (annotation_t), (element_value_t): Removed
	unused structs.
	[81a831b87f1b]

2007-08-21  michi  <michi>

	* src/mm/cacao-gc/gc.c:
	* src/mm/cacao-gc/gc.c (gc_init) [ENABLE_HANDLES]: Added offset
	check for global reference entries.
	[759632de7c01]

	* src/native/jni.c, src/native/localref.c, src/native/localref.h:
	* src/native/jni.c (_Jv_JNI_DeleteLocalRef): Moved code to
	localref_del.

	* src/native/localref.c (localref_add): Minor code cleanup.
	(localref_del): Moved from jni.c and adapted to work with handles.

	* src/native/localref.h (localref_del): Minor signature change.
	[356dbd0bd1d9]

	* src/native/jni.c:
	* src/native/jni.c: Used LLNI_classinfo_wrap to return classes.
	(_Jv_JNI_IsSameObject): Fixed implementation for handles.
	(_Jv_JNI_NewLocalRef): Likewise. (_Jv_JNI_SetObjectArrayElement):
	Use builtin_canstore correctly. (_Jv_JNI_NewGlobalRef): Correct
	implementation for handles. (_Jv_JNI_DeleteGlobalRef): Likewise.
	[5efc6830b6ab]

2007-08-21  twisti  <twisti>

	* src/vm/properties.c:
	* src/vm/properties.c (properties_init): Moved setting java.home
	into WITH_CLASSPATH_GNU, otherwise it's done twice for
	WITH_CLASSPATH_SUN.
	[46d825b9cb5f]

2007-08-21  michi  <michi>

	* src/native/jni.c, src/vm/access.c:
	* src/native/jni.c: Fixed LLNI macro usage.
	[1293d58652ab]

2007-08-21  twisti  <twisti>

	* src/native/jni.c, src/native/vm/java_lang_ClassLoader.c,
	src/native/vm/sun/jvm.c, src/native/vm/sun_misc_Unsafe.c,
	src/vmcore/class.c, src/vmcore/class.h:
	* src/vmcore/class.c (class_define): Added protection domain to
	signature. (class_resolve_superclass): Some changes (not yet
	correct). (class_issubclass): Added assert to see if super is
	resolved.

	* src/vmcore/class.h (classinfo) [ENABLE_JAVASE &&
	WITH_CLASSPATH_SUN]: Added protectiondomain.

	* src/native/jni.c (_Jv_JNI_DefineClass): Pass protection domain to
	class_define.
	* src/native/vm/java_lang_ClassLoader.c (defineClass): Likewise.

	* src/native/vm/sun_misc_Unsafe.c (unistd.h): Added. (vm/builtin.h):
	Likewise. (putShort__Ljava_lang_Object_2JS): Implemented.
	(putFloat__Ljava_lang_Object_2JF): Likewise (putInt__JI): Likewise
	(pageSize): Likewise (allocateInstance): Likewise (getLongVolatile):
	Likewise (defineClass__Ljava_lang_String_2_3BIILjava_lang_ClassLoade
	r_2Ljava_security_ProtectionDomain_2): Pass protection domain to
	class_define.

	* src/native/vm/sun/jvm.c (threads/threads-common.h): Added.
	(vm/signallocal.h): Likewise. (PRINTJVMWARNINGS): New macro (not
	enabled yet). (JVM_MaxMemory): Implemented. (JVM_EnableCompiler):
	Likewise. (JVM_DisableCompiler): Likewise. (JVM_ResolveClass):
	Likewise. (JVM_GetClassSignature): Likewise. (JVM_Yield): Likewise.
	(JVM_GetThreadStateValues): Likewise. (JVM_GetThreadStateNames):
	Likewise. (JVM_RegisterSignal): Likewise. (JVM_FindSignal):
	Likewise. (JVM_DefineClassWithSource): Pass protection domain to
	class_define. (JVM_DesiredAssertionStatus): Return false for now.
	(JVM_Available): Only ioctl is a correct implementation.
	[2f9138ad6203]

	* src/vm/access.c:
	* src/vm/access.c (access_is_accessible_class) [WITH_CLASSPATH_SUN]:
	Check for referer, not cls. (access_is_accessible_member)
	[WITH_CLASSPATH_SUN]: Check for referer, not declarer.
	[ea54fff4a82a]

	* src/native/vm/java_lang_Object.c:
	* src/native/vm/java_lang_Object.c (wait): Check for ms < 0.
	[e1591b347c35]

2007-08-21  panzi  <panzi>

	* src/native/vm/sun/jvm.c:
	* src/native/vm/sun/jvm.c (JVM_GetArrayLength): Now using function
	array_length_get(). (JVM_GetArrayElement): Now using function
	array_element_get(). (JVM_SetArrayElement): Implemented by using
	function array_element_set().
	[debb26635ceb]

2007-08-21  twisti  <twisti>

	* src/vm/array.c, src/vm/array.h:
	* src/vm/array.c (vm/exceptions.h): Added. (vm/primitive.h):
	Likewise. (array_element_get): New function. (array_element_set):
	Likewise. (array_element_primitive_get): Cast to specific array-
	type. (array_element_primitive_set): New function.
	(ARRAY_TYPEARRAY_ELEMENT_GET): Added NPE and AIOOBE checks.
	(ARRAY_TYPEARRAY_ELEMENT_SET): New macro. (array_length_get): New
	function.

	* src/vm/array.h (array_element_get): New function.
	(array_element_set): Likewise. (array_booleanarray_element_get,
	array_bytearray_element_get, array_chararray_element_get,
	array_shortarray_element_get, array_intarray_element_get,
	array_longarray_element_get, array_floatarray_element_get,
	array_doublearray_element_get, array_objectarray_element_get):
	Changed signature. (array_booleanarray_element_set,
	array_bytearray_element_set, array_chararray_element_set,
	array_shortarray_element_set, array_intarray_element_set,
	array_longarray_element_set, array_floatarray_element_set,
	array_doublearray_element_set, array_objectarray_element_set): New
	function. (array_length_get): Likewise.
	[49c86ae5ddb0]

	* src/vm/properties.c:
	* src/vm/properties.c (properties_init) [WITH_CLASSPATH_SUN]:
	Removed debug output.
	[e229dd128d49]

	* configure.ac, src/native/vm/gnu/java_lang_reflect_Constructor.c,
	src/vm/properties.c:
	* configure.ac (AC_CHECK_FUNCS): Added access.
	* src/vm/properties.c (unistd.h): Added. (properties_init)
	[WITH_CLASSPATH_SUN]: Find correct java.home.
	[927d02909913]

2007-08-21  michi  <michi>

	* src/native/vm/gnu/java_lang_reflect_Constructor.c,
	src/native/vm/java_lang_Thread.c, src/vm/primitive.c,
	src/vm/properties.c:
	* src/vm/properties.c (properties_system_add): Use LLNI macros.
	(properties_system_add_all): Likewise.

	* src/vm/primitive.c (primitive_unbox): Likewise.

	* src/native/vm/gnu/java_lang_reflect_Constructor.c: Fixed
	assertion.

	* src/native/vm/java_lang_Thread.c: Fixed LLNI macro usage.
	[11f7b49dda5d]

2007-08-21  panzi  <panzi>

	* THIRDPARTY:
	* THIRDPARTY (src/lib/gnu/sun/reflect/ConstantPool.java),
	(src/lib/gnu/sun/reflect/annotation/AnnotationParser.java),
	(src/lib/gnu/sun/reflect/annotation/AnnotationType.java), (src/lib/g
	nu/sun/reflect/annotation/AnnotationTypeMismatchExceptionProxy.java)
	, (src/lib/gnu/sun/reflect/annotation/TypeNotPresentExceptionProxy.j
	ava): These files are licensed by sun under the GPLv2.
	[8073f3ac70ea]

2007-08-21  twisti  <twisti>

	* src/native/vm/nativevm.c:
	* src/native/vm/nativevm.c [WITH_CLASSPATH_SUN] (string.h): Added.
	[WITH_CLASSPATH_SUN] (mm/memory.h): Likewise. (nativevm_preinit)
	[WITH_CLASSPATH_SUN]: Use classpath_libdir variable instead of
	CLASSPATH_LIBDIR. This is correct for WITH_JRE_LAYOUT.
	[44950c9ac1f3]

2007-08-21  michi  <michi>

	* m4/classpath.m4, src/cacaoh/headers.c:
	* src/cacaoh/headers.c (HEAP_PREFIX): Added define. (printtype):
	Added arguments prefix and infix. (printfields): Pass correct prefix
	for reference types. (printmethod): Pass correct infix for array
	types. (headerfile_generate): Print correct prefix for heap object.
	(headerfile_generate) [ENABLE_HANDLES]: Also create struct typedef
	for handle.
	[1cde84324121]

2007-08-21  twisti  <twisti>

	* m4/classpath.m4:
	* m4/classpath.m4 (AC_CHECK_WITH_CLASSPATH_LIBDIR): Set
	CLASSPATH_LIBDIR correctly for OpenJDK.
	[f59871a923da]

	* configure.ac, m4/staticvm.m4:
	* configure.ac (AC_CHECK_ENABLE_STATICVM): Added.
	* m4/staticvm.m4: New file.
	[575b17df5444]

2007-08-21  michi  <michi>

	* src/cacaoh/dummy.c, src/mm/cacao-gc/gc.c, src/mm/cacao-gc/gc.h,
	src/mm/cacao-gc/rootset.c, src/mm/cacao-gc/rootset.h, src/mm/gc-
	common.h, src/native/jni.c, src/threads/native/threads.c,
	src/threads/threads-common.c, src/vmcore/loader.c:
	* src/mm/cacao-gc/gc.h (list_gcref_entry_t): Renamed type to
	reftype. [!ENABLE_HANDLES]: Added development break.

	* src/mm/cacao-gc/gc.c (gc_reference_register): Added reftype to
	arguments.

	* src/mm/gc-common.h: Added reftype defines.
	* src/mm/cacao-gc/rootset.h: Removed reftype defines.

	* src/mm/cacao-gc/rootset.c: Adapted to changes.

	* src/vmcore/loader.c (loader_hashtable_classloader_add): Pass
	reftype to GC.
	* src/native/jni.c (_Jv_JNI_NewGlobalRef): Likewise.
	* src/threads/native/threads.c (threads_init): Likewise.
	* src/threads/threads-common.c (threads_thread_new): Likewise.
	(threads_thread_print_info) [WITH_CLASSPATH_GNU]: Fixed thread name
	printing.

	* src/cacaoh/dummy.c (gc_reference_register): Adapted dummy function
	to new sig.
	[3c38a2ccdc4f]

2007-08-20  twisti  <twisti>

	* m4/jre-layout.m4:
	* m4/jre-layout.m4: Set Id keyword.
	[187bc2030109]

	* configure.ac, m4/jre-layout.m4:
	* configure.ac (AC_CHECK_WITH_JRE_LAYOUT): Added.
	* m4/jre-layout.m4: New file.
	[29b158e22fc7]

2007-08-20  michi  <michi>

	* src/mm/boehm.c, src/vm/jit/replace.h:
	* src/mm/boehm.c (heap_alloc_uncollectable): Fixed typo.
	* src/vm/jit/replace.h [!ENABLE_REPLACEMENT]: Added missing defines.
	[95bd9c1f25ad]

2007-08-20  twisti  <twisti>

	* src/native/llni.h, src/vm/signal.c:
	* src/vm/signal.c (signal_thread): Removed debug output.
	(signal_thread_handler): Likewise.
	[1cb05b99b528]

2007-08-20  michi  <michi>

	* src/vmcore/loader.c:
	* src/vmcore/loader.c: Fixed typos, LLNI_direct is called
	LLNI_DIRECT.
	[0def6a684fde]

	* src/cacaoh/dummy.c, src/native/Makefile.am, src/native/llni.c,
	src/native/llni.h, src/vmcore/utf8.c, src/vmcore/utf8.h:
	* src/native/Makefile.am: Added llni.c.

	* src/native/llni.c: Added new file. (llni_critical_start,
	llni_critical_end): Implemented.

	* src/native/llni.h: Major cleanup of LLNI macros
	(LLNI_CRITICAL_START, LLNI_CRITICAL_END): Added.

	* src/cacaoh/dummy.c (llni_critical_start, llni_critical_end): Added
	dummies.
	[af75957ea4fa]

2007-08-20  twisti  <twisti>

	* src/vmcore/utf8.c, src/vmcore/utf8.h:
	* src/vmcore/utf8.c (utf_uncaughtException): Added.
	(utf_java_lang_Thread_java_lang_Throwable__V): Likewise.
	(utf8_init): Initialize new variables.
	* src/vmcore/utf8.h: Likewise.
	[3ab11f4e0235]

	* src/threads/native/threads.c:
	* src/threads/native/threads.c (threads_init) [WITH_CLASSPATH_SUN]:
	Added code to initialize the thread. (threads_startup_thread):
	Ignore the return value of threads_detach_thread.
	(threads_detach_thread) [ENABLE_JAVASE]: Implemented
	UncaughtExceptionHandler stuff.
	[65df7c9c179f]

2007-08-20  michi  <michi>

	* src/native/localref.c:
	* src/native/localref.c (localref_add): Disabled debug output.
	[97af6afc71f6]

	* src/native/jni.c, src/native/localref.c, src/native/localref.h:
	* src/native/localref.c (localref_add): Implemented (moved parts
	from jni.c). [!NDEBUG] (localref_dump): Improved debug output.

	* src/native/localref.h: Added prototypes.

	* src/native/jni.c (_Jv_JNI_NewLocalRef): Now uses localref_add.
	[e792a0c22d3d]

	* src/native/vm/gnu/java_lang_VMSystem.c,
	src/native/vm/java_lang_Class.c:
	* src/native/vm/java_lang_Class.c
	(_Jv_java_lang_Class_getClassLoader) [ENABLE_HANDLES]: Fixed
	implementation.

	* src/native/vm/gnu/java_lang_VMSystem.c
	(Java_java_lang_VMSystem_identityHashCode) [ENABLE_GC_CACAO]:
	Likewise.
	[3d0ca306dc19]

	* src/native/jni.c, src/native/localref.c, src/native/localref.h,
	src/vm/vm.c:
	* src/native/localref.c (localref_table_destroy): Added (moved from
	jni.c). Improved documentation.

	* src/native/localref.h: Likewise.

	* src/native/jni.c (jni_free_localref_table): Removed.

	* src/vm/vm.c (vm_createjvm): Added comment about localreftable.
	[329d0c1a2734]

	* src/vm/jit/x86_64/codegen.c:
	* src/vm/jit/x86_64/codegen.c (codegen_emit_stub_builtin): Fixed bug
	in stackframesize calculation.
	[d759d431071b]

	* src/cacaoh/dummy.c, src/mm/cacao-gc/heap.h,
	src/threads/native/threads.c, src/threads/threads-common.c,
	src/vm/builtin.c, src/vm/builtin.h, src/vm/signal.c:
	* src/vm/signal.c (signal_init): Use signal_register_signal to
	register SIGUSR1.

	* src/vm/builtin.c: Adapted to changes on trunk.
	* src/vm/builtin.h: Likewise.
	* src/mm/cacao-gc/heap.h: Likewise.
	* src/threads/threads-common.c: Likewise.
	* src/threads/native/threads.c: Likewise.
	* src/cacaoh/dummy.c: Likewise.
	[173e158ebcbc]

	* configure.ac, src/mm/cacao-gc/gc.c, src/vm/global.h,
	src/vmcore/loader.c:
	* configure.ac: Checks for --enable-handles and sets define
	accordingly.

	* src/vm/global.h (java_handle_t): Changed ifdef to use
	ENABLE_HANDLES.

	* src/vmcore/loader.c (load_class_from_classloader): Likewise

	* src/mm/cacao-gc/gc.c (gc_init) [ENABLE_HANDLES]: Ifdefed offset
	check of indirection cells.
	[78bdf2b86dea]

	* configure.ac, src/Makefile.am, src/lib/Makefile.am,
	src/native/include/Makefile.am,
	src/native/vm/gnu/java_lang_VMString.c,
	src/native/vm/java_lang_String.c, src/native/vm/java_lang_String.h,
	src/threads/threads-common.h, src/vm/builtin.c,
	src/vm/builtintable.inc, src/vm/jit/s390/asmpart.S,
	src/vm/jit/s390/emit.c, src/vm/jit/s390/md.c, src/vm/jit/trace.c,
	src/vm/jit/trace.h, src/vm/properties.c, src/vm/stringlocal.h,
	src/vmcore/zip.c:
	* src/vm/builtin.c (builtintable_init): Create builtin stubs for
	builtintable_function as well.

	* src/vm/builtintable.inc (builtintable_function): Create stubs for
	arraycopy.
	[2120e8901106]

2007-08-19  twisti  <twisti>

	* src/native/vm/Makefile.am, src/native/vm/cldc1.1/java_lang_String.c,
	src/native/vm/gnu/java_lang_VMString.c,
	src/native/vm/java_lang_Class.c, src/native/vm/java_lang_String.c,
	src/native/vm/java_lang_String.h, src/native/vm/reflect.c,
	src/native/vm/sun/jvm.c, src/vm/string.c, src/vm/stringlocal.h:
	* src/vm/string.c (javastring_intern): New function.
	(javastring_print): Likewise.
	* src/vm/stringlocal.h

	* src/native/vm/java_lang_String.c: Removed.
